var db = Ti.Database.install('data/club.db', 'club'); //Make sure we have some database installed
db.close();

Ti.include('common/laf.js');

//Initialize Properties
if (!Ti.App.Properties.hasProperty('VIPGuestsHidden')) {
    Ti.App.Properties.setString('Member', 'false');
    Ti.App.Properties.setString('ZipCode', '');
    Ti.App.Properties.setDouble('Latitude', 0);
    Ti.App.Properties.setDouble('Longitude', 0);
    Ti.App.Properties.setString('FavoriteClubs', '');
    Ti.App.Properties.setString('FavoriteClasses', '');
    Ti.App.Properties.setString('VIPGuests', '');
    Ti.App.Properties.setString('VIPGuestsHidden', '');
}

//See if we have a new version install, if so do some updating OR installing
if (!Ti.App.Properties.hasProperty('InstalledVersion') ||
Ti.App.Properties.getString('InstalledVersion') != laf.network.clientVersion) {
    Ti.include('common/utilUpdate.js');
    versionUpdateInstall(); //Will drop existing databases, unused properties
    Ti.App.Properties.setString('InstalledVersion', laf.network.clientVersion);
}

Ti.App.addEventListener('AppUpdate', function(){
    //App is fully loaded or resumed check for & update data if necessary	
    if (laf.network.isConnected(false)) {
        var updateCheckCutoff = new Date();
        updateCheckCutoff = updateCheckCutoff.setMinutes(updateCheckCutoff.getMinutes() - 60);
        
        //Don't check for updates more than once an hour
        if (!Ti.App.Properties.hasProperty('LastUpdateCheck') || 
			!Ti.App.Properties.hasProperty('LastUpdate') || 		
			updateCheckCutoff > new Date(Ti.App.Properties.getString('LastUpdateCheck'))) {
            Ti.App.Properties.setString('LastUpdateCheck', (new Date()).toString());
            
            //Create a window for a new execution context, effectively acting like a background thread.
            //It will close itself to free memory
            Ti.UI.createWindow({
                height: 0,
                width: 0,
                touchEnabled: false,
                opacity: 0,
                url: 'common/winUpdate.js'
            }).open();
        }
    }
});

if (laf.device.isiPhone()) {
    Ti.App.addEventListener('resumed', function(){
        //App resumed from background, check for update
        Ti.App.fireEvent('AppUpdate');
    });    
}

var winHome = Ti.UI.createWindow({
    title: 'Home',
    titleImage: 'images/lafSwoosh.png',
    fullscreen: false,
    url: 'views/home/default.js',
    exitOnClose: true
});

if (laf.device.isiPhone()) {
    winHome.hideTabBar();
    var tabGroup = Ti.UI.createTabGroup();
    tabGroup.addTab(Ti.UI.createTab({
        window: winHome
    }));
    tabGroup.open();
}
else {
    winHome.navBarHidden = true;
    winHome.open();
}
