//=== auth ===================================
(function(){
    laf.auth = {}; //auth namespace
    laf.auth.isAuthenticated = function(showErrorMessage){
        var authenticated = (Ti.App.Properties.hasProperty('MemberAccount') && Ti.App.Properties.getString('MemberAccount').length > 0);
        
        if (!authenticated && (showErrorMessage == undefined || showErrorMessage == true)) {
            Ti.UI.createAlertDialog({
                title: 'Login Required',
                message: 'You must login with a LAFitness.com account to use this feature. Go to the home screen and in the upper right click \'Login\' to enter your account information.',
                buttonNames: ['OK']
            }).show();
        }
        
        return authenticated;
    };
    
    laf.auth.logOut = function(){
		laf.network.clearAuth();
        Ti.App.Properties.removeProperty('Passcode');		
        Ti.App.Properties.removeProperty('MemberAccount');
        Ti.App.Properties.removeProperty('Member');
        Ti.App.Properties.removeProperty('MemberCheckins');
        Ti.App.Properties.removeProperty('AccountProfile');
        Ti.App.Properties.removeProperty('AccountSummary');
        Ti.App.Properties.removeProperty('DeviceToken');
        Ti.App.Properties.removeProperty('AmenitiesAppointments');
        Ti.App.Properties.removeProperty('TrainingAppointments');
        Ti.App.Properties.removeProperty('TrainingSummary');
        Ti.App.Properties.removeProperty('Stats');
        Ti.App.Properties.removeProperty('StatsHistory');
        Ti.App.Properties.removeProperty('ActivityHistory');
        Ti.App.Properties.removeProperty('ActivePlan');
        Ti.App.Properties.removeProperty('ActiveRoutines');
        Ti.App.Properties.removeProperty('ExerciseLog');
        Ti.App.Properties.removeProperty('isMember');
        Ti.App.Properties.setString('VIPGuests', '');
        Ti.App.Properties.setString('VIPGuestsHidden', '');
        Ti.App.fireEvent('authenticationChange');
    };
})();
