//=== device ===================================
(function(){
	var osName = (Ti.Platform.osname != undefined && Ti.Platform.osname.length > 0) ? Ti.Platform.osname : Ti.Platform.name;
	var platformModel = Ti.Platform.model;
	var platformName = Ti.Platform.name;
	
    laf.device = {}; //device namespace
    
    laf.device.height = Ti.Platform.displayCaps.platformHeight;
    
    laf.device.isAndroid = function(){
		return platformName == 'android';
    };
    
    laf.device.isiOS4Plus = function(){
        if (platformName == 'iPhone OS') {
            var version = Ti.Platform.version.split(".");
            var major = parseInt(version[0], 10);
            if (major >= 4) {
                return true;
            }
        }
        return false;
    };
    
    laf.device.isiPhone = function(){
		return platformName == 'iPhone OS';
    };
    
    laf.device.isSimulator = function(){
        return (platformModel == 'google_sdk' || platformModel == 'Simulator');
    };
    
    laf.device.macAddress = Ti.Platform.displayCaps.macaddress;
    
    laf.device.model = platformModel;
	
	//Branch based on operating system
	laf.device.os = function(/*Object*/ map) {
		var def = map.def||null; //default function or value
		if (typeof map[osName] != 'undefined') {
			if (typeof map[osName] == 'function') { return map[osName](); }
			else { return map[osName]; }
		}
		else {
			if (typeof def == 'function') { return def(); }
			else { return def; }
		}
	};	
    
    laf.device.osName = osName;
    
    laf.device.osVersion = Ti.Platform.version;
    
    laf.device.platform = platformName;
    
    laf.device.timeZoneOffset = (function(){
        var now = new Date();
        var timeZoneSign = (now.getTimezoneOffset() > 0) ? '-' : '+';
		return timeZoneSign + (now.getTimezoneOffset() / 60);
    })();
    
    laf.device.width = Ti.Platform.displayCaps.platformWidth;
})();

