//=== validation ===================================
(function () {
    var regExEmail = /^[\-a-z0-9~!$%\^&*_=+}{\'?]+(\.[\-a-z0-9~!$%\^&*_=+}{\'?]+)*@([a-z0-9_][\-a-z0-9_]*(\.[\-a-z0-9_]+)*\.(aero|asia|biz|cat|com|coop|edu|gov|info|int|jobs|mil|mobi|museum|name|net|org|pro|tel|travel|[a-z][a-z])|([0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}))(:[0-9]{1,5})?$/i;
	var regExInteger = /^[\-+]?\d+$/;
	var regExIntegerPositive = /^\d+$/;
	var regExNumeric = /^[\-+]?(?:\d+\.?\d*|\d*\.?\d+)$/;
	var regExNumericPositive = /^(?:\d+\.?\d*|\d*\.?\d+)$/;
	var regExPhone = /^1?[\- ]?\(?(\d{3})\)?[\- ]?(\d{3})[\- ]?(\d{4})$/;
	var regExPostalCode = /^[A-Z]\d[A-Z][\- |]?\d[A-Z]\d$/i;
	var regExProvince = /^(AB|BC|MB|NB|NL|NS|NT|NU|ON|PE|QC|SK|YT)$/i;
	var regExState = /^(AA|AE|AP|AL|AK|AS|AZ|AR|CA|CO|CT|DE|DC|FM|FL|GA|GU|HI|ID|IL|IN|IA|KS|KY|LA|ME|MH|MD|MA|MI|MN|MS|MO|MT|NE|NV|NH|NJ|NM|NY|NC|ND|MP|OH|OK|OR|PW|PA|PR|RI|SC|SD|TN|TX|UT|VT|VI|VA|WA|WV|WI|WY)$/i;
	var regExZipCode = /^\d{5}$|^\d{5}-\d{4}$/;		
		
	laf.verify = {}; //verify namespace
	
	laf.verify.isEmail = function (strEmail) {
		return regExEmail.test(strEmail);
	};
	
	laf.verify.isInteger = function (strNumber, allowNegatives) {
		return (allowNegatives == undefined || allowNegatives == false) ? regExIntegerPositive.test(strNumber) : regExInteger.test(strNumber);
	};
	
	laf.verify.isNumeric = function (strNumber, allowNegatives) {
		return (allowNegatives == undefined || allowNegatives == false) ? regExNumericPositive.test(strNumber) : regExNumeric.test(strNumber);
	};
	
	laf.verify.isPhone = function (strPhone) {
		return regExPhone.test(strPhone);
	};
	
	laf.verify.isPostalCode = function (strPostalCode) {
    	return regExPostalCode.test(strPostalCode);		
	};
	
	laf.verify.isProvince = function (strProvince) {
		return regExProvince.test(strProvince);
	};
	
	laf.verify.isState = function (strState) {
		return regExState.test(strState);
	};
	
	laf.verify.trim = function (strToTrim) {
		return (strToTrim == undefined) ? '' : ('' + strToTrim).replace(/^\s+|\s+$/g,''); //Use '' to avoid type errors	
	};	
	
	laf.verify.isZipCode = function (strZIP) {
    	return regExZipCode.test(strZIP);		
	};
	
	laf.verify.isEmpty = function (strToTest) {
		return (strToTest == undefined || strToTest == null || 
			(typeof(strToTest) == 'string' && (strToTest.length == 0 || laf.verify.trim(strToTest).length == 0 || strToTest == 'null')) ||
			(typeof(strToTest) == 'object' && (strToTest.value == undefined || strToTest.value.length == 0 || laf.verify.trim(strToTest.value).length == 0)));
	};
	
	laf.verify.padZip = function(strZIP) {
		if (strZIP == undefined) {
			return '';
		} else {
			return('00000'.substr(0, (5 - strZIP.length)) + strZIP); 			
		}
	};
})();
