//=== Graph ===================================
function graph(selectedTabIndex, tabNames, changeFunction){
    this.tabNames = tabNames;
    this.currTabIndex = (selectedTabIndex != undefined) ? selectedTabIndex : 0;
    this.graphWebView = Ti.UI.createWebView({
        top: 0,
        bottom: 0
    });
    
    if (Ti.Platform.name == 'iPhone OS') {
        var tbTimeFrame = Ti.UI.createTabbedBar({
            labels: tabNames,
            backgroundColor: '#336699',
            bottom: 10,
            index: this.currTabIndex,
            style: Ti.UI.iPhone.SystemButtonStyle.BAR,
            height: 25,
            width: 400
        });
        
        tbTimeFrame.addEventListener('click', function(e){
            if (this.currTabIndex != e.index) {
                tbTimeFrame.enabled = false;
                this.currTabIndex = e.index;
                tbTimeFrame.index = this.currTabIndex;
                if (changeFunction != undefined) {
                    changeFunction(this.currTabIndex);
                }
                tbTimeFrame.enabled = true;
            }
        });
        
        this.graphWebView.add(tbTimeFrame);
    }
    else {
        var tabs = [];
        var tabWidth = laf.window.percentToPixels(100 / tabNames.length) + ((Ti.Gesture.orientation == Ti.UI.PORTRAIT || Ti.Gesture.orientation == Ti.UI.UPSIDE_PORTRAIT) ? 25 : 0);
        var vwTabBar = Ti.UI.createView({
            left: 1,
            right: 1,
            height: 30,
            bottom: 5,
            borderRadius: 10,
            backgroundColor: 'transparent'            
        });
        
        for (var tabItr = 0, tabItrLen = tabNames.length; tabItr < tabItrLen; tabItr++) {
        
            var currTab = Ti.UI.createLabel({
                tabIndex: tabItr,
                text: tabNames[tabItr],
                textAlign: 'center',
                backgroundColor: (tabItr == this.currTabIndex) ? '#000F4B' : '#1F3D79',
                top: 220,
                bottom: 0,				
                borderColor: '#000F4B',
                borderWidth: 1,
				height: 30,
                width: tabWidth,
                font: {
                    fontWeight: 'bold',
                    fontSize: 14
                },
                color: 'white',
                left: ((Ti.Gesture.orientation == Ti.UI.PORTRAIT || Ti.Gesture.orientation == Ti.UI.UPSIDE_PORTRAIT) ? 50 : 0) + (tabWidth * tabItr),
                focusable: true
            });
            
            //Return called function to avoid JSLint warning & keep tabIndex
            currTab.addEventListener('click', function(){
                return function(e){
                    this.currTabIndex = e.source.tabIndex;
                    for (ftrTabItr = 0, ftrTabLen = tabs.length; ftrTabItr < ftrTabLen; ftrTabItr++) {
                        tabs[ftrTabItr].backgroundColor = (ftrTabItr == e.source.tabIndex) ? '#000F4B' : '#1F3D79';
                    }
                    if (changeFunction != undefined) {
                        changeFunction(this.currTabIndex);
                    }
                };
            }());
            
            tabs.push(currTab);
            vwTabBar.add(currTab);
        }
        this.graphWebView.add(vwTabBar);
    }
    
    vwMain.add(this.graphWebView);
};

graph.prototype.setHtml = function(htmlContent){
    this.graphWebView.html = htmlContent;
};
