//Temporary file for use by Android until Titanium fixes http://jira.appcelerator.org/browse/TIMOB-3158

//=== network ===================================
//(function(){
//Base64 Encoding of Username:Password@url in wrong in appcelerator for complicated ones like 
//User%25 which should encode User%2525 is staying User%25 so use our own instead
var END_OF_INPUT = -1;
var base64Chars = ['A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', '+', '/'];
var base64Str;
var base64Count;

function readBase64(){
    if (!base64Str) {
        return END_OF_INPUT;
    }
    if (base64Count >= base64Str.length) {
        return END_OF_INPUT;
    }
    var c = base64Str.charCodeAt(base64Count) & 0xff;
    base64Count++;
    return c;
}

function encodeBase64(str){
    base64Str = str;
    base64Count = 0;
    var result = '';
    var inBuffer = new Array(3);
    var lineCount = 0;
    var done = false;
    while (!done && (inBuffer[0] = readBase64()) != END_OF_INPUT) {
        inBuffer[1] = readBase64();
        inBuffer[2] = readBase64();
        result += (base64Chars[inBuffer[0] >> 2]);
        if (inBuffer[1] != END_OF_INPUT) {
            result += (base64Chars[((inBuffer[0] << 4) & 0x30) | (inBuffer[1] >> 4)]);
            if (inBuffer[2] != END_OF_INPUT) {
                result += (base64Chars[((inBuffer[1] << 2) & 0x3c) | (inBuffer[2] >> 6)]);
                result += (base64Chars[inBuffer[2] & 0x3F]);
            }
            else {
                result += (base64Chars[((inBuffer[1] << 2) & 0x3c)]);
                result += ('=');
                done = true;
            }
        }
        else {
            result += (base64Chars[((inBuffer[0] << 4) & 0x30)]);
            result += ('=');
            result += ('=');
            done = true;
        }
        lineCount += 4;
        if (lineCount >= 76) {
            result += ('\n');
            lineCount = 0;
        }
    }
    return result;
}

function makeBasicAuth(user, password){
    user = Ti.Network.encodeURIComponent(user);
    password = Ti.Network.encodeURIComponent(password);
    return "Basic " + encodeBase64(user + ':' + password);
}

var authentication = '';

var regExInvalidCredentials = /^Error Domain=ASIHTTPRequestErrorDomain Code=3 "Authentication needed" UserInfo=/;
var regExInvalidURL = /^Error Domain=ASIHTTPRequestErrorDomain Code=5 "Unable to create request (bad url?)" UserInfo=/;

//laf.network = {}; //network namespace
//laf.network.clientVersion = Ti.App.laf.network.clientVersion; //keep as float for version compare
//laf.network.protocol = Ti.App.laf.network.protocol;
//laf.network.server = Ti.App.laf.network.server;

var androidPost = function(postObject, serviceEndpoint, callbackOK, callbackFail){
    var xhr = Ti.Network.createHTTPClient({
        validatesSecureCertificate: false, //Mobile has limited certs, thus intermediate cert errors
        timeout: 120000
    });
    
    xhr.onload = function(){
        //Ti.API.info(this.responseText)           
        if (callbackOK != undefined) {
            var responseData = '';
            if (this.responseText != undefined) {
                try {
                    responseData = JSON.parse(this.responseText);
                } 
                catch (er) {
                    responseData = this.responseText;
                }
            }
            callbackOK(responseData);
        }
    };
    
    xhr.onerror = function(e){
        var errorMsg = (e == undefined || e == null || e.error == undefined || e.error == null || e.error == 'null') ? '' : e.error;
        Ti.API.info(errorMsg);
        
        if (callbackFail != undefined) {
            callbackFail(errorMsg);
        }
        
        //Check if the error was due to a bad username/password, if so logoff user
        if (Ti.App.Properties.hasProperty('MemberAccount')) {
            if (errorMsg == 'Unauthorized' || regExInvalidCredentials.test(errorMsg) || regExInvalidURL.test(errorMsg)) {
                authentication = '';
                laf.auth.logOut();
                Ti.UI.createAlertDialog({
                    title: 'Invalid Username/Password',
                    message: 'The username or password you provided is no longer valid and you have been logged off.\n\nPlease login again.',
                    buttonNames: ['OK']
                }).show();
                
                setTimeout(function(){
                    laf.window.goHome();
                }, 2000);
            }
        }
    };
    
    if (Ti.Network.online) {
        var jsonObject = {};
        
        //Encode Object With Client Information
        if (postObject != undefined && postObject != '') {
            jsonObject.Value = postObject;
        }
        
        jsonObject.Client = {
            Version: laf.network.clientVersion,
            Platform: laf.device.platform,
            Model: laf.device.model,
            OSName: laf.device.osName,
            OSVersion: laf.device.osVersion,
            MacAddress: laf.device.macAddress,
            TimezoneOffset: laf.device.timeZoneOffset
        };
        
        jsonObject = '{"request":' + JSON.stringify(jsonObject) + '}';
        
        //Ti.API.info(jsonObject);
        Ti.API.info(laf.network.protocol + laf.network.server + '/Services/' + serviceEndpoint);
        xhr.open('POST', laf.network.protocol + laf.network.server + '/Services/' + serviceEndpoint);
        
        xhr.setRequestHeader('Content-Type', 'application/json; charset=utf-8');
        if (Ti.App.Properties.hasProperty('MemberAccount')) {
            if (authentication.length == 0) {
                var memberaccount = JSON.parse(Ti.App.Properties.getString('MemberAccount'));
                authentication = makeBasicAuth(memberaccount.Username, memberaccount.Password);
            }
            xhr.setRequestHeader('Authorization', authentication);
        }
        xhr.send(jsonObject);
    }
    else {
        if (callbackFail != undefined) {
            callbackFail('You are not currently connected to the internet.');
        }
    }
};
//})();
