var versionUpdateInstall = function() {
	
	//Update Clubs Database, Remove LastUpdate propery	
	var db = Ti.Database.open('club');
	db.close();
	db.remove();
	db = Ti.Database.install('data/club.db', 'club'); //Install updated Database
	db.close();
	Ti.App.Properties.removeProperty('LastUpdate');	
	Ti.App.Properties.removeProperty('LastUpdateCheck');	
	
	//Update Postal Database	
	db = Ti.Database.open('postal');
	db.close();
	db.remove();
	db = Ti.Database.install('data/postal.db', 'postal');
	db.close();
	
	//Removed 1.3 - Continuous location tracking
	if (Ti.App.Properties.getString('ZipCode') == 'Current') {
	    Ti.App.Properties.setString('ZipCode', '');
	}
	
	//Removed 1.3 - Old default zipcode was causing some people to be confused 
	if (Ti.App.Properties.getString('ZipCode') == '92612') {
		//Check if location is exactly old default lat/lon
    	var currLat = parseFloat(Ti.App.Properties.getString('Latitude'));
    	var currLon = parseFloat(Ti.App.Properties.getString('Longitude'));
		if (currLat != undefined && currLon != undefined && currLat == 33.648309 && currLon == -117.821853) {
			Ti.App.Properties.setString('ZipCode', '');
		    Ti.App.Properties.setDouble('Latitude', 0);
			Ti.App.Properties.setDouble('Longitude', 0);				
		}
	}		
	
	//1.4 - Identified an issue with having spaces on the start/end of username/passwords
	if (laf.object.isSaved('MemberAccount')) {
        var memberaccount = laf.object.load('MemberAccount');
		memberaccount.Username = laf.verify.trim(memberaccount.Username);
		memberaccount.Password = laf.verify.trim(memberaccount.Password);
		laf.object.save('MemberAccount', memberaccount);		
	}	
	
	Ti.App.Properties.removeProperty('windows'); //Removed 1.3 - Old window load method, no longer in use
	Ti.App.Properties.removeProperty('InstalledDBSize'); //Removed 1.3 - Update based on version, not database
	Ti.App.Properties.removeProperty('InstalledZipDBSize'); //Removed 1.3 - Update based on version, not database
	Ti.App.Properties.removeProperty('Distance'); //Removed 2.0 - Distance no longer used in search parameters
	Ti.App.Properties.removeProperty('IsMemberCount'); //Removed 2.0 - No longer used for three seperate membership conditions
	Ti.App.Properties.removeProperty('isMember'); //Removed 2.0 - No longer have member but not logged in condition
};
