(function(){
    //=== HEADER & DATA =============================
    Ti.include('../../common/winHeader.js');
    
    var buttonsEnabled = true;
    var feedbackTopic = '';
    var feedbackType = 'Comments';
	
    //=== OBJECTS ===================================
    vwMain.add(Ti.UI.createView({
        backgroundImage: laf.path.images + 'background2.png',
        left: 0,
        right: 0,
        top: 0,
        bottom: 0,
        opacity: 0.85
    }));
    
    var tvContactUs = Ti.UI.createTableView({
        backgroundColor: 'transparent',
        rowBackgroundColor: 'transparent',
        separatorColor: 'transparent'
    });
    
    var tfComments = Ti.UI.createTextArea({
        color: 'black',
        font: {
            fontSize: 16,
            fontFamily: 'Arial'
        },
        left: 5,
        right: 5,
        top: 35,
        height: 120,
        borderWidth: 2,
        borderColor: '#bbb',
        borderRadius: 5,
        autocapitalization: Ti.UI.TEXT_AUTOCAPITALIZATION_SENTENCES,
        returnKeyType: Ti.UI.RETURNKEY_DONE,
        autocorrect: false
    });
    
    var lblCharCount = Ti.UI.createLabel({
        color: 'black',
        font: {
            fontSize: 16,
            fontFamily: 'Arial'
        },
        top: 5,
        right: 5,
		height: 20,
        width: 100,
        textAlign: 'right',
        text: '0 / 700'
    });
    
    var btnRightNav = Ti.UI.createButton({
        title: 'Continue',
        style: Ti.UI.iPhone.SystemButtonStyle.DONE
    });
    
    var btnCancel = Ti.UI.createButton({
        title: 'Cancel'
    });
    
    function createButton(align, title, image){
        var btnView = Ti.UI.createView({
            height: 100,
            width: 90,
            bottom: 20,
            borderRadius: 10,
            name: title
        });
        if (align == 0) {
            btnView.left = 30;
        }
        if (align == 2) {
            btnView.right = 30;
        }
        btnView.add(Ti.UI.createView({
            backgroundImage: laf.path.images + image,
            height: 48,
            left: 20,
            width: 48,
            top: 5,
            borderRadius: 10
        }));
        btnView.add(Ti.UI.createLabel({
            color: 'white',
            font: {
                fontWeight: 'bold'
            },
            height: 40,
            left: 0,
            width: 90,
            top: 60,
            text: title,
            textAlign: 'center'
        }));
        btnView.addEventListener('click', function(e){
            buttonClick(btnView);
        });
        return btnView;
    }
    
    function newEditRow(lblText, control){
        var tvRow = Ti.UI.createTableViewRow({
            height: 45,
            backgroundSelectedColor: 'white'
        });
        laf.table.ignoreRowSelection(tvRow);
        
        tvRow.add(Ti.UI.createLabel({
            color: 'black',
            font: {
                fontSize: 18,
                fontFamily: 'Arial'
            },
            left: 5,
            height: 25,
            width: 110,
            textAlign: 'left',
            fontWeight: 'bold',
            text: lblText
        }));
        
        tvRow.add(control);
        return tvRow;
    }
    
    function newTextField(hintText, keyboard, autocapitalization){
        return Ti.UI.createTextField({
            color: '#336699',
            height: 40,
            left: 90,
            right: 10,
            hintText: hintText,
            autocorrect: false,
            borderStyle: Ti.UI.INPUT_BORDERSTYLE_ROUNDED,
            clearButtonMode: Ti.UI.INPUT_BUTTONMODE_ONFOCUS,
            keyboardType: keyboard,
            autocapitalization: autocapitalization,
            returnKeyType: Ti.UI.RETURNKEY_NEXT,
            suppressReturn: false
        });
    }
    
    var tfName = newTextField('Full Name', Ti.UI.KEYBOARD_DEFAULT, Ti.UI.TEXT_AUTOCAPITALIZATION_WORDS);
    var tfEmail = newTextField('E-mail Address', Ti.UI.KEYBOARD_EMAIL, Ti.UI.TEXT_AUTOCAPITALIZATION_NONE);
    var tfBarcode = newTextField('Membership Key Tag', Ti.UI.KEYBOARD_DEFAULT, Ti.UI.TEXT_AUTOCAPITALIZATION_SENTENCES);
    
    //=== FUNCTIONS =================================
    function buttonClick(sourceButton){
        if (buttonsEnabled) { //Prevent multiple clicks
            buttonsEnabled = false;
            sourceButton.backgroundColor = '#576996';
            
            setTimeout(function(){
                setLeftNav(btnCancel);
                
                switch (sourceButton.name) {
                    case 'My\nAccount':
                        if (laf.auth.isAuthenticated(true)) {
                            setAccountRows();
                        }
                        break;
                    case 'A Club or\nEmployee':
                        if (laf.network.isConnected()) {
                            feedbackTopic = 'Club';
                            setClubRows();
                        }
                        break;
                    case 'LA Fitness\nMobile':
                        if (laf.network.isConnected()) {
                            feedbackTopic = 'Mobile';
                            setContactRows();
                        }
                        break;
                }
                sourceButton.backgroundColor = 'transparent';
                buttonsEnabled = true;
            }, 600);
        }
    }
    
    function sendFeedback(){
        if (laf.verify.isEmpty(tfComments)) {
            laf.window.alert('Required', 'Please enter your ' + ((feedbackType.length > 0) ? feedbackType.toLowerCase() + '.' : 'comments.'));
            tfComments.focus();
            return;
        }
        
        var callbackFail = function(error){
            laf.window.alert('ERROR', 'There was an error submitting your feedback. Please try again.');
        };
        
        var callbackOK = function(response){
            if (response.Success) {
                setSuccessRows();
            }
            else {
                laf.window.alert('ERROR', 'There was an error submitting your feedback. Please try again.');
            }
        };
        
        var feedback = {
            Name: tfName.value,
            Email: tfEmail.value,
            BarcodeID: tfBarcode.value,
            Comments: tfComments.value,
            Topic: feedbackTopic,
			Type: feedbackType
        };
        
        post(feedback, 'Public.svc/SubmitFeedback', callbackOK, callbackFail);
    }
    
    function setTopicRows(){
        var data = [];
        data.push(laf.table.section('Contact Us'));
        
        var tvrContactUsTopic = Ti.UI.createTableViewRow({
            height: 110
        });
        laf.table.ignoreRowSelection(tvrContactUsTopic);
        
        tvrContactUsTopic.add(Ti.UI.createLabel({
            color: 'white',
            font: {
                fontSize: 22,
                fontFamily: 'Arial',
                fontWeight: 'bold'
            },
            top: 5,
            left: 10,
            right: 10,
            height: 75,
            text: 'What topic would you like to contact us about?'
        }));
        data.push(tvrContactUsTopic);
        
        tvRow = Ti.UI.createTableViewRow({
            height: 120
        });
        laf.table.ignoreRowSelection(tvRow);
        
        tvRow.add(createButton(0, 'My\nAccount', 'keytag.png'));
        //tvRow.add(createButton(1, 'A Club or\nEmployee', 'club@2x.png'));
        tvRow.add(createButton(2, 'LA Fitness\nMobile', 'mobileIcon48.png'));
        data.push(tvRow);
        
        tvContactUs.setData(data);
    }
    
    function setAccountRows(){
        var phone;
        if (laf.object.isSaved('Member')) {
            phone = laf.data.clubScalar('SELECT PHONE FROM Club WHERE CLUB_ID = \'' + laf.object.load('Member').ClubID + '\'');
        }
        if (phone == undefined || phone.length < 7) {
            phone = '949-255-7200';
        }
        
        var data = [];
        data.push(laf.table.section('Feedback'));
        
        var tvrMemberService = Ti.UI.createTableViewRow({
            height: 210,
            className: 'aboutFeedbackMemberServices'
        });
        laf.table.ignoreRowSelection(tvrMemberService);
        
        tvrMemberService.add(Ti.UI.createLabel({
            color: 'white',
            font: {
                fontSize: 30,
                fontFamily: 'Arial',
                fontWeight: 'bold'
            },
            top: 5,
            left: 10,
            right: 10,
            height: 70,
            text: 'Member Services',
            textAlign: 'center'
        }));
        
        tvrMemberService.add(Ti.UI.createLabel({
            color: 'white',
            font: {
                fontSize: 18,
                fontFamily: 'Arial',
                fontWeight: 'bold'
            },
            top: 70,
            left: 10,
            right: 10,
            height: 70,
            text: 'Monday - Thursday\nFriday\nSaturday - Sunday'
        }));
        tvrMemberService.add(Ti.UI.createLabel({
            color: 'white',
            font: {
                fontSize: 18,
                fontFamily: 'Arial',
                fontWeight: 'light'
            },
            top: 70,
            left: 10,
            right: 10,
            height: 70,
            textAlign: 'right',
            text: '10 AM - 7 PM\n8 AM - 5 PM\nClosed'
        }));
        
        var btnCall = Titanium.UI.createButton({
            title: '  ' + phone,
            color: 'black',
            font: {
                fontSize: 25,
                fontFamily: 'Helvetica'
            },
            top: 160,
            width: 230,
            height: 60,
            image: laf.path.images + 'phone.png',
            backgroundImage: laf.path.images + 'BUTT_gry_off.png',
            backgroundSelectedImage: laf.path.images + 'BUTT_gry_on.png'
        });
        btnCall.addEventListener('click', function(){
            laf.network.openURL('tel:1-' + phone, 'LA FITNESS\nMember Services');
        });
        tvrMemberService.add(btnCall);
        
        data.push(tvrMemberService);
        tvContactUs.setData(data);
    }
    
    function setClubRows(){        
        var data = [];
        data.push(laf.table.section('Contact Us'));
		
        var tvrContactUsTopic = Ti.UI.createTableViewRow({
            height: 240
        });
        laf.table.ignoreRowSelection(tvrContactUsTopic);
        
        tvrContactUsTopic.add(Ti.UI.createLabel({
            color: 'white',
            font: {
                fontSize: 24,
                fontFamily: 'Arial',
                fontWeight: 'bold'
            },
            top: 5,
            left: 10,
            right: 10,
            height: 75,
            text: 'What type of feedback do you have?'
        }));
        
        var btnComments = Ti.UI.createButton({
            height: 55,
            color: 'black',
            left: 5,
            top: 90,
            width: 150,
            backgroundImage: laf.path.images + 'BUTT_gry_off.png',
            backgroundSelectedImage: laf.path.images + 'BUTT_gry_on.png',
            title: 'Comments'
        });
		btnComments.addEventListener('click', function(){
			feedbackType = 'Comments';
			setContactRows();
		});
        tvrContactUsTopic.add(btnComments);
		
        var btnQuestion = Ti.UI.createButton({
            height: 55,
            color: 'black',
            right: 5,
            top: 90,
            width: 150,			
            backgroundImage: laf.path.images + 'BUTT_gry_off.png',
            backgroundSelectedImage: laf.path.images + 'BUTT_gry_on.png',
            title: 'Question'
        });	
		btnQuestion.addEventListener('click', function(){
			feedbackType = 'Question';
			setContactRows();
		});		
        tvrContactUsTopic.add(btnQuestion);		
			
        data.push(tvrContactUsTopic);
        
        tvContactUs.setData(data);
    }
    
    function setContactRows(){
        setRightNav(btnRightNav);
        tvContactUs.backgroundColor = 'white';
        tfName.value = tfEmail.value = tfBarcode.value = '';
        
        //Get default values
        if (laf.auth.isAuthenticated(false)) {
            var member = laf.object.load('Member');
            tfName.value = member.FirstName + ' ' + member.LastName;
            tfEmail.value = laf.verify.isEmail(member.Email) ? member.Email : '';
            tfBarcode.value = member.BarcodeID;
        }
        else {
            if (laf.object.isSaved('AccountSummary')) {
                tfBarcode.value = laf.object.load('AccountSummary').BarcodeID;
            }
        }
        
        var data = [];
        data.push(laf.table.section('Contact Us'));
        data.push(laf.table.infoRow('In order to better process your feedback, please provide the following information.\n'));
        data.push(newEditRow('Name:', tfName));
        data.push(newEditRow('Email:', tfEmail));
        data.push(newEditRow('Key Tag:', tfBarcode));
        if (!laf.auth.isAuthenticated(false) && !laf.object.isSaved('AccountSummary')) {
            data.push(laf.table.infoRow('If you are not a member,\nleave the key tag field blank.', 'center'));
        }
        
        tvContactUs.setData(data);
    }
    
    function setFeedbackRows(){
        if (laf.verify.isEmpty(tfName)) {
            laf.window.alert('Required', 'Please enter your full name.');
            tfName.focus();
            return;
        }
        if (laf.verify.isEmpty(tfEmail) || !laf.verify.isEmail(tfEmail.value)) {
            laf.window.alert(laf.verify.isEmpty(tfEmail) ? 'Required' : 'Invalid', 'Please enter a valid E-mail Address.');
            tfEmail.focus();
            return;
        }
        
        var data = [];
        data.push(laf.table.section((feedbackType.length > 0) ? feedbackType: 'Comments'));
        
        var tvrFeedback = Ti.UI.createTableViewRow({
            height: 250
        });
        laf.table.ignoreRowSelection(tvrFeedback);		
        tvrFeedback.add(Ti.UI.createLabel({
            color: 'black',
            font: {
                fontSize: 16,
                fontFamily: 'Arial'
            },
            top: 5,
            left: 10,
            width: 200,
			height: 20,
            textAlign: 'left',
            text: 'Type your feedback below:'
        }));
        tvrFeedback.add(lblCharCount);
        tvrFeedback.add(tfComments);
        data.push(tvrFeedback);
        
        laf.table.hideEmptyRows(tvContactUs, true);
        tvContactUs.setData(data);
        
        btnRightNav.title = 'Send';
        
        setTimeout(function(){
            tfComments.focus();
        }, 300);
    }
    
    function setSuccessRows(){
        setLeftNav(Ti.UI.createView({
            width: 0,
            height: 0
        }));
        btnRightNav.title = 'Done';
        
        var data = [];
        data.push(laf.table.section('Feedback'));
        
        var tvrSuccessHeader = Ti.UI.createTableViewRow({
            height: 75,
            className: 'aboutFeedbackSuccessHeader'
        });
        laf.table.ignoreRowSelection(tvrSuccessHeader);
        
        tvrSuccessHeader.add(Ti.UI.createView({
            backgroundImage: laf.path.images + 'edit.png',
            height: 48,
            width: 48,
            top: 15,
            right: 10
        }));
        
        tvrSuccessHeader.add(Ti.UI.createLabel({
            color: 'black',
            font: {
                fontSize: 24,
                fontFamily: 'Arial',
                fontWeight: 'light'
            },
            top: 15,
            left: 10,
            right: 68,
            height: 50,
            text: 'Feedback Received'
        }));
        data.push(tvrSuccessHeader);
        
        data.push(laf.table.infoRow('We appreciate that you have taken the time to write to us with your experiences and opinions. In return, we assure you that we will read your comments, give them careful consideration, and when appropriate, act upon them. Thank you!'));
        
        tvContactUs.setData(data);
    }
    
    //=== EVENTS ====================================
    btnCancel.addEventListener('click', function(e){
        win.close();
    });
    
    btnRightNav.addEventListener('click', function(e){
        if (btnRightNav.title == 'Continue') {
            setFeedbackRows();
            return;
        }
        if (btnRightNav.title == 'Send') {
            sendFeedback();
            return;
        }
        
        win.close();
    });
    
    tfName.addEventListener('return', function(){
        tfEmail.focus();
    });
    
    tfEmail.addEventListener('return', function(){
        tfBarcode.focus();
    });
    
    tfBarcode.addEventListener('return', function(){
        setFeedbackRows();
    });
    
    tfComments.addEventListener('return', function(){
        sendFeedback();
    });
    
    tfComments.addEventListener('change', function(){
        if (tfComments.value.length >= 700) {
            tfComments.value = tfComments.value.toString().substring(0, 700);
        }
        lblCharCount.text = tfComments.value.length + ' / 700';
    });
    
    //=== DISPLAY ===================================
    setTopicRows();
    vwMain.add(tvContactUs);
})();
