(function(){
    //=== HEADER & DATA =============================
    Ti.include('../../common/winHeader.js');
    var buttonsEnabled = true;
    
    //=== OBJECTS ============================= 
    vwMain.add(Ti.UI.createView({
        backgroundImage: laf.path.images + 'background2.png',
        left: 0,
        right: 0,
        top: 0,
        bottom: 0,
        opacity: 0.85
    }));
    
    var tvBody = Ti.UI.createTableView({
        backgroundColor: 'transparent',
        rowBackgroundColor: 'transparent',
        separatorColor: 'transparent'
    });
    
    function createButton(align, title, image){
        var btnView = Ti.UI.createView({
            height: 100,
            width: 90,
            bottom: 20,
            borderRadius: 10,
            name: title
        });
        if (align == 0) {
            btnView.left = 5;
        }
        if (align == 2) {
            btnView.right = 5;
        }
        btnView.add(Ti.UI.createView({
            backgroundImage: laf.path.images + image,
            height: 48,
            left: 20,
            width: 48,
            top: 5,
            borderRadius: 10
        }));
        btnView.add(Ti.UI.createLabel({
            color: '#D9D9D9',
            font: {
                fontWeight: 'bold'
            },            
            height: 40,
            left: 0,
            width: 90,
            top: 60,
            text: title,
            textAlign: 'center'
        }));
        btnView.addEventListener('click', function(e){
            buttonClick(btnView);
        });
        return btnView;
    }
    
    //=== FUNCTIONS =============================
    function buttonClick(sourceButton){
        if (buttonsEnabled) { //Prevent multiple clicks
            buttonsEnabled = false;
            sourceButton.backgroundColor = '#576996';// '#C5CCD4';
            
            setTimeout(function(){
                switch (sourceButton.name) {
                    case 'Share\nthis App':
                        var strShare = '';
                        strShare += 'I\'ve been using LA Fitness Mobile and I think you might like it.<br /><br />';
                        if (laf.device.isiPhone()) {
                            strShare += 'Find out more about LA Fitness Mobile:<br />';
                            strShare += '<a href=\'http://itunes.apple.com/us/app/la-fitness-mobile/id376098999?mt=8&uo=4\'>';
                            strShare += 'http://itunes.apple.com/us/app/la-fitness-mobile/id376098999?mt=8&uo=4</a>';
                        }
                        else {
                            strShare += 'Find out more about LA Fitness Mobile from your Android device:<br />';
                            strShare += '<a href=\'market://search?q=pname:com.lafitness.lafitness\'>';
                            strShare += 'market://search?q=pname:com.lafitness.lafitness</a>';
                        }
                        
                        var edShare = Ti.UI.createEmailDialog();
                        edShare.html = true;
                        edShare.setSubject('Check out LA Fitness Mobile');
                        edShare.setMessageBody(strShare);
                        edShare.open();
                        break;
                    case 'Contact\nUs':
						laf.window.create('Contact Us', 'views/about/contactUs.js');
				        laf.window.open();
                        break;
                    case 'Leave a\nReview':
                        if (laf.network.isConnected(true)) {
                            if (laf.device.isiPhone()) {
                                //Titanium unable to open itms-apps urls? Redirect to webpage which will redirect
                                laf.network.openURL(laf.network.protocol + laf.network.server + '/Redirects/Rating_Ios.html');
                            	//laf.network.openURL('itms-apps://ax.itunes.apple.com/WebObjects/MZStore.woa/wa/viewContentsUserReviews?type=Purple+Software&id=376098999');		
                            }
                            else {
                                laf.network.openURL('market://search?q=pname:com.lafitness.lafitness');
                            }
                        }
                        break;
                }
                sourceButton.backgroundColor = 'transparent';
                buttonsEnabled = true;
            }, 600);
        }
    }
    
    function setData(){
        var data = [];
        
        var tvRow = Ti.UI.createTableViewRow({
            height: 250,
            className: 'iconAndText'
        });
        laf.table.ignoreRowSelection(tvRow);
        
        tvRow.add(Ti.UI.createView({
            backgroundImage: laf.path.images + 'mobileIcon512.png',
            height: 175,
            width: 175,
            top: 10
        }));
        
        tvRow.add(Ti.UI.createLabel({
            color: 'white',
            font: {
                fontSize: 24,
                fontWeight: 'bold'
            },
            height: (laf.device.isiPhone()) ? 20 : 30,
            width: 250,
            top: 180,
            text: 'LA Fitness Mobile',
            textAlign: 'center'
        }));
        
        tvRow.add(Ti.UI.createLabel({
            color: 'white',
            font: {
                fontSize: 16,
                fontWeight: 'light'
            },
            height: 17,
            width: 200,
            top: (laf.device.isiPhone()) ? 200 : 206,
            text: 'Version ' + laf.network.clientVersion,
            textAlign: 'center'
        }));
        
        if (laf.network.server.toLowerCase() == 'apitest.lafitness.com') {
            tvRow.add(Ti.UI.createLabel({
                color: 'yellow',
                font: {
                    fontSize: 18,
                    fontWeight: 'bold'
                },
                height: 20,
                width: 300,
                top: 225,
                text: '** DEVELOPMENT VERSION **',
                textAlign: 'center'
            }));
        }
        data.push(tvRow);
        
        tvRow = Ti.UI.createTableViewRow({
            height: 120,
            className: 'buttonsAndText'
        });
        laf.table.ignoreRowSelection(tvRow);
        
        tvRow.add(createButton(0, 'Share\nthis App', 'chat.png'));
        tvRow.add(createButton(1, 'Contact\nUs', 'edit.png'));
        tvRow.add(createButton(2, 'Leave a\nReview', 'star.png'));
        data.push(tvRow);
        
        tvBody.setData(data);
    }
    //=== EVENTS =============================
    
    //=== DISPLAY =============================
    setData();
    vwMain.add(tvBody);
})();
