//=== HEADER & DATA =============================
Ti.include('../../common/winHeader.js');

var lastRefresh = new Date();

//=== OBJECTS =============================
var vwPublicSite, vwTwitter, vwFacebook;
var vwActivity = new activityIndicator();

var btnBack = Ti.UI.createButton({
    title: 'Back',
    enabled: false
});

//=== FUNCTIONS =============================
function getWebView(url){
    var loading = false;
    
    var vwWeb = Ti.UI.createWebView({
        left: 0,
        right: 0,
        top: 0,
        bottom: 0,
        scalesPageToFit: true,
        url: url
    });
    
    vwWeb.addEventListener('beforeload', function(e){
        if (!loading) {
            loading = true;
            vwActivity.show('Loading...');
            setTimeout(function(){
                if (loading) {
                    loading = false;					
                    vwActivity.hide();
                }
            }, 8500);
        }
    });
    
    vwWeb.addEventListener('load', function(e){
        lastRefresh = new Date();
        btnBack.enabled = vwWeb.canGoBack();
        if (loading) {
            loading = false;			
            vwActivity.hide();
        }
    });
    
    return vwWeb;
}

function tabChange(tabIndex){
    laf.window.removeChildren(vwMain);
    
    switch (tabIndex) {
        case 0:
            if (vwTwitter == undefined) {
                vwTwitter = getWebView('http://mobile.twitter.com/LAFitness');
            }
            vwMain.add(vwTwitter);
            btnBack.enabled = vwTwitter.canGoBack();
            break;
        case 1:
            if (vwFacebook == undefined) {
                vwFacebook = getWebView('http://m.facebook.com/lafitness');
            }
            vwMain.add(vwFacebook);
            btnBack.enabled = vwFacebook.canGoBack();
            break;
        case 2:
            if (vwPublicSite == undefined) {
                if (laf.auth.isAuthenticated(false)) {
                    vwPublicSite = getWebView('http://www.lafitness.com/Pages/Default.aspx');
                }
                else {
                    vwPublicSite = getWebView('http://www.lafitness.com/Pages/NonMemberHome.aspx');
                }
            }
            vwMain.add(vwPublicSite);
            btnBack.enabled = vwPublicSite.canGoBack();
            break;
    }
}

//=== EVENTS =============================
btnBack.addEventListener('click', function(e){
    switch (currTabIndex) {
        case 0:
            if (vwTwitter != undefined && vwTwitter.canGoBack()) {
                vwTwitter.goBack();
            }
            break;
        case 1:
            if (vwFacebook != undefined && vwFacebook.canGoBack()) {
                vwFacebook.goBack();
            }
            break;
        case 2:
            if (vwPublicSite != undefined && vwPublicSite.canGoBack()) {
                vwPublicSite.goBack();
            }
            break;
    }
});

laf.window.listen('resume', function(e){
    var refreshCutoff = new Date();
    refreshCutoff = refreshCutoff.setMinutes(refreshCutoff.getMinutes() - 10);
    
    switch (currTabIndex) {
        case 0:
            if (lastRefresh < refreshCutoff) {
                vwTwitter.reload();
            }
            vwPublicSite = undefined;
            vwFacebook = undefined;
            break;
        case 1:
            if (lastRefresh < refreshCutoff) {
                vwFacebook.reload();
            }
            vwPublicSite = undefined;
            vwTwitter = undefined;
            break;
        case 2:
            if (lastRefresh < refreshCutoff) {
                vwPublicSite.reload();
            }
            vwTwitter = undefined;
            vwFacebook = undefined;
            break;
    }
});

//=== DISPLAY =============================
laf.window.footerTabs(['Twitter', 'Facebook', 'LAFitness.com'], tabChange, 0);
setRightNav(btnBack);
