(function(){
    //=== HEADER & DATA =============================
    Ti.include('../../common/winHeader.js');
    var oneDay = 86400000; // 1000*60*60*24
    var months = ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'];
    var daysOfWeek = ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'];
    var today = new Date();
    today = new Date(today.getFullYear(), today.getMonth(), today.getDate());
    
    var startDay = (winData.startDay == undefined) ? 0 : winData.startDay;
    var endDay = (winData.endDay == undefined) ? 13 : winData.endDay;
    var selectedDateStr = (winData.selectedDateStr == undefined) ? '' : winData.selectedDateStr;
    var selectedRowID = -1;
    
    //=== OBJECTS =============================	
    var tvDays = Ti.UI.createTableView({
        top: 0,
        backgroundColor: 'white',
        rowBackgroundColor: 'transparent',
        separatorColor: '#e1e1e1'
    });
    
    var btnCancel = Ti.UI.createButton({
        title: 'Cancel'
    });
    
    function newDayRow(date){
        var dateStr = laf.dateTime.toString(date, 'unspecified');
        
        var tvrDay = Ti.UI.createTableViewRow({
            height: 50,
            className: 'dayPickerDay',
            dateStr: dateStr,
            hasCheck: (dateStr == selectedDateStr)
        });
        
        tvrDay.add(Ti.UI.createLabel({
            font: {
                fontSize: 16,
                fontWeight: 'bold',
                fontFamily: 'Arial'
            },
            color: 'black',
            top: 5,
            left: 5,
            right: 5,
            height: 20,
            textAlign: 'left',
            text: friendlyDateString(date)
        }));
        
        tvrDay.add(Ti.UI.createLabel({
            color: '#7F7F7F',
            font: {
                fontSize: 14,
                fontFamily: 'Arial'
            },
            top: 25,
            left: 5,
            right: 5,
            height: 20,
            textAlign: 'left',
            text: fullDateString(date)
        }));
        
        laf.table.makeRowSelectable(tvrDay);
        return tvrDay;
    }
    
    //=== FUNCTIONS =============================
    function fullDateString(inputDate){
        return months[inputDate.getMonth()] + ' ' + inputDate.getDate() + ', ' + inputDate.getFullYear();
    }
    
    function friendlyDateString(inputDate){
        var days = (inputDate.getTime() - today.getTime()) / oneDay;
        
        if (days == 0) {
            return 'Today';
        }
        if (days == 1) {
            return 'Tomorrow';
        }
        if (days > 1 && days < 7) {
            return daysOfWeek[inputDate.getDay()];
        }
        if (days > 6 && days < 14) {
            return 'Next ' + daysOfWeek[inputDate.getDay()];
        }
        return fullDateString(inputDate);
    }
    
    function setDateRows(){
        var workDate = new Date(today.getTime());
        workDate.setDate(workDate.getDate() + startDay);
        var data = [];
        
        for (dateItr = startDay; dateItr <= endDay; dateItr++) {
            data.push(newDayRow(workDate));
            workDate.setDate(workDate.getDate() + 1);
        }
        
        tvDays.setData(data);
        laf.table.scrollToTop(tvDays, false);
    };
    
    //=== EVENTS =============================	
    tvDays.addEventListener('click', function(e){
        if (e.rowData != undefined && e.rowData.dateStr != undefined) {
            tvDays.touchEnabled = false;
            
            if (laf.device.isiPhone()) {
                for (var i = 0; i < tvDays.data[0].rows.length; i++) {
                    tvDays.data[0].rows[i].hasCheck = (e.index == i);
                }
            }
            
            laf.window.fire('daySelected', {
                dateStr: e.rowData.dateStr
            });
            
            setTimeout(function(){
                win.close();
            }, (laf.device.isiPhone()) ? 700 : 0);
        }
    });
    
    btnCancel.addEventListener('click', function(e){
        win.close();
    });
    
    //=== DISPLAY =============================
    setDateRows();
    vwMain.add(tvDays);
    setLeftNav(btnCancel);
})();

