//=== HEADER & DATA =============================
Ti.include('../../common/winHeader.js');

var windowClosed = false;
var videoURL = (winData.videoURL == undefined) ? 'http://mikeslife.com/video.m4v' : winData.videoURL;
var videoURLLow = (winData.videoURLLow == undefined) ? 'http://mikeslife.com/video.3gp' : winData.videoURLLow;
var allowPortrait = (winData.allowPortrait == undefined) ? false : winData.allowPortrait;

var urlToPlay = '';
if (videoURLLow == undefined || Ti.Network.networkType == Ti.Network.NETWORK_WIFI || Ti.Network.networkType == Ti.Network.NETWORK_LAN) {
    urlToPlay = videoURL;
}
else {
    urlToPlay = videoURLLow;
}

var origOrientation = Ti.Gesture.orientation;
if (!allowPortrait) {
	win.orientationModes = [Ti.UI.LANDSCAPE_LEFT, Ti.UI.LANDSCAPE_RIGHT];	
}


//=== OBJECTS =============================
var vpMainPlayer = Titanium.Media.createVideoPlayer({
    contentURL: urlToPlay,
    backgroundColor: '#111',
    movieControlMode: Titanium.Media.VIDEO_CONTROL_DEFAULT,
    scalingMode: Titanium.Media.VIDEO_SCALING_MODE_FILL
});

//=== FUNCTIONS =============================

//=== EVENTS =============================	
vpMainPlayer.addEventListener('complete', function(){
    win.close();
});

win.addEventListener('close', function(){
    if (!windowClosed) {
        windowClosed = true;
        vpMainPlayer.stop();
    }
	if (!allowPortrait && (origOrientation == Ti.UI.PORTRAIT || origOrientation == Ti.UI.UPSIDE_PORTRAIT)) {
        Ti.UI.orientation = origOrientation;		
	}
});

//=== DISPLAY =============================
if (parseFloat(Titanium.Platform.version) >= 3.2) {
    win.add(vpMainPlayer);
}

vpMainPlayer.play();
