//=== HEADER & DATA =============================
Ti.include('../../common/winHeader.js');

//=== OBJECTS =============================
var favoriteClubs, favoriteClasses;

var vwHolidayMayVary = Ti.UI.createView({
    top: 0,
    height: 29,
    backgroundColor: '#576996'
});
vwHolidayMayVary.add(Ti.UI.createLabel({
    color: 'white',
    font: {
        fontSize: 14,
        fontWeight: 'bold'
    },
    left: 2,
    right: 2,
    textAlign: 'center',
    text: 'Holiday hours and class offerings may vary.'
}));

//=== FUNCTIONS =============================
function tabChange(tabIndex){
    setRightNav(null);
    
    switch (tabIndex) {
        case 0:
            if (favoriteClasses != undefined) {
                favoriteClasses.hide();
            }
            
            if (favoriteClubs == undefined) {
                laf.window.include('favoriteClubs.js');
                favoriteClubs = new favoriteClubs();
                vwMain.add(favoriteClubs.view());
            }
            favoriteClubs.refresh();
            favoriteClubs.show();
            break;
        case 1:
            if (favoriteClubs != undefined) {
                favoriteClubs.hide();
            }
            
            if (favoriteClasses == undefined) {
                laf.window.include('favoriteClasses.js');
                favoriteClasses = new favoriteClasses();
                vwMain.add(favoriteClasses.view());
            }
            favoriteClasses.refresh();
            favoriteClasses.show();
            break;
    }
}

//=== EVENTS =============================
if (laf.device.isAndroid()) {
    //Focus event not firing on Android	
    Ti.Android.currentActivity.addEventListener('resume', function(){
        tabChange(currTabIndex);
    });
}
else {
    win.addEventListener('focus', function(){
        tabChange(currTabIndex);
    });
}

//=== DISPLAY =============================
vwMain.add(vwHolidayMayVary);
laf.window.footerTabs(['Clubs', 'Classes'], tabChange, 0);
