function favoriteClasses(){
    //=== HEADER & DATA =============================	    
    var classes = [];
    var prevFavClassString;
    var favClasses;
    
    //=== OBJECTS =============================
    var vwActivity = new activityIndicator();
    
    var tvClasses = Ti.UI.createTableView({
        top: 29,
        backgroundColor: 'white',
        rowBackgroundColor: 'transparent',
        separatorColor: '#e1e1e1',
        editable: true
    });
    
    var btnEdit = Ti.UI.createButton({
        title: 'Edit'
    });
    
    var btnDone = Ti.UI.createButton({
        title: 'Done',
        style: Ti.UI.iPhone.SystemButtonStyle.DONE
    });
    
    //=== FUNCTIONS =============================     
    function loadClasses(){
        classes = [];
        
        prevFavClassString = Ti.App.Properties.getString('FavoriteClasses');
        favClasses = prevFavClassString.split(',');
        if (favClasses.length != 0) {
            for (var classItr = 0, classLen = favClasses.length; classItr < classLen; classItr++) {
                var favClass = favClasses[classItr].split('|');
                if (favClass.length > 1) {
                    classes.push(laf.data.clubRow('SELECT Class.CLASSES_ID, Class.NAME, Class.DESCRIPTION, Club.CLUB_ID, Club.DESCRIPTION FROM Class, Club WHERE Class.CLASSES_ID = \'' + favClass[1] + '\' AND Club.CLUB_ID = \'' + favClass[0] + '\'', ['ClassID', 'Name', 'Description', 'ClubID', 'ClubDescription']));
                }
            }
            
            //Sort by order stored in array	
            classes.sort(function(a, b){
                return (favClasses.indexOf(a.ClubID + '|' + a.ClassID) - favClasses.indexOf(b.ClubID + '|' + b.ClassID));
            });
        }
    }
    
    function getHoursString(classID, clubID){
        var todaysDayID = ((new Date()).getDay() + 1);
        var strHours = '';
        
        var hours = laf.data.clubSet('SELECT DISTINCT strftime("%m/%d/%Y %H:%M:%S", t1.Time) AS START_TIME FROM ClassSchedule cs JOIN Time t1 on t1.TimeID=cs.START_TIME WHERE CLASSES_ID =\'' + classID + '\' AND CLUB_ID =\'' + clubID + '\' AND DAY_ID = \'' + todaysDayID + '\' ORDER BY START_TIME', ['Start']);
        if (hours == undefined || hours.length == undefined || hours.length == 0) {
            strHours = 'Class Not Offered';
        }
        else {
        
            for (var hoursItr = 0, hoursLen = hours.length; hoursItr < hoursLen; hoursItr++) {
                strHours += ', ' + laf.dateTime.toTimeString(hours[hoursItr].Start);
            }
            strHours = strHours.substring(1);
        }
        
        if (laf.device.isiPhone()) {
            return 'Today: ' + strHours + '\n\n';
        }
        else {
            return 'Today: ' + strHours + '\n';
        }
    }
    
    function newClassRow(classIndex){
        var tvrClass = Ti.UI.createTableViewRow({
            height: 'auto',
            className: laf.table.uniqueClass(),
            hasChild: true,
            classID: classes[classIndex].ClassID,
            clubID: classes[classIndex].ClubID
        });
        
        tvrClass.add(Ti.UI.createLabel({
            font: {
                fontSize: 16,
                fontWeight: 'bold',
                fontFamily: 'Arial'
            },
            color: 'black',
            top: 5,
            left: 5,
            right: laf.table.leftDataRightMargin,
            height: 20,
            textAlign: 'left',
            text: classes[classIndex].Name
        }));
        
        tvrClass.add(Ti.UI.createLabel({
            color: '#7F7F7F',
            font: {
                fontSize: 14,
                fontFamily: 'Arial'
            },
            top: 25,
            left: 15,
            right: 10,
            height: 'auto',
            textAlign: 'left',
            text: '@ ' + classes[classIndex].ClubDescription + '\n' + getHoursString(classes[classIndex].ClassID, classes[classIndex].ClubID)
        }));
        
        laf.table.makeRowSelectable(tvrClass);
        return tvrClass;
    }
    
    function setClassRows(){
        tvClasses.editing = false;
        tvClasses.moving = false;
        
        var data = [];
        
        data.push(laf.table.section('Favorite Classes'));
        
        if (classes == undefined || classes.length == undefined || classes.length == 0) {
            setRightNav(null);
            tvClasses.touchEnabled = false;
            laf.table.hideEmptyRows(tvClasses, false);			
            
            var tvrNoFavorites = Ti.UI.createTableViewRow({
                height: 105,
                editable: false,
                moveable: false,
                className: 'favoriteClubsNoFavorites'
            });
            tvrNoFavorites.add(Ti.UI.createLabel({
                color: '#7F7F7F',
                font: {
                    fontSize: 18,
                    fontFamily: 'Arial'
                },
                top: 25,
                left: 5,
                right: 5,
                height: 80,
                textAlign: 'center',
                text: 'Add your favorite classes from\nSearch on the home screen.'
            }));
            data.push(tvrNoFavorites);
        }
        else {
            if (laf.device.isiPhone()) {
                setRightNav(btnEdit);
            }
            
            tvClasses.touchEnabled = true;
            laf.table.showEmptyRows(tvClasses);			
            for (var classItr = 0, classLen = classes.length; classItr < classLen; classItr++) {
                data.push(newClassRow(classItr));
            }
        }
        
        tvClasses.setData(data);
    }
    
    //=== EVENTS =============================
    tvClasses.addEventListener('click', function(e){
        if (e.rowData != undefined && e.rowData.classID != undefined && e.rowData.clubID != undefined) {
            if (e.rowData.classID >= 0 && e.rowData.clubID >= 0) {
                laf.window.create('Club', '/views/search/club.js', {
                    clubID: e.rowData.clubID,
                    classID: e.rowData.classID
                });
                laf.window.open();
            }
        }
    });
    
    tvClasses.addEventListener('move', function(e){
        if (e.fromIndex != e.index) {
            var favIndex = favClasses.indexOf(e.rowData.clubID + '|' + e.rowData.classID);
            if (favIndex >= 0) {
                var toCopy = favClasses[favIndex];
                favClasses.splice(favIndex, 1);
                favClasses.splice((favIndex - e.fromIndex) + e.index, 0, toCopy);
                Ti.App.Properties.setString('FavoriteClasses', favClasses.toString());
            }
        }
    });
    
    tvClasses.addEventListener('delete', function(e){
        if (e.rowData != undefined && e.rowData.clubID != undefined && e.rowData.classID != undefined) {
            var favIndex = favClasses.indexOf(e.rowData.clubID + '|' + e.rowData.classID);
            if (favIndex >= 0) {
                favClasses.splice(favIndex, 1);
                Ti.App.Properties.setString('FavoriteClasses', favClasses.toString());
            }
        }
    });
    
    btnEdit.addEventListener('click', function(e){
        setRightNav(btnDone);
        tvClasses.moving = true;
        tvClasses.editing = true;
    });
    
    btnDone.addEventListener('click', function(e){
        tvClasses.moving = false;
        tvClasses.editing = false;
        loadClasses();
        setClassRows();
    });
    
    //=== DISPLAY =============================
    this.hide = function(){
        tvClasses.visible = false;
        tvClasses.moving = false;
        tvClasses.editing = false;
        setRightNav(null);
    };
    
    this.refresh = function(){
        if (favClasses == undefined || prevFavClassString != Ti.App.Properties.getString('FavoriteClasses').split(',')) {
            vwActivity.show('Loading...');
            loadClasses();
            setClassRows();
            vwActivity.hide();
        }
        else {
            if (!laf.device.isiPhone() || classes.length == 0) {
                setRightNav(null);
            }
            else {
                setRightNav(btnEdit);
            }
        }
    };
    
    this.show = function(){
        tvClasses.visible = true;
    };
    
    this.view = function(){
        return tvClasses;
    };
};
