function favoriteClubs(){
    //=== HEADER & DATA =============================	
    var clubs = [];
    var hours = [];
    var holidayHours = [];
    var prevFavClubsString;
    var favClubs;
    
    //=== OBJECTS =============================
    var vwActivity = new activityIndicator();
    
    var tvClubs = Ti.UI.createTableView({
        top: 29,
    	backgroundColor: 'white',
    	rowBackgroundColor: 'transparent',
    	separatorColor: '#e1e1e1',	
        editable: true
    });
    
    var btnEdit = Ti.UI.createButton({
        title: 'Edit'
    });
    
    var btnDone = Ti.UI.createButton({
        title: 'Done',
        style: Ti.UI.iPhone.SystemButtonStyle.DONE
    });
    
    function newClubRow(clubIndex){
        var tvrClub = Ti.UI.createTableViewRow({
            height: 75,
            className: 'favoriteClubsClub',
            hasChild: true,
            clubID: clubs[clubIndex].ClubID
        });
        
        tvrClub.add(Ti.UI.createLabel({
            font: {
                fontSize: 16,
                fontWeight: 'bold',
                fontFamily: 'Arial'
            },
            color: 'black',
            top: 5,
            left: 5,
            right: laf.table.leftDataRightMargin,
            height: 20,
            textAlign: 'left',
            text: clubs[clubIndex].Description
        }));
        
        tvrClub.add(Ti.UI.createLabel({
            color: '#7F7F7F',
            font: {
                fontSize: 14,
                fontFamily: 'Arial'
            },
            top: 25,
            left: 15,
            right: laf.table.leftDataRightMargin,
            height: 40,
            textAlign: 'left',
            text: clubs[clubIndex].Phone + '\n' + getHoursString(clubs[clubIndex].ClubID, clubs[clubIndex].CountryCode)
        }));
        
        laf.table.makeRowSelectable(tvrClub);
        
        return tvrClub;
    }
    
    //=== FUNCTIONS =============================     
    function loadClubs(){
        clubs = [];
        hours = [];
        holidayHours = [];
        
        prevFavClubsString = Ti.App.Properties.getString('FavoriteClubs');
        favClubs = prevFavClubsString.split(',');
        if (favClubs.length != 0) {
            var favClubFilter = '';
            for (var clubItr = 0, clubLen = favClubs.length; clubItr < clubLen; clubItr++) {
                favClubFilter += ',\'' + favClubs[clubItr] + '\'';
            }
            favClubFilter = favClubFilter.substring(1);
            
            clubs = laf.data.clubSet('SELECT CLUB_ID, DESCRIPTION, ADDRESS, CITY, STATE, PHONE, COUNTRYCODE FROM Club WHERE CLUB_ID IN (' + favClubFilter + ')', ['ClubID', 'Description', 'Address', 'City', 'State', 'Phone', 'CountryCode']);
            hours = laf.data.clubSet('SELECT CLUB_ID, strftime("%m/%d/%Y %H:%M:%S", t1.Time) AS OPEN_TIME, strftime("%m/%d/%Y %H:%M:%S", t2.Time) AS CLOSE_TIME, OPEN24, CLOSED FROM ClubHours ch JOIN Time t1 on t1.TimeID=ch.OPEN_TIME JOIN Time t2 on t2.TimeID=ch.CLOSE_TIME WHERE CLUB_ID IN (' + favClubFilter + ') AND SCHEDULE_TYPE_ID = \'1\' AND DAY_ID = \'' + ((new Date()).getDay() + 1) + '\' ORDER BY SCHEDULE_TYPE_ID, DAY_ID', ['ClubID', 'Open', 'Close', 'Open24', 'Closed24']);
            holidayHours = laf.data.clubSet('SELECT DISTINCT ch.Description, ch.CountryCode, strftime("%m/%d/%Y %H:%M:%S", t1.Time) AS OPEN_TIME, strftime("%m/%d/%Y %H:%M:%S", t2.Time) AS CLOSE_TIME, REGULAR_HOURS, CLOSED FROM ClubHoliday ch JOIN Club c ON ch.CountryCode = c.COUNTRYCODE JOIN Time t1 on t1.TimeID=ch.OPEN_TIME JOIN Time t2 on t2.TimeID=ch.CLOSE_TIME WHERE date(ObservedDate) = date(\'now\', \'localtime\') AND c.CLUB_ID IN (' + favClubFilter + ')', ['Description', 'CountryCode', 'Open', 'Close', 'Regular', 'Closed']);
            
            //Sort by order stored in array
            clubs.sort(function(a, b){
                return favClubs.indexOf(a.ClubID) - favClubs.indexOf(b.ClubID);
            });
        }
    }
    
    function getHoursString(clubID, countryCode){
        var hoursIndex = -1;
        var holidayIndex = -1;
        
        for (var hoursItr = 0, hoursLen = hours.length; hoursItr < hoursLen; hoursItr++) {
            if (hours[hoursItr].ClubID == clubID) {
                hoursIndex = hoursItr;
                break;
            }
        }
        
        for (var holidayItr = 0, holidayLen = holidayHours.length; holidayItr < holidayLen; holidayItr++) {
            if (holidayHours[holidayItr].CountryCode == countryCode) {
                holidayIndex = holidayItr;
                break;
            }
        }
        
        var strHours = (holidayIndex == -1) ? 'Today\'s Hours: ' : 'Holiday Hours: ';
        if (hoursIndex == -1 || hours[hoursIndex].Closed24 == '1' || (holidayIndex != -1 && holidayHours[holidayIndex].Closed == '1')) {
            strHours += 'Closed';
        }
        else {
            if (holidayIndex == -1 || holidayHours[holidayIndex].Regular == '1') {
                if (hours[hoursIndex].Open24 == '1') {
                    strHours += 'Open 24 Hours';
                }
                else {
                    strHours += laf.dateTime.toTimeString(hours[hoursIndex].Open) + ' - ' + laf.dateTime.toTimeString(hours[hoursIndex].Close);
                }
            }
            else {
                var closesAtMidnight = (hours[hoursIndex].Close == '01/01/1900 00:00:00');
                strHours += laf.dateTime.toTimeString((holidayHours[holidayIndex].Open > hours[hoursIndex].Open) ? holidayHours[holidayIndex].Open : hours[hoursIndex].Open);
                strHours += ' - ';
                strHours += laf.dateTime.toTimeString((closesAtMidnight || holidayHours[holidayIndex].Close < hours[hoursIndex].Close) ? holidayHours[holidayIndex].Close : hours[hoursIndex].Close);
            }
        }
        
        return strHours;
    }
    
    function setClubRows(){
        tvClubs.editing = false;
        tvClubs.moving = false;
        
        var data = [];
        
        data.push(laf.table.section('Favorite Clubs'));
        
        if (clubs == undefined || clubs.length == undefined || clubs.length == 0) {
            setRightNav(null);
            tvClubs.touchEnabled = false;
            laf.table.hideEmptyRows(tvClubs, false);	
            
            var tvrNoFavorites = Ti.UI.createTableViewRow({
                height: 105,
                editable: false,
                moveable: false,
                className: 'favoriteClubsNoFavorites'
            });
            tvrNoFavorites.add(Ti.UI.createLabel({
                color: '#7F7F7F',
                font: {
                    fontSize: 18,
                    fontFamily: 'Arial'
                },
                top: 25,
                left: 5,
                right: 5,
                height: 80,
                textAlign: 'center',
                text: 'Add your favorite clubs from\nSearch on the home screen.'
            }));
            data.push(tvrNoFavorites);
        }
        else {
            if (laf.device.isiPhone()) {
                setRightNav(btnEdit);
            }
            
            tvClubs.touchEnabled = true;
            laf.table.showEmptyRows(tvClubs);				
            for (var clubItr = 0, clubLen = clubs.length; clubItr < clubLen; clubItr++) {
                data.push(newClubRow(clubItr));
            }
        }
        
        tvClubs.setData(data);
    }
    
    //=== EVENTS =============================
    tvClubs.addEventListener('click', function(e){
        if (e.rowData != undefined && e.rowData.clubID != undefined) {
            if (e.rowData.clubID >= 0) {
                laf.window.create('Club', '/views/search/club.js', {
                    clubID: e.rowData.clubID
                });
                laf.window.open();
            }
        }
    });
    
    tvClubs.addEventListener('move', function(e){
        if (e.fromIndex != e.index) {
            var favIndex = favClubs.indexOf(e.rowData.clubID);
            if (favIndex >= 0) {
                var toCopy = favClubs[favIndex];
                favClubs.splice(favIndex, 1);
                favClubs.splice((favIndex - e.fromIndex) + e.index, 0, toCopy);
                Ti.App.Properties.setString('FavoriteClubs', favClubs.toString());
            }
        }
    });
    
    tvClubs.addEventListener('delete', function(e){
        if (e.rowData != undefined && e.rowData.clubID != undefined && e.rowData.clubID >= 0) {
            var favIndex = favClubs.indexOf(e.rowData.clubID);
            if (favIndex >= 0) {
                favClubs.splice(favIndex, 1);
                Ti.App.Properties.setString('FavoriteClubs', favClubs.toString());
            }
        }
    });
    
    btnEdit.addEventListener('click', function(e){
        setRightNav(btnDone);
        tvClubs.moving = true;
        tvClubs.editing = true;
    });
    
    btnDone.addEventListener('click', function(e){
        tvClubs.moving = false;
        tvClubs.editing = false;
        loadClubs();
        setClubRows();
    });
    
    //=== DISPLAY =============================
    this.hide = function(){
        tvClubs.visible = false;
        tvClubs.moving = false;
        tvClubs.editing = false;
        setRightNav(null);
    };
    
    this.refresh = function(){
        if (favClubs == undefined || prevFavClubsString != Ti.App.Properties.getString('FavoriteClubs').split(',')) {
            vwActivity.show('Loading...');
            loadClubs();
            setClubRows();
            vwActivity.hide();
        }
        else {
            if (!laf.device.isiPhone() || clubs.length == 0) {
                setRightNav(null);
            }
            else {
                setRightNav(btnEdit);
            }
        }
    };
    
    this.show = function(){
        tvClubs.visible = true;
    };
    
    this.view = function(){
        return tvClubs;
    };
};
