//=== HEADER & DATA =============================

//=== OBJECTS =============================
var vwImages = [];
for (var c = 0; c < 12; c++) {
    vwImages.push(Ti.UI.createView({
        backgroundColor: 'black'
    }));
    vwImages[c].add(Ti.UI.createView({
        backgroundImage: laf.path.images + 'gallery/image' + (c + 1) + '.jpg',
        width: 329,
        height: 180
    }));
}

var vwScrollView = Ti.UI.createScrollableView({
    views: vwImages,
    currentPage: 0
});

var vwToolbar = Ti.UI.createView({
    bottom: 5,
    left: 35,
    right: 35,
    height: 35,
    opacity: 0.4,
    backgroundColor: 'black',
    borderRadius: 10
});

var lblDisclaimer = Ti.UI.createLabel({
    color: 'white',
    font: {
        fontSize: 10,
        fontWeight: 'light'
    },
    top: 2,
    height: 20,
    textAlign: 'center',
    text: 'Facilities, equipment and amenities vary by location.'
});

var btnLeft = Ti.UI.createView({
    bottom: 7,
    left: 40,
    height: 30,
    width: 30,
    visible: false,
    backgroundImage: laf.path.images + 'arrowLeft.png'
});

var btnRight = Ti.UI.createView({
    bottom: 7,
    right: 40,
    height: 30,
    width: 30,
    backgroundImage: laf.path.images + 'arrowRight.png'
});

var btnClose = Ti.UI.createButton({
    title: 'X',
    color: 'white',
    font: {
        fontSize: 30,
        fontFamily: 'Helvetica'
    },
    height: 35,
    width: 50,
    top: 5,
    right: 5,
    backgroundImage: laf.path.images + 'BUTT_red_off.png',
    backgroundSelectedImage: laf.path.images + 'BUTT_red_on.png'
});

//=== FUNCTIONS =============================
function enableLeftRight(photoIndex){
    photoIndex = parseInt(photoIndex, 10);
    
    if (photoIndex <= 0) {
        btnLeft.enabled = false;
        btnLeft.visible = false;
    }
    else {
        btnLeft.enabled = true;
        btnLeft.visible = true;
    }
    
    if (photoIndex >= vwImages.length - 1) {
        btnRight.enabled = false;
        btnRight.visible = false;
    }
    else {
        btnRight.enabled = true;
        btnRight.visible = true;
    }
}

//=== EVENTS ====================================
vwScrollView.addEventListener('scroll', function(e){
    btnRight.enabled = btnLeft.enabled = false;
    enableLeftRight(e.currentPage);
});

btnLeft.addEventListener('click', function(e){
    btnRight.enabled = btnLeft.enabled = false;
    btnLeft.visible = false;
    
    var i = vwScrollView.currentPage - 1;
    if (i >= 0) {
        vwScrollView.currentPage = i;
    }
});

btnRight.addEventListener('click', function(e){
    btnRight.enabled = btnLeft.enabled = false;
    btnRight.visible = false;
    
    var i = vwScrollView.currentPage + 1;
    if (i < vwImages.length) {
        vwScrollView.currentPage = i;
    }
});

btnClose.addEventListener('click', function(){
    win.close();
});

//=== DISPLAY ===================================
win.backgroundColor = '#000';
win.add(vwScrollView);
win.add(lblDisclaimer);
win.add(vwToolbar);
win.add(btnLeft);
win.add(btnRight);
win.add(btnClose);
