//=== HEADER & DATA =============================

//=== OBJECTS =============================
var images = [];
for (var c = 0; c < 12; c++) {
    images[c] = laf.path.images + 'gallery/image' + (c + 1) + '.jpg';
}

var vwCoverflow = Ti.UI.createCoverFlowView({
    images: images,
    top: -15,
    backgroundColor: '#000'
});

var vwToolbar = Ti.UI.createView({
    bottom: 5,
    left: 35,
    right: 35,
    height: 35,
    opacity: 0.4,
    backgroundColor: 'black',
    borderRadius: 10
});

var lblDisclaimer = Ti.UI.createLabel({
    color: 'white',
    font: {
        fontSize: 10,
        fontWeight: 'light'
    },
    top: 2,
    height: 20,
    textAlign: 'center',
    text: 'Facilities, equipment and amenities vary by location.'
});

var btnLeft = Ti.UI.createView({
    bottom: 7,
    left: 40,
    height: 30,
    width: 30,
    enabled: false,
    opacity: 0.3,
    backgroundImage: laf.path.images + 'arrowLeft.png'
});

var btnRight = Ti.UI.createView({
    bottom: 7,
    right: 40,
    height: 30,
    width: 30,
    backgroundImage: laf.path.images + 'arrowRight.png'
});

var btnClose = Ti.UI.createButton({
    title: 'X',
    color: 'white',
    font: {
        fontSize: 30,
        fontFamily: 'Helvetica'
    },
    height: 35,
    width: 50,
    top: 5,
    right: 5,
    backgroundImage: laf.path.images + 'BUTT_red_off.png',
    backgroundSelectedImage: laf.path.images + 'BUTT_red_on.png'
});

//=== FUNCTIONS =============================
function enableLeftRight(photoIndex){
    if (photoIndex <= 0) {
        btnLeft.enabled = false;
        btnLeft.opacity = 0.3;
    }
    else {
        btnLeft.enabled = true;
        btnLeft.opacity = 1.0;
    }
    
    if (photoIndex >= images.length - 1) {
        btnRight.enabled = false;
        btnRight.opacity = 0.3;
    }
    else {
        btnRight.enabled = true;
        btnRight.opacity = 1.0;
    }
}

//=== EVENTS ====================================
vwCoverflow.addEventListener('change', function(e){
    btnRight.enabled = btnLeft.enabled = false;
    enableLeftRight(vwCoverflow.selected);
});

btnLeft.addEventListener('click', function(e){
    btnRight.enabled = btnLeft.enabled = false;
    btnLeft.opacity = 0.3;
    
    var i = vwCoverflow.selected - 1;
    if (i >= 0) {
        vwCoverflow.selected = i;
    }
    
    setTimeout(function(){
        enableLeftRight(i);
    }, 125);
});

btnRight.addEventListener('click', function(e){
    btnRight.enabled = btnLeft.enabled = false;
    btnRight.opacity = 0.3;
    
    var i = vwCoverflow.selected + 1;
    if (i < images.length) {
        vwCoverflow.selected = i;
    }
    
    setTimeout(function(){
        enableLeftRight(i);
    }, 125);
});

btnClose.addEventListener('click', function(){
    Ti.UI.iPhone.statusBarStyle = Ti.UI.iPhone.StatusBar.DEFAULT;
    win.showNavBar();
    win.close();
});

//=== DISPLAY ===================================
win.hideNavBar();
Ti.UI.iPhone.statusBarStyle = Ti.UI.iPhone.StatusBar.OPAQUE_BLACK;

win.add(vwCoverflow);
win.add(lblDisclaimer);
win.add(vwToolbar);
win.add(btnLeft);
win.add(btnRight);
win.add(btnClose);
