//=== HEADER & DATA =============================
//Ti.include('../../common/winHeader.js'); //Not needed, as this page is an include from default.js

var selectedClubID = -1;
var selectedClubDescription = '';
var selectedContact = {};

//=== OBJECTS =============================
var tvPass = Ti.UI.createTableView({
    backgroundColor: 'white',
    rowBackgroundColor: 'transparent',
    separatorColor: '#e1e1e1'
});

var btnDetails = Ti.UI.createButton({
    title: 'Full Terms & Conditions',
    height: 25,
    color: 'black',
    width: 260,
    top: 95,
    backgroundImage: laf.path.images + 'BUTT_gry_off.png',
    backgroundSelectedImage: laf.path.images + 'BUTT_gry_on.png'
});

//=== FUNCTIONS =============================
function createPass(){
    var callbackFail = function(){
        laf.window.alert('Error', 'An error occured while processing your guests. Please try again.');
        win.close();
    };
    
    var callbackOK = function(response){
        if (response.Success) {
            laf.window.alert('Guest Pass Created', 'Your guest pass has been created and emailed to the address you provided (check spam folder).');
            setTimeout(function(){
                win.close();
            }, 600);
        }
        else {
            laf.window.alert('Error', 'An error occured while processing your guest pass. Please try again. ' + response.Message);
            win.close();
        }
    };
    
    selectedContact.ClubID = selectedClubID;
    post(selectedContact, 'Public.svc/CreateGuestPass', callbackOK, callbackFail);
}

function loadClub(clubID){
    selectedClubDescription = laf.data.clubScalar('Select DESCRIPTION FROM Club WHERE CLUB_ID = \'' + clubID + '\'');
    selectedClubID = (laf.object.isNullOrEmpty(selectedClubDescription)) ? -1 : clubID;
}

function setGuestRows(){
    var data = [];
    
    data.push(laf.table.section('Complimentary Pass'));
    
    var tvrDescription = Ti.UI.createTableViewRow({
        height: 150,
        className: 'guestsDescription'
    });
    laf.table.ignoreRowSelection(tvrDescription);
    
    tvrDescription.add(Ti.UI.createView({
        backgroundImage: laf.path.images + 'edit.png',
        height: 48,
        width: 48,
        top: 20,
        right: 10
    }));
    
    tvrDescription.add(Ti.UI.createLabel({
        color: 'black',
        font: {
            fontSize: 18,
            fontFamily: 'Arial'
        },
        top: 5,
        left: 10,
        right: 68,
        height: 80,
        text: 'Come into LA Fitness Sports Clubs and enjoy this complimentary pass.'
    }));
    
    tvrDescription.add(btnDetails);
    data.push(tvrDescription);
    
    data.push(laf.table.section('Pass Details'));
    var clubDefined = selectedClubDescription != undefined && selectedClubDescription.length > 0;
    var contactDefined = selectedContact != undefined && selectedContact.FirstName != undefined;
    
    data.push(laf.table.actionRow((clubDefined) ? selectedClubDescription : 'Select a Club...', 'SelectClub', 40, 'club.png'));
    data.push(laf.table.actionRow((contactDefined) ? selectedContact.FirstName + ' ' + selectedContact.LastName : 'Enter Contact Info...', 'SelectContact', 40, 'userAdd.png'));
    
    tvPass.setData(data);
    
    if (clubDefined && contactDefined) {
        createPass();
    }
}

//=== EVENTS =============================
tvPass.addEventListener('click', function(e){
    if (e.rowData != undefined && e.rowData.rowType != undefined) {
        switch (e.rowData.rowType) {
            case 'SelectClub':
                laf.window.create('Locations', '/views/common/clubPicker.js', {
                    selectedClubDescription: selectedClubDescription
                });
                laf.window.open();
                break;
            case 'SelectContact':
                laf.window.create('Contact', '/views/guests/contactInfo.js', {
                    selectedContact: selectedContact
                });
                laf.window.open();
                break;
        }
    }
});

btnDetails.addEventListener('click', function(e){
    laf.window.create('Terms', 'views/guests/terms.js');
    laf.window.open();
});

laf.window.listen('clubSelected', function(e){
    loadClub(e.clubID);
    setGuestRows();
});

laf.window.listen('contactEntered', function(e){
    selectedContact = e.contact;
    setGuestRows();
});

//=== DISPLAY =============================
setGuestRows();
vwMain.add(tvPass);
