//=== HEADER & DATA =============================
//Ti.include('../../common/winHeader.js'); //Not needed, as this page is an include from default.js

var member = laf.object.isSaved('Member') ? laf.object.load('Member') : undefined;

//=== OBJECTS =============================
var tvPass = Ti.UI.createTableView({
    backgroundColor: 'white',
    rowBackgroundColor: 'transparent',
    separatorColor: '#e1e1e1'
});

var btnDetails = Ti.UI.createButton({
    title: 'Full Terms & Conditions',
    height: 25,
    color: 'black',
    width: 260,
    top: 95,
    backgroundImage: laf.path.images + 'BUTT_gry_off.png',
    backgroundSelectedImage: laf.path.images + 'BUTT_gry_on.png'
});

//=== FUNCTIONS =============================
function setGuestRows(){
    var data = [];
    
    if (member != undefined && member.HasGuests != undefined && member.HasGuests == true) {
        data.push(laf.table.section('Guests'));
        
        var tvrAmenityDetail = Ti.UI.createTableViewRow({
            height: 140,
            className: 'vipGuestsAmenityDetail'
        });
        laf.table.ignoreRowSelection(tvrAmenityDetail);
        
        tvrAmenityDetail.add(Ti.UI.createView({
            backgroundImage: laf.path.images + 'keytag.png',
            height: 48,
            width: 48,
            top: 20,
            right: 10
        }));
        
        tvrAmenityDetail.add(Ti.UI.createLabel({
            color: 'black',
            font: {
                fontSize: 18,
                fontFamily: 'Arial'
            },
            top: 5,
            left: 10,
            right: 68,
            height: 105,
            text: 'Your membership includes guest privileges. Bring up to two of your friends to workout with you.'
        }));
        
        tvrAmenityDetail.add(Ti.UI.createLabel({
            color: 'black',
            font: {
                fontSize: 10,
                fontWeight: 'light',
                fontFamily: 'Arial'
            },
            top: 105,
            left: 10,
            right: 10,
            height: 30,
            textAlign: 'center',
            text: 'Terms & Conditions of your Membership Agreement Apply.'
        }));
        
        data.push(tvrAmenityDetail);
    }
    
    data.push(laf.table.section('VIP Guests'));
    
    var tvrDescription = Ti.UI.createTableViewRow({
        height: 135,
        className: 'vipGuestsDescription'
    });
    laf.table.ignoreRowSelection(tvrDescription);
    
    tvrDescription.add(Ti.UI.createView({
        backgroundImage: laf.path.images + 'userGroup.png',
        height: 48,
        width: 48,
        top: 20,
        right: 10
    }));
    
    tvrDescription.add(Ti.UI.createLabel({
        color: 'black',
        font: {
            fontSize: 18,
            fontFamily: 'Arial'
        },
        top: 5,
        left: 10,
        right: 68,
        height: 85,
        text: 'Your VIPs receive a 2 week pass to workout whenever they like, with or without you.'
    }));
    
    tvrDescription.add(btnDetails);
    data.push(tvrDescription);
    data.push(laf.table.actionRow('My VIP Guests', 'ViewGuests', 40, 'userGroup.png'));
    tvPass.setData(data);
}

//=== EVENTS =============================
tvPass.addEventListener('click', function(e){
    if (e.rowData != undefined && e.rowData.rowType != undefined) {
        if (e.rowData.rowType == 'ViewGuests') {
            laf.window.create('VIP Guests', '/views/guests/vipGuestsList.js');
            laf.window.open();
        }
    }
});

btnDetails.addEventListener('click', function(e){
    laf.window.create('Terms', 'views/guests/terms.js');
    laf.window.open();
});

//=== DISPLAY =============================
setGuestRows();
vwMain.add(tvPass);

//Background update of membership info
var callbackOK = function(response){
    if (response.Success) {
        laf.object.save('Member', response.Value);
        if ((member == undefined && response.Value.HasGuests == true) ||
        (response.Value.HasGuests != member.HasGuests)) {
            member = response.Value;
            setGuestRows();
        }
        else {
            member = response.Value;
        }
    }
};
post('', 'Private.svc/GetCustomer', callbackOK, function(){
}, true);
