//=== HEADER & DATA =============================
Ti.include('../../common/winHeader.js');

var selectedClubID = -1;
var selectedClubDescription = '';
var selectedContact = {};

//=== OBJECTS =============================
var tvPass = Ti.UI.createTableView({
    backgroundColor: 'white',
    rowBackgroundColor: 'transparent',
    separatorColor: '#e1e1e1'
});

var btnCancel = Ti.UI.createButton({
    title: 'Cancel'
});

//=== FUNCTIONS =============================
function createPass(){
    selectedContact.ClubID = selectedClubID;
    var guests = [];
    guests.push(selectedContact);
    
    var callbackFail = function(){
        laf.window.alert('Error', 'An error occured while processing your guests. Please try again.');
        win.close();
    };
    
    var callbackOK = function(response){
        if (response.Success) {
            var guestID = (response.Value != undefined && response.Value.length > 0) ? response.Value[0] : 0;
            var newGuest = {};
            newGuest.CellPhone = '' + selectedContact.PhoneNumber;
            newGuest.ClubID = selectedContact.ClubID;
            newGuest.Email = '' + selectedContact.Email;
            newGuest.FirstName = '' + selectedContact.FirstName;
            newGuest.GuestID = guestID;
            newGuest.LastName = '' + selectedContact.LastName;
            newGuest.Phone = '' + selectedContact.PhoneNumber;
            newGuest.CreateDate = (new Date()).getTime();
            
            var vipGuests = [];
            if (laf.object.isSaved('VIPGuests')) {
                vipGuests = laf.object.load('VIPGuests');
                if (vipGuests == undefined) {
                    vipGuests = [];
                }
            }
			vipGuests.splice(0, 0, newGuest);            
            laf.object.save('VIPGuests', vipGuests);
            laf.window.fire('VIPGuestAdded');
            setTimeout(function(){
                win.close();
            }, 600);
        }
        else {
            laf.window.alert('Error', 'An error occured while processing your guests. Please try again. ' + response.Message);
            win.close();
        }
    };
    
    post(guests, 'Private.svc/CreateVIPGuest', callbackOK, callbackFail);
}

function loadClub(clubID){
    selectedClubDescription = laf.data.clubScalar('Select DESCRIPTION FROM Club WHERE CLUB_ID = \'' + clubID + '\'');
    selectedClubID = (laf.object.isNullOrEmpty(selectedClubDescription)) ? -1 : clubID;
}

function setGuestRows(){
    var data = [];
    
    data.push(laf.table.section('New VIP Guest'));
    
    var tvrDescription = Ti.UI.createTableViewRow({
        height: 120,
        className: 'guestsDescription'
    });
    laf.table.ignoreRowSelection(tvrDescription);
    
    tvrDescription.add(Ti.UI.createView({
        backgroundImage: laf.path.images + 'edit.png',
        height: 48,
        width: 48,
        top: 20,
        right: 10
    }));
    
    tvrDescription.add(Ti.UI.createLabel({
        color: 'black',
        font: {
            fontSize: 18,
            fontFamily: 'Arial'
        },
        top: 5,
        left: 10,
        right: 68,
        height: 100,
        text: 'Create a VIP Guest by selecting the club and contact information for your friend below.'
    }));
    
    data.push(tvrDescription);
    
    data.push(laf.table.section('Pass Details'));
    var clubDefined = selectedClubDescription != undefined && selectedClubDescription.length > 0;
    var contactDefined = selectedContact != undefined && selectedContact.FirstName != undefined;
    
    data.push(laf.table.actionRow((clubDefined) ? selectedClubDescription : 'Select a Club...', 'SelectClub', 40, 'club.png'));
    data.push(laf.table.actionRow((contactDefined) ? selectedContact.FirstName + ' ' + selectedContact.LastName : 'Enter Contact Info...', 'SelectContact', 40, 'userAdd.png'));
    
    tvPass.setData(data);
    
    if (clubDefined && contactDefined) {
        createPass();
    }
}

//=== EVENTS =============================
tvPass.addEventListener('click', function(e){
    if (e.rowData != undefined && e.rowData.rowType != undefined) {
        switch (e.rowData.rowType) {
            case 'SelectClub':
                laf.window.create('Locations', '/views/common/clubPicker.js', {
                    selectedClubDescription: selectedClubDescription
                });
                laf.window.open();
                break;
            case 'SelectContact':
                laf.window.create('Contact', '/views/guests/contactInfo.js', {
                    selectedContact: selectedContact
                });
                laf.window.open();
                break;
        }
    }
});

btnCancel.addEventListener('click', function(e){
    win.close();
});

laf.window.listen('clubSelected', function(e){
    loadClub(e.clubID);
    setGuestRows();
});

laf.window.listen('contactEntered', function(e){
    selectedContact = e.contact;
    setGuestRows();
});

//=== DISPLAY =============================
loadClub(laf.object.isSaved('Member') ? parseInt(laf.object.load('Member').ClubID, 10) : -1);
setLeftNav(btnCancel);
setGuestRows();
vwMain.add(tvPass);
