(function(){
    //=== HEADER & DATA =============================
    Ti.include('../../common/winHeader.js');
    
    //=== OBJECTS =============================		
    var tvProgressSetting = Ti.UI.createTableView({
        backgroundColor: 'white',
        rowBackgroundColor: 'transparent',
        separatorColor: '#e1e1e1'
    });
    
    function createTableLabelRight(description){
        return Ti.UI.createLabel({
            color: '#576996',
            font: {
                fontSize: 16,
                fontFamily: 'Arial'
            },
            height: 20,
            textAlign: 'right',
            right: laf.table.detailsRight,
            text: description
        });
    }
    
    var lblPasscodeEnabled = createTableLabelRight(laf.object.isSaved('Passcode') ? 'ON' : 'OFF');
    
    //=== FUNCTIONS =============================
    function setSettingsRows(){
        var data = [];
        data.push(laf.table.section('Settings'));
        
        var tvrPasscode = laf.table.actionRow('Passcode', 'Passcode', 65, 'lock.png');
        tvrPasscode.add(lblPasscodeEnabled);
        data.push(tvrPasscode);
        
        data.push(laf.table.actionRow('Sharing', 'Sharing', 65, 'refresh.png'));
        data.push(laf.table.actionRow('Logout', 'Logout', 65, 'delete.png'));
        
        laf.table.hideEmptyRows(tvProgressSetting, true);
        tvProgressSetting.setData(data);
    }
    
    //=== EVENTS =============================
    tvProgressSetting.addEventListener('click', function(e){
        if (e.rowData != undefined && e.rowData.rowType != undefined) {
            switch (e.rowData.rowType) {
                case 'Passcode':
                    laf.window.create('Passcode', 'views/common/passcode.js', {
                        reset: laf.object.isSaved('Passcode') ? false : true,
                        unlock: false
                    });
                    laf.window.open();
                    break;
                case 'Sharing':
                    laf.window.create('Sharing Settings', 'views/home/settingsShare.js');
                    laf.window.open();
                    break;
                case 'Logout':
                    laf.window.alert('Logout', 'Are you sure that you would like to logout of your LAFitness.com account?', ['Logout', 'Cancel'], function(e){
                        if (e.index == 0) {
                            laf.auth.logOut();
                            laf.window.goHome();
                        }
                    });
                    break;
            }
        }
    });
    
    //=== DISPLAY =============================
    setSettingsRows();
    vwMain.add(tvProgressSetting);
    
})();
