(function(){
    //=== HEADER & DATA =============================
    Ti.include('../../common/winHeader.js');
	
    //=== OBJECTS =============================		
    var tvSettingsPasscode = Ti.UI.createTableView({
        backgroundColor: 'white',
        rowBackgroundColor: 'transparent',
        separatorColor: '#e1e1e1'
    });
    
    //=== FUNCTIONS =============================    
    function setOptionRows(){
        var data = [];
        data.push(laf.table.section('Passcode Options'));
        data.push(laf.table.actionRow('Turn Passcode Off', 'Disable', 80, 'unlock.png'));		
        data.push(laf.table.actionRow('Change Passcode', 'Change', 80, 'lock.png'));
		laf.table.hideEmptyRows(tvSettingsPasscode, true);					
        tvSettingsPasscode.setData(data);
    }
	
    //=== EVENTS =============================
    tvSettingsPasscode.addEventListener('click', function(e){
        if (e.rowData != undefined && e.rowData.rowType != undefined) {
			switch (e.rowData.rowType) {
				case 'Disable':
					Ti.App.Properties.removeProperty('Passcode');
					laf.window.alert('Passcode has been disabled.');
					
					setTimeout(function(){
						laf.window.goHome();
					}, 800);
					break;
				case 'Change':
					laf.window.create('Setting', 'views/common/passcode.js', {
						reset: true,
						unlock: false
					});
					laf.window.open();
					break;
			}
		}
    });
	
    //=== DISPLAY =============================
    setOptionRows();	
    vwMain.add(tvSettingsPasscode);
})();
