(function(){
    //=== HEADER & DATA =============================
    Ti.include('../../common/winHeader.js');
    Ti.include('../../library/ouath_adapter.js');
    
    //=== OBJECTS =============================		
    var vwTwitpic, vwPicasa;
    var vwActivity = new activityIndicator();
    
    var tvProgressSettingShare = Ti.UI.createTableView({
        backgroundColor: 'white',
        rowBackgroundColor: 'transparent',
        separatorColor: '#e1e1e1'
    });
    
    function createTableLabelRight(description){
        return Ti.UI.createLabel({
            color: '#576996',
            font: {
                fontSize: 16,
                fontFamily: 'Arial'
            },
            height: 20,
            textAlign: 'right',
            right: laf.table.detailsRight,
            text: 'Sign in'
        });
    }
    
    var lblFacebook = createTableLabelRight();
    var lblFlickr = createTableLabelRight();
    var lblPicasa = createTableLabelRight();
    var lblTumblr = createTableLabelRight();
    var lblTwitpic = createTableLabelRight();
    var lblTwitter = createTableLabelRight();
    
    //=== FUNCTIONS =============================
    function createBody(){
        var data = [];
        data.push(laf.table.section('Settings'));
        
        var tvrFacebook = laf.table.actionRow('Facebook', 'Facebook', 65, 'refresh.png');
        tvrFacebook.add(lblFacebook);
        
        var tvrFlickr = laf.table.actionRow('Flickr', 'Flickr', 65, 'refresh.png');
        tvrFlickr.add(lblFlickr);
        
        var tvrPicasa = laf.table.actionRow('Picasa', 'Picasa', 65, 'refresh.png');
        tvrPicasa.add(lblPicasa);
        
        var tvrTumblr = laf.table.actionRow('Tumblr', 'Tumblr', 65, 'refresh.png');
        tvrTumblr.add(lblTumblr);
        
        var tvrTwitpic = laf.table.actionRow('Twitpic', 'Twitpic', 65, 'refresh.png');
        tvrTwitpic.add(lblTwitpic);
        
        var tvrTwitter = laf.table.actionRow('Twitter', 'Twitter', 65, 'refresh.png');
        tvrTwitter.add(lblTwitter);
        
        data.push(tvrFacebook);
        data.push(tvrFlickr);
        data.push(tvrPicasa);
        data.push(tvrTumblr);
        data.push(tvrTwitpic);
        data.push(tvrTwitter);
        
        laf.table.hideEmptyRows(tvProgressSettingShare, true);
        tvProgressSettingShare.setData(data);
    }
    
    function getWebView(url){
        var loading = false;
        
        var vwWeb = Ti.UI.createWebView({
            left: 0,
            right: 0,
            top: 0,
            bottom: 0,
            scalesPageToFit: true,
            url: url
        });
        
        vwWeb.addEventListener('beforeload', function(e){
            if (!loading) {
                loading = true;
                vwActivity.show('Loading...');
                setTimeout(function(){
                    if (loading) {
                        loading = false;
                        vwActivity.hide();
                    }
                }, 2000);
            }
        });
        
        vwWeb.addEventListener('load', function(e){
            if (loading) {
                loading = false;
                vwActivity.hide();
            }
        });
        
        return vwWeb;
    }
    //=== EVENTS =============================
    tvProgressSettingShare.addEventListener('click', function(e){		
		
        if (e.rowData != undefined && e.rowData.rowType != undefined) {
            switch (e.rowData.rowType) {
                case 'Email':
                    
                    break;
                case 'Facebook':
                    
                    break;
                case 'Flickr':
                    
                    break;
                case 'Picasa':
                    
                    break;
                case 'Tumblr':
                    
                    break;
                case 'Twitpic':
                    
                    break;
                case 'Twitter':
                    var oAuthAdapter = new OAuthAdapter('Tx8uUr6zrt8j3gfRwRlo9pu2WJpzDaIVMxRw9WisbA', 'xH4EQpNOJ0TVfK3B6FfMw', 'HMAC-SHA1');
                    
                    // load the access token for the service (if previously saved)
                    oAuthAdapter.loadAccessToken('twitter');
                    
                    oAuthAdapter.send('https://api.twitter.com/1/statuses/update.json', [['status', 'hey @ziodave, I successfully tested the #oauth adapter with #twitter and @appcelerator #titanium!']], 'Twitter', 'Published.', 'Not published.');
                    
                    // if the client is not authorized, ask for authorization. the previous tweet will be sent automatically after authorization
                    if (oAuthAdapter.isAuthorized() == false) {
                        // this function will be called as soon as the application is authorized
                        var receivePin = function(){
                            // get the access token with the provided pin/oauth_verifier
                           // oAuthAdapter.getAccessToken('http://twitter.com/oauth/access_token');
							oAuthAdapter.getAccessToken('https://api.twitter.com/oauth/access_token');
                            // save the access token
                            oAuthAdapter.saveAccessToken('twitter');
                        };
                        
                        // show the authorization UI and call back the receive PIN function
                       // oAuthAdapter.showAuthorizeUI('http://twitter.com/oauth/authorize?oauth_token=' + oAuthAdapter.getRequestToken('http://twitter.com/oauth/request_token', [['oauth_callback', 'oob']]), receivePin, PinFinder.twitter);
						oAuthAdapter.showAuthorizeUI('https://api.twitter.com/oauth/authorize=' + oAuthAdapter.getRequestToken('https://api.twitter.com/oauth/request_token', [['oauth_callback', 'oob']]), receivePin, PinFinder.twitter);
                    }
                    
                    break;
            }
        }
    });
    
    
    //=== DISPLAY =============================
    vwMain.add(tvProgressSettingShare);
    createBody();
})();
