function checkins(){
    //=== HEADER & DATA =============================
    var loadDate;
    
    //=== OBJECTS =============================
    var vwActivity = new activityIndicator();
    
    var vwCheckins = Ti.UI.createView({
        top: 0,
        bottom: 0
    });
    
    var tvCheckins = Ti.UI.createTableView({
        top: 48,
        backgroundColor: 'white',
        rowBackgroundColor: 'transparent',
        separatorColor: '#e1e1e1',
        allowsSelection: false
    });
    
    var vwHeader = Ti.UI.createView({
        left: 0,
        right: 0,
        top: 0,
        height: 48,
        backgroundColor: '#576996'
    });
    vwHeader.add(Ti.UI.createView({
        backgroundImage: laf.path.images + 'check2.png',
        left: 5,
        width: 29,
        height: 29
    }));
    var lblPercentage = Ti.UI.createLabel({
        color: '#FFFFFF',
        font: {
            fontSize: 18,
            fontWeight: 'bold',
            fontFamily: 'Arial'
        },
        left: 45,
        height: 'auto',
        width: 'auto',
        text: ''
    });
    vwHeader.add(lblPercentage);
    
    if (laf.device.isiPhone()) {
        lblPercentage.top = 5;
        var pbProgress = Ti.UI.createProgressBar({
            left: 45,
            right: 15,
            min: 0,
            max: 30,
            value: 0,
            height: 10,
            style: Ti.UI.iPhone.ProgressBarStyle.BAR,
            bottom: 7
        });
        vwHeader.add(pbProgress);
        pbProgress.show();
    }
    
    vwCheckins.add(vwHeader);
    vwCheckins.add(tvCheckins);
    
    //=== FUNCTIONS =============================
    function loadCheckins(){
        if (laf.network.isConnected(!laf.object.isSaved('MemberCheckins'))) {
            var callbackFail = function(error){
                if (laf.object.isSaved('MemberCheckins')) {
                    laf.window.alert('Unable to Update', 'Could not update checkins at this time. Using data stored from last update.');
                }
                else {
                    laf.window.alert('Unable to Connect', 'There was an error connecting to LA Fitness web services.');
                }
            };
            
            var callbackOK = function(response){
                if (response.Success) {
                    loadDate = new Date();
                    if (!laf.object.isSaved('MemberCheckins') || Ti.App.Properties.getString('MemberCheckins') != JSON.stringify(response.Value)) {
                        laf.object.save('MemberCheckins', response.Value);
                        setCheckinRows();
                    }
                }
                else {
                    callbackFail();
                }
            };
            
            post('', 'Private.svc/GetCheckLog', callbackOK, callbackFail, laf.object.isSaved('MemberCheckins'));
        }
        else {
            if (laf.object.isSaved('MemberCheckins')) {
                laf.window.alert('Unable to Update', 'Could not update checkins at this time. Using data stored from last update.');
            }
        }
    }
    
    function newCheckinRow(strCheckinTime){
        var tvRow = Ti.UI.createTableViewRow({
            height: 30,
            className: 'checkinRow'
        });
        tvRow.add(Ti.UI.createLabel({
            color: 'black',
            height: 30,
            left: 10,
            right: 10,
            text: strCheckinTime
        }));
        return tvRow;
    };
    
    function setHeaderValues(checkinsPast30){
        //It shouldn't be, but to be safe 		
        if (checkinsPast30 > 30) {
            checkinsPast30 = 30;
        }
        if (checkinsPast30 < 0) {
            checkinsPast30 = 0;
        }

        lblPercentage.text = 'Past 30 days:      ' + checkinsPast30 + '/30      ' + Math.round((checkinsPast30 / 30) * 100) + '%';
        //lblPercentage.text = 'Statistics:     ' + checkinsPast30 + '/30 Days    ' + Math.round((checkinsPast30 / 30) * 100) + '%';		
        
        if (laf.device.isiPhone()) {
            pbProgress.value = checkinsPast30;
            setTimeout(function(){
                pbProgress.value = checkinsPast30; //Often doesn't set unless done after load
            }, 700);
            
            setTimeout(function(){
                pbProgress.value = checkinsPast30; //Often doesn't set unless done after load
            }, 1250);
        }
    }
    
    function setCheckinRows(){
        var data = [];
        
        var history = (laf.object.isSaved('MemberCheckins')) ? laf.object.load('MemberCheckins') : undefined;
        if (history == undefined || history.length == 0) {
            data.push(laf.table.section('Recent Checkins'));
            
            tvCheckins.touchEnabled = false;
            laf.table.hideEmptyRows(tvCheckins, false);
            
            var tvrNoHistory = Ti.UI.createTableViewRow({
                height: 105,
                editable: false,
                moveable: false,
                className: 'checkinsNoHistory'
            });
            tvrNoHistory.add(Ti.UI.createLabel({
                color: '#7F7F7F',
                font: {
                    fontSize: 18,
                    fontFamily: 'Arial'
                },
                top: 25,
                left: 5,
                right: 5,
                height: 80,
                textAlign: 'center',
                text: 'No recent checkin history was found.'
            }));
            data.push(tvrNoHistory);
            setHeaderValues(0);
        }
        else {
            tvCheckins.touchEnabled = true;
            laf.table.showEmptyRows(tvCheckins);
            
            var dayStr = '';
            var checkinsPast30 = 0;
            var currClub = '';
            var now = new Date();
            var thirtyDaysInPast = new Date(new Date().setDate(now.getDate() - 30));
            thirtyDaysInPast = new Date(thirtyDaysInPast.getFullYear(), thirtyDaysInPast.getMonth(), thirtyDaysInPast.getDate());
            
            for (var historyItr = 0, historyLen = history.length; historyItr < historyLen; historyItr++) {
                if (currClub != history[historyItr].ClubName) {
                    currClub = history[historyItr].ClubName;
                    data.push(laf.table.section(currClub));
                }
                
                var datest = history[historyItr].Date.toString();
                datest = datest.substring(datest.indexOf('(') + 1, datest.indexOf('-'));
                var date = new Date(parseInt(datest, 10));
                data.push(newCheckinRow(date.toDateString() + ' @ ' + laf.dateTime.toTimeString(date, true)));
                if (date >= thirtyDaysInPast) {
                    var currDateStr = laf.dateTime.toDateString(date);
                    if (dayStr.indexOf(currDateStr + ',') == -1) {
                        dayStr += currDateStr + ',';
                        checkinsPast30++;
                    }
                }
            }
            setHeaderValues(checkinsPast30);
        }
        tvCheckins.setData(data);
    };
    
    //=== EVENTS =============================
    
    //=== DISPLAY =============================
    this.hide = function(){
        vwCheckins.visible = false;
    };
    
    this.refresh = function(){
        var refreshDate = new Date();
        if (loadDate == undefined || (refreshDate.getTime() - loadDate.getTime()) > 120000) {
            vwActivity.show('Loading...');
            setCheckinRows();
            vwActivity.hide();
            
            //Check for updated data
            loadCheckins();
        }
    };
    
    this.show = function(){
        vwCheckins.visible = true;
    };
    
    this.view = function(){
        return vwCheckins;
    };
};
