function profile(){
    //=== HEADER & DATA =============================
    var loadDate;
    var editOptions = [];
    var editView = false;
    
    //=== OBJECTS =============================
    var vwActivity = new activityIndicator();
    
    var vwProfile = Ti.UI.createView({
        top: 0,
        bottom: 0
    });
    
    var tvProfile = Ti.UI.createTableView({
        top: 48,
        backgroundColor: 'white',
        rowBackgroundColor: 'transparent',
        separatorColor: '#e1e1e1'
    });
    
    var vwHeader = Ti.UI.createView({
        left: 0,
        right: 0,
        top: 0,
        height: 48,
        backgroundColor: '#576996'
    });
    vwHeader.add(Ti.UI.createView({
        backgroundImage: laf.path.images + 'keytag2.png',
        left: 5,
        width: 29,
        height: 29
    }));
    var lblBarcode = Ti.UI.createLabel({
        color: '#FFFFFF',
        font: {
            fontSize: 18,
            fontWeight: 'bold',
            fontFamily: 'Arial'
        },
        left: 45,
        right: 5
    });
    vwHeader.add(lblBarcode);
    
    var btnCancel = Ti.UI.createButton({
        title: 'Cancel'
    });
    
    var btnEdit = Ti.UI.createButton({
        title: 'Edit'
    });
    
    var btnDone = Ti.UI.createButton({
        title: 'Done',
        style: Ti.UI.iPhone.SystemButtonStyle.DONE
    });
    
    function newEditRow(lblText, control){
        var tvRow = Ti.UI.createTableViewRow({
            height: 45,
            backgroundSelectedColor: 'white',
            className: lblText
        });
        laf.table.ignoreRowSelection(tvRow);
        
        tvRow.add(Ti.UI.createLabel({
            color: 'black',
            font: {
                fontSize: 18,
                fontFamily: 'Arial'
            },
            left: 5,
            height: 25,
            width: 110,
            textAlign: 'left',
            fontWeight: 'bold',
            text: lblText
        }));
        
        tvRow.add(control);
        
        return tvRow;
    }
    
    function newTextField(hintText, keyboard, autocapitalization){
        return Ti.UI.createTextField({
            color: '#336699',
            height: 40,
            left: 100,
            right: 10,
            hintText: hintText,
            autocorrect: false,
            borderStyle: Ti.UI.INPUT_BORDERSTYLE_ROUNDED,
            clearButtonMode: Ti.UI.INPUT_BUTTONMODE_ONFOCUS,
            keyboardType: keyboard,
            autocapitalization: autocapitalization,
            returnKeyType: Ti.UI.RETURNKEY_NEXT,
            suppressReturn: false
        });
    }
    
    var tfEmail = newTextField('E-mail Address', Ti.UI.KEYBOARD_EMAIL, Ti.UI.TEXT_AUTOCAPITALIZATION_NONE);
    var tfHomePhone = newTextField('Home Phone', Ti.UI.KEYBOARD_NUMBERS_PUNCTUATION, Ti.UI.TEXT_AUTOCAPITALIZATION_ALL);
    var tfCellPhone = newTextField('Cell Phone', Ti.UI.KEYBOARD_NUMBERS_PUNCTUATION, Ti.UI.TEXT_AUTOCAPITALIZATION_ALL);
    var tfWorkPhone = newTextField('Work Phone', Ti.UI.KEYBOARD_NUMBERS_PUNCTUATION, Ti.UI.TEXT_AUTOCAPITALIZATION_ALL);
    var tfAddress = newTextField('Address', Ti.UI.KEYBOARD_DEFAULT, Ti.UI.TEXT_AUTOCAPITALIZATION_WORDS);
    var tfAddress2 = newTextField('Address 2', Ti.UI.KEYBOARD_DEFAULT, Ti.UI.TEXT_AUTOCAPITALIZATION_WORDS);
    var tfCity = newTextField('City', Ti.UI.KEYBOARD_DEFAULT, Ti.UI.TEXT_AUTOCAPITALIZATION_WORDS);
    var tfState = newTextField('State/Province Abbreviation', Ti.UI.KEYBOARD_DEFAULT, Ti.UI.TEXT_AUTOCAPITALIZATION_ALL);
    var tfZipcode = newTextField('ZIP/Postal Code', Ti.UI.KEYBOARD_NUMBERS_PUNCTUATION, Ti.UI.TEXT_AUTOCAPITALIZATION_ALL);
    tfZipcode.returnKeyType = Ti.UI.RETURNKEY_DONE;
    
    //=== FUNCTIONS =============================
    function loadProfile(){
        if (laf.network.isConnected(!laf.object.isSaved('AccountProfile'))) {
            var callbackFail = function(){
                if (!editView) {
                    if (laf.object.isSaved('AccountProfile')) {
                        laf.window.alert('Unable to Update', 'Could not retrieve account information at this time. Using data stored from last update.');
                    }
                }
            };
            
            var callbackOK = function(response){
                if (response.Success) {
                    var refreshNeeded = !laf.object.isSaved('AccountProfile') || Ti.App.Properties.getString('AccountProfile') != JSON.stringify(response.Value);
                    laf.object.save('AccountProfile', response.Value);
                    if (!editView) {
                        loadDate = new Date();
                        if (refreshNeeded) {
                            setProfileRows();
                        }
                    }
                }
                else {
                    callbackFail();
                }
            };
            
            //Background update when saved, as having asbolute latest not essential
            post('', 'Private.svc/GetAccountProfile', callbackOK, callbackFail, laf.object.isSaved('AccountProfile'));
        }
        else {
            if (laf.object.isSaved('AccountProfile')) {
                laf.window.alert('Unable to Update', 'Could not retrieve account information at this time. Using data stored from last update.');
            }
        }
    }
    
    function setProfileRows(){
        editView = false;
        setLeftNav(null);
        lblBarcode.text = (laf.object.isSaved('Member')) ? laf.object.load('Member').BarcodeID : 'Account Profile';
        editOptions = [];
        
        var data = [];
        
        var account = (laf.object.isSaved('AccountProfile')) ? laf.object.load('AccountProfile') : undefined;
        if (account == undefined || account.length == 0) {
            setRightNav(null);
            
            data.push(laf.table.section('Account Information'));
            tvProfile.touchEnabled = false;
            laf.table.hideEmptyRows(tvProfile, false);
            
            var tvrNorProfile = Ti.UI.createTableViewRow({
                height: 105,
                editable: false,
                moveable: false,
                className: 'profileNoProfile'
            });
            tvrNorProfile.add(Ti.UI.createLabel({
                color: '#7F7F7F',
                font: {
                    fontSize: 18,
                    fontFamily: 'Arial'
                },
                top: 25,
                left: 5,
                right: 5,
                height: 80,
                textAlign: 'center',
                text: 'Account information not available at this time.'
            }));
            data.push(tvrNorProfile);
        }
        else {
            setRightNav(btnEdit);
            tvProfile.touchEnabled = true;
            laf.table.showEmptyRows(tvProfile);
            
            for (var accountItr = 0, accountLen = account.length; accountItr < accountLen; accountItr++) {
                var currItem = account[accountItr];
                if (currItem != undefined) {
                    if (currItem.Key == '*') {
                        data.push(laf.table.section(currItem.Value));
                    }
                    else 
                        if (currItem.Key == '-') {
                            //Remove 'Update' & 'Edit' which showed on individual items in earlier releases
                            editOptions.push(currItem.Value.replace('Update ', '').replace('Edit ', ''));
                        }
                        else {
                            data.push(laf.table.infoRow(currItem.Key + ' ' + currItem.Value));
                        }
                }
            }
            
            if (!laf.device.isAndroid()) {
                editOptions.push('Cancel');
            }
        }
        
        tvProfile.setData(data);
        laf.table.scrollToTop(tvProfile, false);
    };
    
    function saveProfile(){
        tfEmail.blur();
        tfHomePhone.blur();
        tfCellPhone.blur();
        tfWorkPhone.blur();
        tfAddress.blur();
        tfAddress2.blur();
        tfCity.blur();
        tfState.blur();
        tfZipcode.blur();
        
        if (!laf.verify.isEmpty(tfEmail) && !laf.verify.isEmail(tfEmail.value)) {
            laf.window.alert('Invalid', 'Please enter a valid E-mail Address or leave it blank.');
            tfEmail.focus();
            return;
        }
        if (!laf.verify.isEmpty(tfHomePhone) && !laf.verify.isPhone(tfHomePhone.value)) {
            laf.window.alert('Invalid', 'Please enter a valid Home Phone number or leave it blank.');
            tfHomePhone.focus();
            return;
        }
        if (!laf.verify.isEmpty(tfCellPhone) && !laf.verify.isPhone(tfCellPhone.value)) {
            laf.window.alert('Invalid', 'Please enter a valid Cell Phone number or leave it blank.');
            tfCellPhone.focus();
            return;
        }
        if (!laf.verify.isEmpty(tfWorkPhone) && !laf.verify.isPhone(tfWorkPhone.value)) {
            laf.window.alert('Invalid', 'Please enter a valid Work Phone number or leave it blank.');
            tfWorkPhone.focus();
            return;
        }
        if (laf.verify.isEmpty(tfAddress)) {
            laf.window.alert('Required', 'Please enter your Address.');
            tfAddress.focus();
            return;
        }
        if (laf.verify.isEmpty(tfCity)) {
            laf.window.alert('Required', 'Please enter your City.');
            tfCity.focus();
            return;
        }
        if (laf.verify.isEmpty(tfState) || (!laf.verify.isState(tfState.value) && !laf.verify.isProvince(tfState.value))) {
            laf.window.alert(laf.verify.isEmpty(tfState) ? 'Required' : 'Invalid', 'Please enter your State/Province abbreviation.');
            tfState.focus();
            return;
        }
        if (laf.verify.isEmpty(tfZipcode) || (!laf.verify.isZipCode(tfZipcode.value) && !laf.verify.isPostalCode(tfZipcode.value))) {
            laf.window.alert(laf.verify.isEmpty(tfZipcode) ? 'Required' : 'Invalid', 'Please enter your ZIP/Postal code.');
            tfState.focus();
            return;
        }
        
        var member = (laf.object.isSaved('Member')) ? laf.object.load('Member') : {};
        member.Email = laf.verify.trim(tfEmail.value);
        member.HomePhone = laf.verify.trim(tfHomePhone.value);
        member.MobilePhone = laf.verify.trim(tfCellPhone.value);
        member.WorkPhone = laf.verify.trim(tfWorkPhone.value);
        member.Address = laf.verify.trim(tfAddress.value);
        member.Address2 = laf.verify.trim(tfAddress2.value);
        member.City = laf.verify.trim(tfCity.value);
        member.State = laf.verify.trim(tfState.value);
        member.Zipcode = laf.verify.trim(tfZipcode.value);
        
        var callbackOK = function(response){
            if (response.Success) {
                laf.object.save('Member', member);
                editView = false;
                setProfileRows();
                post('', 'Private.svc/GetAccountProfile', loadProfile, loadProfile);
            }
            else {
                laf.window.alert('Error', 'Could not update your account, please try again. ' + response.Message);
            }
        };
        
        post(member, 'Private.svc/UpdateMemberInfo', callbackOK, undefined, false);
    }
    
    function setProfileEditRows(){
        editView = true;
        editOptions = [];
        setLeftNav(btnCancel);
        setRightNav(btnDone);
        
        var data = [];
        
        if (laf.object.isSaved('Member')) {
            var member = laf.object.load('Member');
            tfEmail.value = member.Email;
            tfHomePhone.value = member.HomePhone;
            tfCellPhone.value = member.MobilePhone;
            tfWorkPhone.value = member.WorkPhone;
            tfAddress.value = member.Address;
            tfAddress2.value = member.Address2;
            tfCity.value = member.City;
            tfState.value = member.State;
            tfZipcode.value = member.Zipcode;
        }
        
        data.push(laf.table.section('Contact Information'));
        data.push(newEditRow('E-mail:', tfEmail));
        data.push(newEditRow('Home #:', tfHomePhone));
        data.push(newEditRow('Cell #:', tfCellPhone));
        data.push(newEditRow('Work #:', tfWorkPhone));
        
        data.push(laf.table.section('Mailing Information'));
        data.push(newEditRow('Address:', tfAddress));
        data.push(newEditRow('Address 2:', tfAddress2));
        data.push(newEditRow('City:', tfCity));
        data.push(newEditRow('State:', tfState));
        data.push(newEditRow('ZIP/Postal:', tfZipcode));
        
        tvProfile.setData(data);
        laf.table.scrollToTop(tvProfile, false);
    }
    
    //=== EVENTS =============================	
    btnEdit.addEventListener('click', function(e){
        if ((laf.device.isAndroid() && (editOptions.length == 1)) || ((laf.device.isiPhone() && (editOptions.length == 2)))) {
            if (laf.network.isConnected(true)) {
                setProfileEditRows();
            }
            return;
        }
        
        if (editOptions.length > 1) {
            var dlgEdit;
            if (laf.device.isAndroid()) {
                dlgEdit = Ti.UI.createOptionDialog({
                    options: editOptions,
                    title: 'What would you like to edit?',
                    buttonNames: ['Cancel']
                });
            }
            else {
                dlgEdit = Ti.UI.createOptionDialog({
                    options: editOptions,
                    cancel: editOptions.length - 1,
                    title: 'What would you like to edit?'
                });
            }
            dlgEdit.addEventListener('click', function(e){
                if (e.index == 0 && laf.device.isAndroid() && e.button) {
                    return;
                }
                else {
                    var selected = editOptions[e.index];
                    switch (selected) {
                        case 'Personal Information':
                            if (laf.network.isConnected(true)) {
                                setProfileEditRows();
                            }
                            break;
                        case 'Billing Information':
                            laf.network.openURL('tel:1-949-255-8100', 'LA Fitness\nAutomated Billing Update');
                            break;
                        case 'Cancel':
                            break;
                        default:
                            laf.window.alert('Not Supported', 'This application must be updated to use this feature.');
                            break;
                    }
                }
            });
            dlgEdit.show();
        }
        else {
            //Personal Info update, no billing option
            if (laf.network.isConnected(true)) {
                setProfileEditRows();
            }
        }
    });
    
    btnDone.addEventListener('click', function(e){
        saveProfile();
    });
    
    btnCancel.addEventListener('click', function(e){
        setProfileRows();
    });
    
    tfEmail.addEventListener('return', function(){
        tfHomePhone.focus();
    });
    
    tfHomePhone.addEventListener('return', function(){
        tfCellPhone.focus();
    });
    
    tfCellPhone.addEventListener('return', function(){
        tfWorkPhone.focus();
    });
    
    tfWorkPhone.addEventListener('return', function(){
        tfAddress.focus();
    });
    
    tfAddress.addEventListener('return', function(){
        tfAddress2.focus();
    });
    
    tfAddress2.addEventListener('return', function(){
        tfCity.focus();
    });
    
    tfCity.addEventListener('return', function(){
        tfState.focus();
    });
    
    tfState.addEventListener('return', function(){
        tfZipcode.focus();
    });
    
    tfZipcode.addEventListener('return', function(){
        saveProfile();
    });
    
    //=== DISPLAY =============================
    vwProfile.add(vwHeader);
    vwProfile.add(tvProfile);
    
    this.hide = function(){
        vwProfile.visible = false;
        editView = false;
        setLeftNav(null);
        setRightNav(null);
    };
    
    this.refresh = function(){
        var refreshDate = new Date();
        if (loadDate == undefined || editOptions.length == 0 || (refreshDate.getTime() - loadDate.getTime()) > 120000) {
            vwActivity.show('Loading...');
            setProfileRows();
            loadProfile(); //Check for updated data			
            vwActivity.hide();
        }
        else {
            setRightNav(btnEdit);
        }
    };
    
    this.show = function(){
        vwProfile.visible = true;
    };
    
    this.view = function(){
        return vwProfile;
    };
};
