function receipts(){
    //=== HEADER & DATA =============================
    var loadDate;
    var receiptView = false;
    
    //=== OBJECTS =============================	
    var vwActivity = new activityIndicator();
    
    var vwReceipts = Ti.UI.createView({
        top: 0,
        bottom: 0
    });
    
    var tvReceiptList = Ti.UI.createTableView({
        top: 48,
        backgroundColor: 'white',
        rowBackgroundColor: 'transparent',
        separatorColor: '#e1e1e1'
    });
    
    var vwHeader = Ti.UI.createView({
        left: 0,
        right: 0,
        top: 0,
        height: 48,
        backgroundColor: '#576996'
    });
    vwHeader.add(Ti.UI.createView({
        backgroundImage: laf.path.images + 'keytag2.png',
        left: 5,
        width: 29,
        height: 29
    }));
    var lblBarcode = Ti.UI.createLabel({
        color: '#FFFFFF',
        font: {
            fontSize: 18,
            fontWeight: 'bold',
            fontFamily: 'Arial'
        },
        left: 45,
        right: 5
    });
    vwHeader.add(lblBarcode);
    
    var vwReceipt = Ti.UI.createWebView({
        top: 0,
        bottom: 0,
        scalesPageToFit: true,
        visible: false
    });
    
    var btnRightNav = Ti.UI.createButton({
        title: 'All Receipts'
    });
    
    //=== FUNCTIONS =============================
    function loadReceiptList(){
        if (laf.network.isConnected(!laf.object.isSaved('ReceiptList'))) {
            var callbackFail = function(error){
                if (!receiptView) {
                    if (laf.object.isSaved('ReceiptList')) {
                        laf.window.alert('Unable to Update', 'Could not update receipts at this time. Using data stored from last update.');
                    }
                }
            };
            
            var callbackOK = function(response){
                if (response.Success) {
                    var refreshNeeded = !laf.object.isSaved('ReceiptList') || Ti.App.Properties.getString('ReceiptList') != JSON.stringify(response.Value);
                    laf.object.save('ReceiptList', response.Value);
                    if (!receiptView) {
                        loadDate = new Date();
                        if (refreshNeeded) {
                            setReceiptListRows();
                        }
                    }
                }
                else {
                    callbackFail();
                }
            };
            
            //Background update when saved, as having asbolute latest not essential
            post('', 'Private.svc/GetReceiptList', callbackOK, callbackFail, laf.object.isSaved('ReceiptList'));
        }
        else {
            if (laf.object.isSaved('ReceiptList')) {
                laf.window.alert('Unable to Update', 'Could not update receipts at this time. Using data stored from last update.');
            }
        }
    }
    
    function setReceiptListRows(){
        receiptView = false;
        setRightNav(null);
        tvReceiptList.visible = true;
        vwReceipt.visible = false;
        
        lblBarcode.text = (laf.object.isSaved('Member')) ? laf.object.load('Member').BarcodeID : 'Account Receipts';
        
        var data = [];
        
        data.push(laf.table.section('Receipts'));
        
        var receiptList = (laf.object.isSaved('ReceiptList')) ? laf.object.load('ReceiptList') : undefined;
        if (receiptList == undefined || receiptList.length == undefined || receiptList.length == 0) {
            tvReceiptList.touchEnabled = false;
            laf.table.hideEmptyRows(tvReceiptList, false);			
            
            var tvrNoReceipts = Ti.UI.createTableViewRow({
                height: 105,
                className: 'receiptsNoReceipts'
            });
            tvrNoReceipts.add(Ti.UI.createLabel({
                color: '#7F7F7F',
                font: {
                    fontSize: 18,
                    fontFamily: 'Arial'
                },
                top: 25,
                left: 5,
                right: 5,
                height: 80,
                textAlign: 'center',
                text: 'No recent receipts were found.'
            }));
            data.push(tvrNoReceipts);
        }
        else {
            tvReceiptList.touchEnabled = true;
			laf.table.showEmptyRows(tvReceiptList);            
			
            for (var receiptItr = 0, receiptLen = receiptList.length; receiptItr < receiptLen; receiptItr++) {
                var createDate = laf.dateTime.fromString(receiptList[receiptItr].CreateDate);
                
                var tvrReceipt = Ti.UI.createTableViewRow({
                    height: 50,
                    className: 'receiptsReceiptSummary',
                    hasChild: true,
                    receiptID: receiptList[receiptItr].CustomerCommunicationID
                });
                
                tvrReceipt.add(Ti.UI.createLabel({
                    font: {
                        fontSize: 16,
                        fontWeight: 'bold',
                        fontFamily: 'Arial'
                    },
                    color: 'black',
                    top: 5,
                    left: 5,
                    right: 5,
                    height: 20,
                    text: receiptList[receiptItr].Subject
                }));
                
                tvrReceipt.add(Ti.UI.createLabel({
                    color: '#7F7F7F',
                    font: {
                        fontSize: 14,
                        fontFamily: 'Arial'
                    },
                    top: 25,
                    left: 5,
                    right: 5,
                    height: 20,
                    text: createDate.toDateString() + ' @ ' + laf.dateTime.toTimeString(createDate, true)
                }));
                
                laf.table.makeRowSelectable(tvrReceipt);
                data.push(tvrReceipt);
            }
        }
        
        tvReceiptList.setData(data);
    };
    
    function loadReceipt(receiptID){
        var callbackOK = function(response){
            if (response.Success && response.Message.length > 0) {
                try {
                    receiptView = true;
                    vwReceipt.html = response.Message;
                    setRightNav(btnRightNav);
                    vwReceipt.visible = true;
                    tvReceiptList.visible = false;
                    vwReceipt.visible = true; //Make sure displayed
                } 
                catch (er) {
                    //catch for potentially malformed html
                    receiptView = false;
                    tvReceiptList.visible = true;
                    vwReceipt.visible = false;
                    setRightNav(null);
                    laf.window.alert('Error', 'Error loading receipt at this time. Try again later.');
                }
            }
            else {
                laf.window.alert('Error', 'Could not retrieve receipt at this time. Try again later.');
            }
        };
        
        post(receiptID, 'Private.svc/GetReceipt', callbackOK, function(){
            laf.window.alert('Error', 'Could not retrieve receipt at this time. Try again later.');
        }, false);
    }
    
    //=== EVENTS =============================		
    tvReceiptList.addEventListener('click', function(e){
        if (e.rowData != undefined && e.rowData.receiptID != undefined) {
            if (laf.network.isConnected(true) && e.rowData.receiptID > 0) {
                loadReceipt(e.rowData.receiptID);
            }
        }
    });
    
    btnRightNav.addEventListener('click', function(e){
        setRightNav(null);
        tvReceiptList.visible = true;
        vwReceipt.visible = false;
    });
    
    //=== DISPLAY =============================
    vwReceipts.add(vwHeader);
    vwReceipts.add(vwReceipt);
    vwReceipts.add(tvReceiptList);
    
    this.hide = function(){
        receiptView = false;
        vwReceipts.visible = false;
    };
    
    this.refresh = function(){
        var refreshDate = new Date();
        if (loadDate == undefined || (refreshDate.getTime() - loadDate.getTime()) > 120000) {
            vwActivity.show('Loading...');
            setReceiptListRows();
            vwActivity.hide();
            
            //Check for updated rows
            loadReceiptList();
        }
        else {
            setRightNav(null);
            tvReceiptList.visible = true;
            vwReceipt.visible = false;
        }
    };
    
    this.show = function(){
        vwReceipts.visible = true;
    };
    
    this.view = function(){
        return vwReceipts;
    };
};
