(function(){
    //=== HEADER & DATA =============================
    Ti.include('../../common/winHeader.js');
    
    var selectedClubID = -1;
    var selectedClubDescription = '';
    var selectedDateStr = '';
    var thirtyMinuteIntervals = ['30 Minutes', '1 Hour', '1 Hour 30 Minutes', '2 Hours'];
    
    var data = [];
    
    //=== OBJECTS =============================	
    var vwBackground = Ti.UI.createView({
        backgroundImage: laf.path.images + 'background.png',
        left: 0,
        right: 0,
        top: 0,
        bottom: 0,
        opacity: 0.80,
        visible: false
    });
    
    var vwActivity = new activityIndicator();
    
    var tvAppointment = Ti.UI.createTableView({
        top: 0,
        bottom: 0,
        backgroundColor: 'transparent',
        rowBackgroundColor: 'transparent',
        separatorColor: '#e1e1e1'
    });
    
    var btnCancel = Ti.UI.createButton({
        title: 'Cancel'
    });
    
    function newAvailabilityRow(amenitiesID, dateAndTime, minsAvailable){
        if (minsAvailable > 120) {
            minsAvailable = 120;
        }
        
        var tvRow = Ti.UI.createTableViewRow({
            height: 40,
            hasChild: true,
            className: 'tvAppointmentRow',
            rowType: 'Availability',
            amenitiesID: amenitiesID,
            minsAvailable: minsAvailable,
            dateAndTime: dateAndTime
        });
        
        tvRow.add(Ti.UI.createLabel({
            color: 'black',
            font: {
                fontSize: 14,
                fontFamily: 'Arial'
            },
            left: 5,
            textAlign: 'left',
            text: laf.dateTime.toTimeString(dateAndTime, true)
        }));
        
        tvRow.add(Ti.UI.createLabel({
            color: '#7F7F7F',
            font: {
                fontSize: 14,
                fontFamily: 'Arial'
            },
            right: laf.table.detailsRight,
            textAlign: 'right',
            text: 'Up to ' + minsAvailable + ' minutes'
        }));
        
        return tvRow;
    }
    
    //=== FUNCTIONS =============================
	/*function addToCalendarHelper(classDate, classTime, classDetails, clubDescription, offsetHour, offsetMinutes){
        var onComplete = function(calendarID){
            if (calendarID != undefined && calendarID != -1) {
            
                var onComplete2 = function(success){
                    laf.window.fire('newReservation');
                    setTimeout(function(){
                        win.close();
                    }, 600); 
                };
                
                if (!laf.calendar.checkIfEventExist(classDate, classTime, calendarID, classDetails, clubDescription)) {
                    laf.calendar.addEvent(classDate, classTime, calendarID, classDetails, clubDescription, 10, offsetHour, offsetMinutes, onComplete2);
                }
            }
            else {
                laf.window.fire('newReservation');
                setTimeout(function(){
                    win.close();
                }, 600);
            }
        };
        laf.calendar.picker(onComplete);
    }*/
    
    function friendlyTime(minutes){
        var thirtyMinuteGroups = minutes / 30;
        if (minutes % 30 == 0 && thirtyMinuteGroups < 5) {
            return thirtyMinuteIntervals[thirtyMinuteGroups - 1];
        }
        else {
            return minutes + ' Minutes';
        }
    }
    
    function loadClub(clubID){
        //Verify club has racquetball courts
        var hasRacquetball = laf.data.clubSet('SELECT CLUB_ID FROM ClubAmenity WHERE CLUB_ID = \'' + clubID + '\' AND ClubAmenity.AmenityID = \'1\'', ['ClubID']);
        if (hasRacquetball != undefined && hasRacquetball.length > 0) {
            selectedClubDescription = laf.data.clubScalar('Select DESCRIPTION FROM Club WHERE CLUB_ID = \'' + clubID + '\'');
            selectedClubID = (laf.object.isNullOrEmpty(selectedClubDescription)) ? -1 : clubID;
        }
    }
    
    function createAppointment(amenitiesID, dateAndTime, minsAvailable){
        var options = [];
        
        while (minsAvailable > 0) {
            options.push(friendlyTime(minsAvailable));
            minsAvailable -= 30;
        }
        
        if (laf.device.isiPhone()) {
            options.push('Cancel');
        }
        
        var dlgApptOptions = Ti.UI.createOptionDialog({
            options: options,
            title: 'Create New Reservation\n' + dateAndTime.toDateString() + ' @ ' + laf.dateTime.toTimeString(dateAndTime)
        });
        
        if (laf.device.isAndroid()) {
            dlgApptOptions.buttonNames = ['Cancel'];
        }
        
        if (laf.device.isiPhone()) {
            dlgApptOptions.cancel = options.length - 1;
        }
        
        dlgApptOptions.addEventListener('click', function(e){
            if (laf.device.isiPhone() && e.index == options.length - 1 || laf.device.isAndroid() && e.index == 0 && e.button) {
                return; //cancel button
            }
            
            if (laf.device.isAndroid() && options[e.index] == undefined) {
                return; //cancel button for Android
            }
            
            var apptMin = (laf.device.isiPhone()) ? (options.length - 1 - e.index) * 30 : (options.length - e.index) * 30;
            
            var adConfirmAppt = Ti.UI.createAlertDialog({
                title: 'Confirm Reservation',
                message: 'Schedule a court reservation for\n' + selectedClubDescription + '\n' + dateAndTime.toDateString() +
                ' @ ' +
                laf.dateTime.toTimeString(dateAndTime) +
                '\nfor ' +
                options[e.index] +
                '?',
                buttonNames: (laf.device.isiPhone()) ? ['Cancel', 'Reserve'] : ['Reserve', 'Cancel']
            });
            adConfirmAppt.addEventListener('click', function(e){
                if ((laf.device.isiPhone() && e.index == 1) || (!laf.device.isiPhone() && e.index == 0)) {
                    var callbackFailCreate = function(){
                        laf.window.alert('Unable to Make Reservation', 'There was an error reserving your court. Please try again or contact the club directly.');
                    };
                    var callbackOKCreate = function(response){
                        if (response.Success) {
                        
                            //Add to local collection of appointments
                            var newAppt = {
                                AmenititesAppointmentID: parseInt(response.Value.AmenititesAppointmentID, 10),
                                AmenityDescription: response.Value.AmenityDescription,
                                ClubDescription: response.Value.ClubDescription,
                                ClubID: response.Value.ClubID,
                                EndTime: response.Value.EndTime,
                                Notes: response.Value.AmenityDescription,
                                StartTime: response.Value.StartTime
                            };
                            
                            var rAppts = [];
                            if (laf.object.isSaved('AmenitiesAppointments')) {
                                rAppts = laf.object.load('AmenitiesAppointments');
                                if (laf.object.isNullOrEmpty(rAppts)) {
                                    rAppts = [];
                                }
                            }
                            rAppts.push(newAppt);
                            laf.object.save('AmenitiesAppointments', rAppts);
                            
                            /*if (laf.device.isAndroid()) {
                                var classDate = laf.dateTime.fromString(newAppt.StartTime);
                                var offsetMinutes = ((apptMin / 60).toString().indexOf('.5') != -1) ? 30 : 0;
                                var offsetHour = apptMin / 60;
                                addToCalendarHelper(classDate, classDate, 'Club: ' + newAppt.ClubDescription, newAppt.Notes, offsetHour, offsetMinutes);
                            }*/
                            //else {
                                laf.window.fire('newReservation');
                                setTimeout(function(){
                                    win.close();
                                }, 600);
                            //}   
                        }
                        else {
                            laf.window.alert('Unable to Make Reservation', response.Message);
                            setReservationRows(); //Refresh the schedule, possibly an already filled appointment
                        }
                    };
                    
                    var createAmenityAppointmentQuery = {
                        AmenitiesApptTypeID: 1,
                        AmenityID: amenitiesID,
                        StartDate: laf.dateTime.toString(dateAndTime, 'Unspecified'),
                        StartDateUTC: laf.dateTime.toString(dateAndTime, 'UTC'),
                        Duration: apptMin,
                        Notes: 'Racquetball Court',
                        ClubID: selectedClubID,
                        ClubDescription: selectedClubDescription
                    };
                    
                    post(createAmenityAppointmentQuery, 'Private.svc/CreateAmenityAppointment_2', callbackOKCreate, callbackFailCreate);
                }
            });
            adConfirmAppt.show();
            
        });
        dlgApptOptions.show();
    }
    
    function setAvailabilityRows(){
        var callbackFail = function(error){
            laf.window.alert('Unable to Get Availability', 'There was an error retrieving the availability for this club & date. Please try again or contact the club directly.');
            tvAppointment.setData(data);
            laf.table.scrollToTop(tvAppointment, false);
        };
        
        var callbackOK = function(response){
            if (response.Success) {
                var availability = response.Value;
                data.push(laf.table.section('Availability'));
                
                if (!laf.object.isNullOrEmpty(availability)) {
                    for (var availItr = 0, availLen = availability.length; availItr < availLen; availItr++) {
                        var currAvail = availability[availItr];
                        data.push(newAvailabilityRow(currAvail.AmenitiesID, laf.dateTime.fromString(currAvail.DateAndTime), currAvail.MinsAvailable));
                    }
                }
                else {
                    data.push(laf.table.infoRow('There is no racquetball availability for this club and date. Please change the club or date above.'));
                }
            }
            else {
                laf.window.alert('Unable to Get Availability', 'There was an error retrieving the availability for this club & date. Please try again or contact the club directly.');
            }
            
            tvAppointment.setData(data);
            laf.table.scrollToTop(tvAppointment, false);
        };
        
        post({
            AvailabilityDate: selectedDateStr,
            AmenityTypeID: 1,
            ClubID: selectedClubID
        }, 'Private.svc/GetAmenityAvailability', callbackOK, callbackFail);
    }
    
    function setReservationRows(){
        data = [];
        
        data.push(laf.table.section('New Racquetball Reservation'));
        
        if (!laf.object.isSaved('Member') || laf.object.load('Member').HasCourts == false) {
            //enable background image when membership does not include courts
            vwBackground.visible = true;
            
            tvAppointment.touchEnabled = false;
            laf.table.hideEmptyRows(tvAppointment, false);
            
            var strAddReservation = 'You membership does not include the courts amenity, which is required to reserve racquetball courts. Without the amenity, you may still pay a daily fee at checkin and have use of the courts.\n\nContact your local club for more details.';
            var tvrNoCourts = Ti.UI.createTableViewRow({
                height: 220,
                className: 'RacquetballNoCoutrs'
            });
            tvrNoCourts.add(Ti.UI.createLabel({
                color: 'white',
                font: {
                    fontSize: 18,
                    fontFamily: 'Arial'
                },
                top: 20,
                left: 5,
                right: 5,
                height: 200,
                textAlign: 'left',
                text: strAddReservation
            }));
            data.push(tvrNoCourts);
            tvAppointment.setData(data);
            laf.table.scrollToTop(tvAppointment, false);
        }
        else {
            //Make background image invisible when membership does include courts	
            vwBackground.visible = false;
            
            tvAppointment.touchEnabled = true;
            laf.table.showEmptyRows(tvAppointment);
            
            var clubDefined = selectedClubDescription != undefined && selectedClubDescription.length > 0;
            var dateDefined = selectedDateStr != undefined && selectedDateStr.length > 0;
            
            data.push(laf.table.actionRow((clubDefined) ? selectedClubDescription : 'Select a Club...', 'SelectClub', 40, 'club.png'));
            data.push(laf.table.actionRow((dateDefined) ? laf.dateTime.fromString(selectedDateStr).toDateString() : 'Select a Date...', 'SelectDate', 40, 'calendar.png'));
            
            if (clubDefined && dateDefined) {
                setAvailabilityRows();
            }
            else {
                tvAppointment.setData(data);
                laf.table.scrollToTop(tvAppointment, false);
            }
        }
    };
    
    //=== EVENTS =============================		
    tvAppointment.addEventListener('click', function(e){
        tvAppointment.touchEnabled = false;
        if (e.rowData != undefined && e.rowData.rowType != undefined) {
            switch (e.rowData.rowType) {
                case 'SelectClub':
                    laf.window.create('Locations', '/views/common/clubPicker.js', {
                        showRacquetballOnly: true,
                        selectedClubDescription: selectedClubDescription
                    });
                    laf.window.open();
                    break;
                case 'SelectDate':
                    laf.window.create('Date', '/views/common/dayPicker.js', {
                        startDay: 0,
                        endDay: 8,
                        selectedDateStr: selectedDateStr
                    });
                    laf.window.open();
                    break;
                case 'Availability':
                    if (e.rowData.amenitiesID > 0 && e.rowData.minsAvailable > 0) {
                        createAppointment(e.rowData.amenitiesID, e.rowData.dateAndTime, e.rowData.minsAvailable);
                    }
                    break;
            }
        }
        tvAppointment.touchEnabled = true;
    });
    
    btnCancel.addEventListener('click', function(e){
        win.close();
    });
    
    laf.window.listen('clubSelected', function(e){
        tvAppointment.touchEnabled = false;
        //vwActivity.show('Loading...');
        loadClub(e.clubID);
        setReservationRows();
        //vwActivity.hide();
        tvAppointment.touchEnabled = true;
    });
    
    laf.window.listen('daySelected', function(e){
        tvAppointment.touchEnabled = false;
        //vwActivity.show('Loading...');
        selectedDateStr = e.dateStr;
        setReservationRows();
        //vwActivity.hide();
        tvAppointment.touchEnabled = true;
    });
    
    //=== DISPLAY =============================
    vwActivity.show('Loading...');
    loadClub(laf.object.isSaved('Member') ? parseInt(laf.object.load('Member').ClubID, 10) : -1);
    selectedDateStr = '';
    setReservationRows();
    vwMain.add(vwBackground);
    vwMain.add(tvAppointment);
    setLeftNav(btnCancel);
    vwActivity.hide();
})();
