(function(){
    //=== HEADER & DATA =============================
    Ti.include('../../common/winHeader.js');
    
    var selectedClubID = -1;
    var selectedClubDescription = '';
    var selectedDateStr = '';
    var selectedTrainerName = '';
    var selectedTrainerDexRowID = '';
    var thirtyMinuteIntervals = ['30 Minutes', '1 Hour', '1 Hour 30 Minutes', '2 Hours'];
    var data = [];
    
    //=== OBJECTS =============================	
    var vwActivity = new activityIndicator();
    
    var vwTraining = Ti.UI.createView({
        top: 0,
        bottom: 0
    });
    
    var vwHeader = Ti.UI.createView({
        left: 0,
        right: 0,
        top: 0,
        height: 48,
        backgroundColor: '#576996',
        visible: false
    });
    vwHeader.add(Ti.UI.createView({
        backgroundImage: laf.path.images + 'clock.png',
        left: 5,
        width: 29,
        height: 29
    }));
    var lblSessions = Ti.UI.createLabel({
        color: '#FFFFFF',
        font: {
            fontSize: 14,
            fontWeight: 'bold',
            fontFamily: 'Arial'
        },
        left: 45
    });
    vwHeader.add(lblSessions);
    
    var tvAppointment = Ti.UI.createTableView({
        top: 0,
        backgroundColor: 'white',
        rowBackgroundColor: 'transparent',
        separatorColor: '#e1e1e1'
    });
    
    var btnCancel = Ti.UI.createButton({
        title: 'Cancel'
    });
    
    function newAvailabilityRow(proposedScheduleID, trainerID, trainerName, dateAndTime, minsAvailable){
        if (minsAvailable > 60) {
            minsAvailable = 60;
        }
        
        var tvRow = Ti.UI.createTableViewRow({
            height: 40,
            hasChild: true,
            className: 'tvAppointmentRow',
            rowType: 'Availability',
            trainerID: trainerID,
            minsAvailable: minsAvailable,
            dateAndTime: dateAndTime,
            proposedScheduleID: proposedScheduleID,
            trainerName: trainerName
        });
        
        tvRow.add(Ti.UI.createLabel({
            color: 'black',
            font: {
                fontSize: 14,
                fontWeight: 'bold',
                fontFamily: 'Arial'
            },
            top: 2,
            left: 5,
            height: 20,
            textAlign: 'left',
            text: laf.dateTime.toTimeString(dateAndTime, true)
        }));
        
        tvRow.add(Ti.UI.createLabel({
            color: '#7F7F7F',
            font: {
                fontSize: 14,
                fontFamily: 'Arial'
            },
            top: 22,
            left: 5,
            right: laf.table.detailsRight + 110,
            height: 20,
            textAlign: 'left',
            text: trainerName
        }));
        
        tvRow.add(Ti.UI.createLabel({
            color: '#7F7F7F',
            font: {
                fontSize: 14,
                fontFamily: 'Arial'
            },
            right: laf.table.detailsRight,
            textAlign: 'right',
            text: 'Up to ' + minsAvailable + ' minutes'
        }));
        
        laf.table.makeRowSelectable(tvRow);
        return tvRow;
    }
    
    function newTrainerAvailabilityRow(proposedScheduleID, trainerID, dateAndTime, minsAvailable){	
        var tvRow = Ti.UI.createTableViewRow({
            height: 40,
            hasChild: true,
            className: 'tvTrainerAvailabilityRow',
            rowType: 'TrainerAvailability',
            proposedScheduleID: proposedScheduleID,
			trainerID: trainerID,
			dateAndTime: dateAndTime,
			minsAvailable: minsAvailable
        });
        
        tvRow.add(Ti.UI.createLabel({
            color: 'black',
            font: {
                fontSize: 14,
                fontFamily: 'Arial'
            },
            left: 5,
            textAlign: 'left',
            text: laf.dateTime.toTimeString(dateAndTime, true)
        }));
        
        tvRow.add(Ti.UI.createLabel({
            color: '#7F7F7F',
            font: {
                fontSize: 14,
                fontFamily: 'Arial'
            },
            right: laf.table.detailsRight,
            textAlign: 'right',
            text: 'Up to ' + minsAvailable + ' minutes'
        }));
        
        laf.table.makeRowSelectable(tvRow);
        return tvRow;
    }
    
    //=== FUNCTIONS =============================
    /*function addToCalendarHelper(classDate, classTime, classDetails, clubDescription, offsetHour, offsetMinutes){
        var onComplete = function(calendarID){
            if (calendarID != undefined && calendarID != -1) {
            
                var onComplete2 = function(success){
                    laf.window.fire('newReservation');
                    setTimeout(function(){
                        win.close();
                    }, 600);
                };
                
                if (!laf.calendar.checkIfEventExist(classDate, classTime, calendarID, classDetails, clubDescription)) {
                    laf.calendar.addEvent(classDate, classTime, calendarID, classDetails, clubDescription, 10, offsetHour, offsetMinutes, onComplete2);
                }
            }
            else {
                laf.window.fire('newReservation');
                setTimeout(function(){
                    win.close();
                }, 600);
            }
        };
        laf.calendar.picker(onComplete);
    }*/
    
    function friendlyTime(minutes){
        var thirtyMinuteGroups = minutes / 30;
        if (minutes % 30 == 0 && thirtyMinuteGroups < 5) {
            return thirtyMinuteIntervals[thirtyMinuteGroups - 1];
        }
        else {
            return minutes + ' Minutes';
        }
    }
    
    function loadClub(clubID){
        selectedClubDescription = laf.data.clubScalar('Select DESCRIPTION FROM Club WHERE CLUB_ID = \'' + clubID + '\'');
        selectedClubID = (selectedClubDescription != undefined && selectedClubDescription.length > 0) ? clubID : -1;
    }
    
    function createAppointment(proposedScheduleID, dateAndTime, minsAvailable, trainer){
        var options = [];
        
        while (minsAvailable > 0) {
            options.push(friendlyTime(minsAvailable));
            minsAvailable -= 30;
        }
        
        if (laf.device.isiPhone()) {
            options.push('Cancel');
        }
        
        var dlgApptOptions = Ti.UI.createOptionDialog({
            options: options,
            title: 'Create New Reservation\n' + dateAndTime.toDateString() + ' @ ' + laf.dateTime.toTimeString(dateAndTime)
        });
        
        if (laf.device.isAndroid()) {
            dlgApptOptions.buttonNames = ['Cancel'];
        }
        
        if (laf.device.isiPhone()) {
            dlgApptOptions.cancel = options.length - 1;
        }
        
        dlgApptOptions.addEventListener('click', function(e){
            if (laf.device.isiPhone() && e.index == options.length - 1 || laf.device.isAndroid() && e.index == 0 && e.button) {
                return; //cancel button
            }
            
            if (laf.device.isAndroid() && options[e.index] == undefined) {
                return; //cancel button for android
            }
            
            var apptMin = (laf.device.isiPhone()) ? (options.length - 1 - e.index) * 30 : (options.length - e.index) * 30;
            
            var adConfirmAppt = Ti.UI.createAlertDialog({
                title: 'Confirm Reservation',
                message: 'Schedule a reservation for\n' + selectedClubDescription + '\n' + dateAndTime.toDateString() +
                ' @ ' +
                laf.dateTime.toTimeString(dateAndTime) +
                '\nfor ' +
                options[e.index] +
                '?',
                buttonNames: (laf.device.isiPhone()) ? ['Cancel', 'Reserve'] : ['Reserve', 'Cancel']
            });
            adConfirmAppt.addEventListener('click', function(e){
                if ((laf.device.isiPhone() && e.index == 1) || (!laf.device.isiPhone() && e.index == 0)) {
                    var callbackFailCreate = function(){
                        laf.window.alert('Unable to Make Reservation', 'There was an error making your reservation. Please try again or contact the club directly.');
                    };
                    var callbackOKCreate = function(response){
                        if (response.Success) {
                        
                            //Add to local collection of appointments
                            var tAppts = [];
                            if (laf.object.isSaved('TrainingAppointments')) {
                                tAppts = laf.object.load('TrainingAppointments');
                                if (laf.object.isNullOrEmpty(tAppts)) {
                                    tAppts = [];
                                }
                            }
                            
                            var newAppts = response.Value;
                            for (var newApptItr = 0, newApptLen = newAppts.length; newApptItr < newApptLen; newApptItr++) {
                                var currAppt = newAppts[newApptItr];
                                
                                //Some values in currAppt maybe null or zero, but we don't use them
                                var newAppt = {
                                    Club: {
                                        Description: selectedClubDescription,
                                        ID: selectedClubID
                                    },
                                    Consumed: (currAppt.Consumed == undefined || currAppt.Consumed == 0) ? false : true,
                                    Durration: parseInt(currAppt.Durration, 10),
                                    EndDateTime: currAppt.EndDateTime,
                                    FitnessCustomerID: currAppt.FitnessCustomerID,
                                    ID: parseInt(currAppt.ID, 10),
                                    StartDateTime: currAppt.StartDateTime,
                                    Trainer: {
                                        ID: currAppt.Trainer.ID,
                                        Name: trainer
                                    },
                                    TrainingCustomerID: parseInt(currAppt.TrainingCustomerID, 10)
                                };
                                tAppts.push(newAppt);
                            }
                            
                            laf.object.save('TrainingAppointments', tAppts);
                            
                            /*if (laf.device.isAndroid()) {
                             var classDate = laf.dateTime.fromString(newAppt.StartDateTime);
                             var offsetMinutes = ((apptMin / 60).toString().indexOf('.5') != -1) ? 30 : 0;
                             var offsetHour = apptMin / 60;
                             addToCalendarHelper(classDate, classDate, 'Club: ' + newAppt.Club.Description, 'Personal Trainer: ' + newAppt.Trainer.Name, offsetHour, offsetMinutes);
                             }*/
                            //else {
                            laf.window.fire('newReservation');
                            setTimeout(function(){
                                win.close();
                            }, 600);
                            //}
                        }
                        else {
                            laf.window.alert('Unable to Make Reservation', response.Message);
                            setReservationRows(); //Refresh the schedule, possibly an already filled appointment
                        }
                    };
                    
                    var createTrainingAppointmentQuery = {
                        ProposedScheduleID: proposedScheduleID,
                        StartDateTime: laf.dateTime.toString(dateAndTime, 'Unspecified'),
                        UTCStartDateTime: laf.dateTime.toString(dateAndTime, 'UTC'),
                        Duration: apptMin,
                        ClubDescription: selectedClubDescription
                    };
                    
                    post(createTrainingAppointmentQuery, 'Private.svc/CreateTrainingAppointment', callbackOKCreate, callbackFailCreate);
                }
            });
            adConfirmAppt.show();
            
        });
        dlgApptOptions.show();
    }
    
    function setAppointmentRows(){
        var callbackFailQuery = function(error){
            laf.window.alert('Unable to Get Availability', 'There was an error retrieving the availability for this club & trainer. Please try again or contact the club directly.');
            tvAppointment.setData(data);
            laf.table.scrollToTop(tvAppointment, false);
        };
        
        var callbackOKQuery = function(response){
            if (response.Success) {
            
                var trainerAppt = response.Value;
                var currentDate = '';
                
                if (trainerAppt != undefined && trainerAppt.length > 0) {
                
                    currentDate = laf.dateTime.fromString(trainerAppt[0].StartDateTime).toDateString();
                    data.push(laf.table.section(currentDate));
                    
                    for (var trainerApptItr = 0, trainerApptLen = trainerAppt.length; trainerApptItr < trainerApptLen; trainerApptItr++) {
                        var currTrainerAppt = trainerAppt[trainerApptItr];
                        
                        if (currentDate.indexOf(laf.dateTime.fromString(currTrainerAppt.StartDateTime).toDateString()) == -1) {
                            currentDate = laf.dateTime.fromString(currTrainerAppt.StartDateTime).toDateString();
                            data.push(laf.table.section(currentDate));
                        }
						data.push(newTrainerAvailabilityRow(currTrainerAppt.ProposedScheduleID, currTrainerAppt.Trainer.ID, laf.dateTime.fromString(currTrainerAppt.StartDateTime), currTrainerAppt.Durration));							
                    }
                }
                else {
                    data.push(laf.table.section('Appointment'));
                    data.push(laf.table.infoRow('There is no appointment available for this club and trainer. Please change the club or trainer above.'));
                }
            }
            else {
                laf.window.alert('Unable to Get Appointments', 'There was an error retrieving a list of appointments. Please try again or contact the club directly.');
            }
            tvAppointment.setData(data);
            laf.table.scrollToTop(tvAppointment, false);
        };
        
        var appointmentQuery = {
            ClubID: selectedClubID,
            DexRowID: selectedTrainerDexRowID
        };
        
        post(appointmentQuery, 'Private.svc/GetTrainerAvailability', callbackOKQuery, callbackFailQuery);
    }
    
    function setAvailabilityRows(){
        var callbackFail = function(error){
            laf.window.alert('Unable to Get Availability', 'There was an error retrieving the availability for this club & date. Please try again or contact the club directly.');
            tvAppointment.setData(data);
            laf.table.scrollToTop(tvAppointment, false);
        };
        
        var callbackOK = function(response){
            if (response.Success) {
                var availability = response.Value;
                if (availability != undefined && availability.length > 0) {
                    var hourSection = '';
                    
                    for (var availItr = 0, availLen = availability.length; availItr < availLen; availItr++) {
                        var currAvail = availability[availItr];
                        var currTimeStr = laf.dateTime.toTimeString(laf.dateTime.fromString(currAvail.StartDateTime)).replace('12:30PM', 'Noon').replace(':30', '');
                        
                        if (hourSection != currTimeStr) {
                            hourSection = currTimeStr;
                            data.push(laf.table.section(hourSection));
                        }
                        data.push(newAvailabilityRow(currAvail.ProposedScheduleID, currAvail.Trainer.ID, currAvail.Trainer.Name, laf.dateTime.fromString(currAvail.StartDateTime), currAvail.Durration));
                    }
                }
                else {
                    data.push(laf.table.section('Availability'));
                    data.push(laf.table.infoRow('There is no personal training availability for this club and date. Please change the club or date above.'));
                }
            }
            else {
                laf.window.alert('Unable to Get Availability', 'There was an error retrieving the availability for this club & date. Please try again or contact the club directly.');
            }
            
            tvAppointment.setData(data);
            laf.table.scrollToTop(tvAppointment, false);
        };
        
        post({
            AppointmentDate: selectedDateStr,
            ClubID: selectedClubID
        }, 'Private.svc/GetTrainingSchedule', callbackOK, callbackFail); //, !laf.device.isiPhone());
    }
    
    function setReservationRows(){
        data = [];
        
        //Show header with current training info
        if (laf.object.isSaved('Member')) {
            var member = laf.object.load('Member');
            if (!laf.object.isNullOrEmpty(member.Total30MinSessions)) {
                lblSessions.text = '';
                if (!laf.object.isNullOrEmpty(member.Total60MinSessions)) {
                    lblSessions.text += '60 Minute Sessions: ' + member.Total60MinSessions + '\n';
                }
                lblSessions.text += '30 Minute Sessions: ' + member.Total30MinSessions;
                vwHeader.visible = true;
                tvAppointment.top = 48;
            }
            else {
                vwHeader.visible = false;
                tvAppointment.top = 0;
            }
        }
        else {
            vwHeader.visible = false;
            tvAppointment.top = 0;
        }
        
        data.push(laf.table.section('New Training Reservation'));
        
        var clubDefined = selectedClubDescription != undefined && selectedClubDescription.length > 0;
        var dateDefined = selectedDateStr != undefined && selectedDateStr.length > 0;
        var trainerDefined = selectedTrainerName != undefined && selectedTrainerName.length > 0;
        
        data.push(laf.table.actionRow((clubDefined) ? selectedClubDescription : 'Select a Club...', 'SelectClub', 40, 'club.png'));
		
        if (trainerDefined) {
            data.push(laf.table.actionRow(selectedTrainerName, 'SelectDateOrTrainer', 40, 'weightLift.png'));
		} else {
            data.push(laf.table.actionRow((dateDefined) ? laf.dateTime.fromString(selectedDateStr).toDateString() : 'Select a Date\/' + 'Trainer...', 'SelectDateOrTrainer', 40, 'calendar.png'));
        }
        
        if (clubDefined && dateDefined) {
			setAvailabilityRows();
		}
		else {
			if (clubDefined && trainerDefined) {
				setAppointmentRows();
			}
			else {
				tvAppointment.setData(data);
				laf.table.scrollToTop(tvAppointment, false);
			}
		}
    };
    
    //=== EVENTS =============================		
    tvAppointment.addEventListener('click', function(e){
        tvAppointment.touchEnabled = false;
        if (e.rowData != undefined && e.rowData.rowType != undefined) {
            switch (e.rowData.rowType) {
                case 'SelectClub':
                    laf.window.create('Locations', '/views/common/clubPicker.js', {
                        showRacquetballOnly: false,
                        selectedClubDescription: selectedClubDescription
                    });
                    laf.window.open();
                    break;
                case 'SelectDateOrTrainer':
                    var options;
                    if (laf.device.isAndroid()) {
                        options = ['Date', 'Trainer'];
                    }
                    else {
                        options = ['Date', 'Trainer', 'Cancel']; //.push('Cancel');
                    }
                    
                    var odDateOrTrainer = Ti.UI.createOptionDialog({
                        title: 'What would you like to search by?',
                        options: options
                    });
                    
                    if (laf.device.isAndroid()) {
                        odDateOrTrainer.buttonNames = ['Cancel'];
                    }
                    else {
                        odDateOrTrainer.cancel = options.length - 1;
                    }
                    
                    odDateOrTrainer.addEventListener('click', function(e){
                        if ((laf.device.isAndroid() && ((e.index == 0 && e.button) || options[e.index] == undefined)) ||
                        (!laf.device.isAndroid() && e.index == options.length - 1)) {
                            return; //Cancel button
                        }
                        
                        if (e.index == 0) {
                            laf.window.create('Date', '/views/common/dayPicker.js', {
                                startDay: 1,
                                endDay: 14,
                                selectedDateStr: selectedDateStr
                            });
                            laf.window.open();
                        }
                        if (e.index == 1) {
                            laf.window.create('Trainer', '/views/reservations/trainerPicker.js', {
                                selectedClubID: selectedClubID,
								selectedTrainerDexRowID: selectedTrainerDexRowID
                            });
                            laf.window.open();
                        }
                    });
                    
                    odDateOrTrainer.show();
                    break;
                case 'Availability':
                    if (e.rowData.proposedScheduleID > 0 && e.rowData.minsAvailable > 0) {
                        createAppointment(e.rowData.proposedScheduleID, e.rowData.dateAndTime, e.rowData.minsAvailable, e.rowData.trainerName);
                    }
                    break;
                case 'TrainerAvailability':
                    if (e.rowData.proposedScheduleID > 0 && e.rowData.minsAvailable > 0) {
                        createAppointment(e.rowData.proposedScheduleID, e.rowData.dateAndTime, e.rowData.minsAvailable, selectedTrainerName);
                    }
                    break;
            }
        }
        tvAppointment.touchEnabled = true;
    });
    
    btnCancel.addEventListener('click', function(e){
        win.close();
    });
    
    laf.window.listen('clubSelected', function(e){
        tvAppointment.touchEnabled = false;
        //vwActivity.show('Loading...');
        loadClub(e.clubID);
        selectedTrainerName = '';
        selectedTrainerDexRowID = '';
        setReservationRows();
        //vwActivity.hide();
        tvAppointment.touchEnabled = true;
    });
    
    laf.window.listen('daySelected', function(e){
        tvAppointment.touchEnabled = false;
        //vwActivity.show('Loading...');
        selectedDateStr = e.dateStr;
        selectedTrainerName = '';
        selectedTrainerDexRowID = '';
        setReservationRows();
        //vwActivity.hide();
        tvAppointment.touchEnabled = true;
    });
    
    laf.window.listen('trainerSelected', function(e){
        tvAppointment.touchEnabled = false;
        //vwActivity.show('Loading...');
        selectedTrainerName = e.trainerName;
        selectedTrainerDexRowID = e.trainerDexRowID;
        selectedDateStr = '';
        setReservationRows();
        //vwActivity.hide();
        tvAppointment.touchEnabled = true;
    });
    
    //=== DISPLAY =============================
    vwActivity.show('Loading...');
    loadClub(laf.object.isSaved('Member') ? parseInt(laf.object.load('Member').ClubID, 10) : -1);
    selectedDateStr = '';
    setReservationRows();
    vwMain.add(vwHeader);
    vwMain.add(tvAppointment);
    setLeftNav(btnCancel);
    vwActivity.hide();
})();
