function clubClasses(){
    //=== HEADER & DATA =============================
    //Ti.include('../../common/lafCalendar.js');
    
    var loadDate;
    var filteredClassID = -1;
    var classes = [];
    var classDetails = {};
    var classSchedule = [];
    var weekView = false;
    var daysOfWeek = ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'];
    
    //=== OBJECTS =============================
    var vwActivity = new activityIndicator();
    
    var tvClubClasses = Ti.UI.createTableView({
        top: 48,
        backgroundColor: 'white',
        rowBackgroundColor: 'transparent',
        separatorColor: '#e1e1e1'
    });
    
    var btnRightNav = Ti.UI.createButton({
        title: 'All Classes'
    });
    
    //=== FUNCTIONS =============================
    function loadClasses(){
        classes = laf.data.clubSet('SELECT DISTINCT ClassSchedule.CLASSES_ID, Class.NAME FROM ClassSchedule INNER JOIN Class on ClassSchedule.CLASSES_ID = Class.CLASSES_ID WHERE CLUB_ID =\'' + clubID + '\' ORDER BY Class.NAME', ['ClassID', 'Name']);
    }
    
    function loadSchedule(){
        classes = laf.data.clubSet('SELECT DISTINCT ClassSchedule.CLASSES_ID, Class.NAME, (DAY_ID-1) AS DAY_ID, strftime("%m/%d/%Y %H:%M:%S", t1.Time) AS START_TIME FROM ClassSchedule INNER JOIN Class on ClassSchedule.CLASSES_ID = Class.CLASSES_ID JOIN Time t1 on t1.TimeID=ClassSchedule.START_TIME WHERE CLUB_ID =\'' + clubID + '\' ORDER BY DAY_ID, START_TIME', ['ClassID', 'Name', 'DayID', 'Start']);
    }
    
    function loadClassDetails(classID){
        classDetails = laf.data.clubRow('SELECT CLASSES_ID, NAME, DESCRIPTION FROM Class WHERE CLASSES_ID = \'' + classID + '\'', ['ClassID', 'Name', 'Description']);
        classSchedule = laf.data.clubSet('SELECT (DAY_ID-1) AS DAY_ID, strftime("%m/%d/%Y %H:%M:%S", t1.Time) AS START_TIME FROM ClassSchedule cs JOIN Time t1 on t1.TimeID=cs.START_TIME WHERE CLUB_ID =\'' + clubID + '\' AND CLASSES_ID =\'' + classID + '\' ORDER BY DAY_ID, START_TIME', ['DayID', 'Start']);
    }
    
    function newClassRow(classID, name){
        var tvRow = Ti.UI.createTableViewRow({
            height: 40,
            hasChild: true,
            className: 'clubClassesClass',
            rowType: 'Class',
            classID: classID
        });
        
        tvRow.add(Ti.UI.createLabel({
            color: 'black',
            font: {
                fontSize: 16
            },
            left: 5,
            text: name
        }));
        
        laf.table.makeRowSelectable(tvRow);
        return tvRow;
    }
    
    function newClassHeaderRow(classID, name, image){
        var tvRow = Ti.UI.createTableViewRow({
            height: 40,
            hasChild: true,
            className: 'clubClassesClass',
            rowType: 'Class'
        });
        
        tvRow.add(Ti.UI.createLabel({
            color: 'black',
            font: {
                fontSize: 16
            },
            left: 40,
            text: name
        }));
        
        tvRow.add(Ti.UI.createView({
            backgroundImage: laf.path.images + image,
            left: 5
        }));
        
        laf.table.makeRowSelectable(tvRow);
        return tvRow;
    }
    
    function newClassScheduleRow(classID, classTitle, classTime){
        var tvRow = Ti.UI.createTableViewRow({
            height: 30,
            hasChild: (laf.device.isiPhone()) ? false : true,
            className: 'clubClassesSchedule',
            rowType: 'Class',
            classID: classID
        });
        
        tvRow.add(Ti.UI.createLabel({
            color: 'black',
            font: {
                fontSize: 17,
                fontFamily: 'Arial',
                fontWeight: 'bold'
            },
            top: 2,
            left: 5,
            height: 26,
            text: laf.dateTime.toTimeString(classTime)
        }));
        
        tvRow.add(Ti.UI.createLabel({
            color: 'black',
            font: {
                fontSize: 17,
                fontFamily: 'Arial'
            },
            top: 2,
            left: 80,
            height: 26,
            text: classTitle
        }));
        
        laf.table.makeRowSelectable(tvRow);
        return tvRow;
    }
    
    function newClassDetailRow(classDayID, classTime){
        var tvRow = Ti.UI.createTableViewRow({
            height: 40,
            hasChild: true,
            rowType: 'ClassDetail',
            classTime: classTime,
            classDay: classDayID,
            className: 'clubClassesClassDetail'
        });
        
        tvRow.add(Ti.UI.createLabel({
            color: 'black',
            font: {
                fontSize: 20,
                fontFamily: 'Arial'
            },
            left: 45,
            text: laf.dateTime.toTimeString(classTime)
        }));
        
        tvRow.add(Ti.UI.createView({
            backgroundImage: laf.path.images + 'calendar.png',
            left: 5,
            width: 29,
            height: 29
        }));
        
        laf.table.makeRowSelectable(tvRow);
        return tvRow;
    }
    
    function newFavoriteRow(){
        var isFavoriteClass = false;
        var favoriteClasses = Ti.App.Properties.getString('FavoriteClasses').split(',');
        if (favoriteClasses.length > 0) {
            isFavoriteClass = favoriteClasses.indexOf(clubID + '|' + filteredClassID) >= 0;
        }
        
        if (isFavoriteClass) {
            return laf.table.actionRow('Remove from Favorites', 'Favorite', 50, 'favoriteRemove.png', true);
        }
        else {
            return laf.table.actionRow('Add to Favorites', 'Favorite', 50, 'favoriteAdd.png', true);
        }
    }
    
    function setClubClassRows(){
        var data = [];
        if (laf.device.isiPhone()) {
            tvClubClasses.setIndex(null);
        }
        
        setRightNav(null);
        
        filteredClassID = -1;
			
        data.push(laf.table.actionRow('Switch to Schedule View', 'ScheduleView', 48, 'switch.png'));
        data.push(laf.table.section('Classes'));
        
        for (var classItr = 0, classLen = classes.length; classItr < classLen; classItr++) {
            data.push(newClassRow(classes[classItr].ClassID, classes[classItr].Name));
        }
        
        tvClubClasses.setData(data);
        laf.table.scrollToTop(tvClubClasses, false);
    }
    
    function setClubScheduleRows(){
        var data = [];
        var index = [];
        
        setRightNav(null);
        filteredClassID = -1;
        var lastDay = -1;
        var rowCounter = 0;
        
        // used for scroll to index.  Comment out until further notice
        // var todayDate = new Date();
        //  var scrollIndex = todayDate.getDay();
        //  todayDate = daysOfWeek[scrollIndex].toString();
		
		index.push({
			title: 'View',
			index: rowCounter++
		});
        data.push(laf.table.actionRow('Switch to List View', 'ListView', 48, 'switch.png'));
        
        for (var scheduleItr = 0, scheduleLen = classes.length; scheduleItr < scheduleLen; scheduleItr++) {
            var curClassItem = classes[scheduleItr];
            if (lastDay != curClassItem.DayID) {
                lastDay = curClassItem.DayID;
                index.push({
                    title: daysOfWeek[curClassItem.DayID].substring(0, 3),
                    index: rowCounter
                });
                data.push(laf.table.section(daysOfWeek[curClassItem.DayID]));
                
                //  used for scroll to index.  Comment out until further notice
                //  if (todayDate == daysOfWeek[curClassItem.DayID]) {
                //  scrollIndex = (laf.device.isAndroid()) ? parseInt(scheduleItr,10) + parseInt(curClassItem.DayID,10) : scheduleItr;
                //  scrollIndex = (laf.device.isAndroid()) ? scheduleItr + curClassItem.DayID : scheduleItr;
                //  }                 
            }
            data.push(newClassScheduleRow(curClassItem.ClassID, curClassItem.Name, curClassItem.Start));
            rowCounter++;
        }
        
        tvClubClasses.setData(data);
        if (laf.device.isiPhone()) {
            tvClubClasses.setIndex(index);
        }
        
        // used for scroll to index.  Comment out until further notice        
        // tvClubClasses.scrollToIndex(scrollIndex, {
        // animated: true,
        // position: Titanium.UI.iPhone.TableViewScrollPosition.TOP
        // });
    }
    
    function setClassDetailRows(){
    
        var data = [];
        if (laf.device.isiPhone()) {
            tvClubClasses.setIndex(null);
        }
        setRightNav(btnRightNav);
        
        data.push(laf.table.section(classDetails.Name));
        data.push(laf.table.infoRow(classDetails.Description));
        
        if (laf.auth.isAuthenticated(false)) {
            data.push(newFavoriteRow());
        }
        
        var lastDay = -1;
        for (var scheduleItr = 0, scheduleLen = classSchedule.length; scheduleItr < scheduleLen; scheduleItr++) {
            var curClassItem = classSchedule[scheduleItr];
            if (lastDay != curClassItem.DayID) {
                lastDay = curClassItem.DayID;
                data.push(laf.table.section(daysOfWeek[curClassItem.DayID]));
            }
            data.push(newClassDetailRow(curClassItem.DayID, curClassItem.Start));
        }
        
        tvClubClasses.setData(data);
        laf.table.scrollToTop(tvClubClasses, false);
    }
    
    //=== EVENTS =============================
    tvClubClasses.addEventListener('click', function(e){
        if (e.rowData != undefined && e.rowData.rowType != undefined) {
            switch (e.rowData.rowType) {
                case 'Class':
                    if (e.rowData.classID != undefined) {
                        vwActivity.show('Loading...');
                        filteredClassID = e.rowData.classID;
                        loadClassDetails(filteredClassID);
                        setClassDetailRows();
                        vwActivity.hide();
                    }
                    break;
                case 'ClassDetail':
                    if (e.rowData.classTime != undefined) {
                        if (laf.network.isConnected(true) && laf.auth.isAuthenticated(true)) {
                            var classDate = new Date();
                            var classTime = new Date(e.rowData.classTime);
                            var dayOfWeek = parseInt(e.rowData.classDay, 10);
                            var offset = 0;
                            
                            if (dayOfWeek < classDate.getDay()) {
                                offset = (dayOfWeek + 7) - classDate.getDay();
                            }
                            else 
                                if (dayOfWeek > classDate.getDay()) {
                                    offset = dayOfWeek - classDate.getDay();
                                }
                            
                            classDate = new Date(classDate.getFullYear(), classDate.getMonth(), classDate.getDate(), classTime.getHours(), classTime.getMinutes());
                            classDate.setDate(classDate.getDate() + offset);
                            
                            //Send calendar request
                            var adConfirmAppt = Ti.UI.createAlertDialog({
                                title: 'Class Reminder',
                                message: 'Send me a reminder for\n' + classDetails.Name + '\n' + daysOfWeek[classDate.getDay()] + '\'s @ ' + laf.dateTime.toTimeString(classDate) + '?',
                                buttonNames: (laf.device.isiPhone()) ? ['Cancel', 'Send'] : ['Send', 'Cancel']
                            });
                            adConfirmAppt.addEventListener('click', function(e){
                                if ((laf.device.isiPhone() && e.index == 1) || (!laf.device.isiPhone() && e.index == 0)) {
                                    var callbackOK = function(response){
                                        if (response.Success) {
                                            /*if (laf.device.isAndroid()) {
                                         //if android, ask user if they want to add the event to their calendar
                                         var onComplete = function(calendarID){
                                         if (calendarID != undefined && calendarID != -1) {
                                         if (!laf.calendar.checkIfEventExist(classDate, classTime, calendarID, classDetails.Name, clubDescription)) {
                                         laf.calendar.addEvent(classDate, classTime, calendarID, classDetails.Name, clubDescription, 10, 1, 0);
                                         }
                                         }
                                         };
                                         laf.calendar.picker(onComplete);
                                         } */
                                            laf.window.alert('Reminder sent', 'We have sent a reminder to the email we have on file.');
                                        }
                                        else {
                                            laf.window.alert('Error sending', response.Message);
                                        }
                                    };
                                    
                                    var classReminderQuery = {
                                        ClassID: classDetails.ClassID,
                                        ClassName: classDetails.Name,
                                        ClassTime: laf.dateTime.toString(classDate, 'Unspecified'),
                                        ClassTimeUTC: laf.dateTime.toString(classDate, 'UTC'),
                                        ClubDescription: clubDescription,
                                        ClubID: clubID
                                    };
                                    
                                    post(classReminderQuery, 'Private.svc/SendClassReminder', callbackOK);
                                }
                            });
                            adConfirmAppt.show();
                        }
                    }
                    break;
                case 'Favorite':
                    var isFavoriteClass = false;
                    var favoriteClasses = Ti.App.Properties.getString('FavoriteClasses').split(',');
                    if (favoriteClasses.length > 0) {
                        isFavoriteClass = favoriteClasses.indexOf(clubID + '|' + filteredClassID) >= 0;
                    }
                    else {
                        favoriteClasses = [];
                    }
                    
                    if (isFavoriteClass) {
                        favoriteClasses.splice(favoriteClasses.indexOf(clubID + '|' + filteredClassID), 1);
                    }
                    else {
                        favoriteClasses.push(clubID + '|' + filteredClassID);
                    }
                    Ti.App.Properties.setString('FavoriteClasses', favoriteClasses.toString());
                    tvClubClasses.updateRow(1, newFavoriteRow(), {
                        animationStyle: Ti.UI.iPhone.RowAnimationStyle.FADE
                    });
                    break;
                case 'ListView':
                    vwActivity.show('Loading...');
                    loadClasses();
                    setClubClassRows();
                    laf.object.save('SearchClubClasses', 'listView');
                    vwActivity.hide();
                    break;
                case 'ScheduleView':
                    vwActivity.show('Loading...');
                    loadSchedule();
                    setClubScheduleRows();
                    laf.object.save('SearchClubClasses', 'scheduleView');
                    vwActivity.hide();
                    break;
            }
        }
    });
    
    btnRightNav.addEventListener('click', function(e){
        vwActivity.show('Loading...');
        
        if (laf.object.isSaved('SearchClubClasses')) {
            weekView = (laf.object.load('SearchClubClasses') == 'scheduleView') ? true : false;
        }
		
        if (filteredClassID < 0) { //See if we are changing views or simply removing filter
            weekView = !weekView;
        }
        
        if (!weekView) {
            loadClasses();
            setClubClassRows();
            laf.object.save('SearchClubClasses', 'listView');
        }
        else {
            loadSchedule();
            setClubScheduleRows();
            laf.object.save('SearchClubClasses', 'scheduleView');
        }
        vwActivity.hide();
    });
    //=== DISPLAY =============================
    this.hide = function(){
        tvClubClasses.visible = false;
        setRightNav(null);
    };
    
    this.refresh = function(classID){
        if (classID != undefined && classID >= 0) {
            vwActivity.show('Loading...');
            filteredClassID = classID;
            loadClassDetails(filteredClassID);
            setClassDetailRows();
            vwActivity.hide();
        }
        else {
            if (filteredClassID >= 0 || classes.length == 0) {
                vwActivity.show('Loading...');
                
                if (laf.object.isSaved('SearchClubClasses')) {
                    weekView = (laf.object.load('SearchClubClasses') == 'scheduleView') ? true : false;
                }
                
                if (!weekView) {
                    loadClasses();
                    setClubClassRows();
                }
                else {
                    loadSchedule();
                    setClubScheduleRows();
                }
                vwActivity.hide();
            }
        }
    };
    
    this.show = function(){
        tvClubClasses.visible = true;
    };
    
    this.view = function(){
        return tvClubClasses;
    };
};
