function clubHours(){
    //=== HEADER & DATA =============================
    var loadDate;
    var daysOfWeek = ['Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat'];
    var hours = [];
    var kidsKlubHours = [];
    var holidayHours = [];
    
    //=== OBJECTS =============================
    var vwActivity = new activityIndicator();
    
    var tvClubHours = Ti.UI.createTableView({
        top: 48,
        backgroundColor: 'white',
        rowBackgroundColor: 'transparent',
        separatorColor: '#e1e1e1',
        allowsSelection: false
    });
    
    //=== FUNCTIONS =============================
    function loadClubHours(){
        var hoursSet = laf.data.clubSet('SELECT DISTINCT SCHEDULE_TYPE_ID, strftime("%m/%d/%Y %H:%M:%S", t1.Time) AS OPEN_TIME, strftime("%m/%d/%Y %H:%M:%S", t2.Time) AS CLOSE_TIME, OPEN24, CLOSED, (DAY_ID-1) AS DAY_ID FROM ClubHours ch JOIN Time t1 on t1.TimeID=ch.OPEN_TIME JOIN Time t2 on t2.TimeID=ch.CLOSE_TIME WHERE CLUB_ID =\'' + clubID + '\' ORDER BY SCHEDULE_TYPE_ID, DAY_ID', ['ScheduleTypeID', 'Open', 'Close', 'Open24', 'Closed24', 'DayID']);
        
        hours = [];
        kidsKlubHours = [];
        for (var hoursItr = 0, hoursLen = hoursSet.length; hoursItr < hoursLen; hoursItr++) {
            var dayID = parseInt(hoursSet[hoursItr].DayID, 10);
            
            if (hoursSet[hoursItr].ScheduleTypeID == '1') {
                hours[dayID] = hoursSet[hoursItr];
            }
            else 
                if (hoursSet[hoursItr].ScheduleTypeID == '2') {
                    if (kidsKlubHours[dayID] == undefined) {
                        kidsKlubHours[dayID] = [];
                    }
                    kidsKlubHours[dayID].push(hoursSet[hoursItr]);
                }
        }

        if (!laf.device.isAndroid()) {
            holidayHours = laf.data.clubSet('SELECT DISTINCT ch.Description, strftime("%m/%d/%Y %H:%M:%S", t1.Time) AS OPEN_TIME, strftime("%m/%d/%Y %H:%M:%S", t2.Time) AS CLOSE_TIME, REGULAR_HOURS, CLOSED, strftime("%m/%d/%Y %H:%M:%S", t3.Time) AS KK_OPEN_TIME, strftime("%m/%d/%Y %H:%M:%S", t4.Time) AS KK_CLOSE_TIME, KK_REGULAR_HOURS, KK_CLOSED, strftime("%m/%d/%Y", ObservedDate) AS ObservedDate FROM ClubHoliday ch JOIN Club c ON ch.CountryCode = c.COUNTRYCODE JOIN Time t1 on t1.TimeID=ch.OPEN_TIME JOIN Time t2 on t2.TimeID=ch.CLOSE_TIME JOIN Time t3 on t3.TimeID = ch.KK_OPEN_TIME JOIN Time t4 on t4.TimeID = ch.KK_CLOSE_TIME WHERE date(ObservedDate) >= date(\'now\', \'localtime\') AND date(ObservedDate) <= date(\'now\', \'localtime\', \'+7 day\') AND c.CLUB_ID =\'' + clubID + '\' ORDER BY date(ObservedDate)', ['Description', 'Open', 'Close', 'Regular', 'Closed', 'KKOpen', 'KKClose', 'KKRegular', 'KKClosed', 'ObservedDate']);
        } else {
            //Android performing very poorly & slow on complicated SQL, break it up
            holidayHours = laf.data.clubSet('SELECT DISTINCT ch.Description, OPEN_TIME, CLOSE_TIME, REGULAR_HOURS, CLOSED, KK_OPEN_TIME, KK_CLOSE_TIME, KK_REGULAR_HOURS, KK_CLOSED, strftime("%m/%d/%Y", ObservedDate) AS ObservedDate FROM ClubHoliday ch JOIN Club c ON ch.CountryCode = c.COUNTRYCODE WHERE date(ObservedDate) >= date(\'now\', \'localtime\') AND date(ObservedDate) <= date(\'now\', \'localtime\', \'+7 day\') AND c.CLUB_ID =\'' + clubID + '\' ORDER BY date(ObservedDate)', ['Description', 'Open', 'Close', 'Regular', 'Closed', 'KKOpen', 'KKClose', 'KKRegular', 'KKClosed', 'ObservedDate']);
            for (var holidayItr = 0, holidayLen = holidayHours.length; holidayItr < holidayLen; holidayItr++) {
                var currHoliday = holidayHours[holidayItr];
                currHoliday.Open = laf.data.clubScalar('SELECT strftime("%m/%d/%Y %H:%M:%S", Time) FROM Time WHERE TimeID = \'' + currHoliday.Open + '\'');
                currHoliday.Close = laf.data.clubScalar('SELECT strftime("%m/%d/%Y %H:%M:%S", Time) FROM Time WHERE TimeID = \'' + currHoliday.Close + '\'');
                currHoliday.KKOpen = laf.data.clubScalar('SELECT strftime("%m/%d/%Y %H:%M:%S", Time) FROM Time WHERE TimeID = \'' + currHoliday.KKOpen + '\'');
                currHoliday.KKClose = laf.data.clubScalar('SELECT strftime("%m/%d/%Y %H:%M:%S", Time) FROM Time WHERE TimeID = \'' + currHoliday.KKClose + '\'');
            }
        }
    }
    
    function getHolidayRow(clubHoliday){
        var dayID = (new Date(clubHoliday.ObservedDate).getDay());
        var regHours = hours[dayID];
        var regKKHours = kidsKlubHours[dayID];

		var strDate = (new Date(clubHoliday.ObservedDate)).toDateString();        
        var strHours = clubHoliday.Description || 'Holiday';
		strHours += ' - ' + strDate.substr(0, strDate.length - 5) + '\nHours: ';
        if (regHours == undefined || regHours.Closed24 == '1' || clubHoliday.Closed == '1') {
            strHours += 'Closed';
        }
        else {
            if (clubHoliday.Regular == '1') {
                if (regHours.Open24 == '1') {
                    strHours += 'Open 24 Hrs.';
                }
                else {
                    strHours += laf.dateTime.toTimeString(regHours.Open) + ' - ' + laf.dateTime.toTimeString(regHours.Close);
                }
            }
            else {
                //Use the lesser of regular club hours or the holiday hours		
                var closesAtMidnight = (regHours.Close == '01/01/1900 00:00:00');
                strHours += laf.dateTime.toTimeString((clubHoliday.Open > regHours.Open) ? clubHoliday.Open : regHours.Open);
                strHours += ' - ';
                strHours += laf.dateTime.toTimeString((closesAtMidnight || clubHoliday.Close < regHours.Close) ? clubHoliday.Close : regHours.Close);
            }
        }
        
        //See if we have a Kids Klub or if club is closed
        if (regHours != undefined && regKKHours != undefined && regKKHours.length > 0 && regHours.Closed24 != '1' && clubHoliday.Closed != '1') {
            strHours += '\nKids Klub: ';
            if (clubHoliday.KKClosed == '1') {
                strHours += 'Closed';
            }
            else {
                if (clubHoliday.Regular == '1') {
                    if (regKKHours[0].Open24 == '1') {
                        strHours += 'Open 24 Hrs.';
                    }
                    else {
                        for (i = 0, lenI = regKKHours.length; i < lenI; i++) {
                            strHours += laf.dateTime.toTimeString(regKKHours[i].Open, false) + ' - ';
                            strHours += laf.dateTime.toTimeString(regKKHours[i].Close, false) + '\n';
                        }
                        if (strHours.length > 0) {
                            strHours = strHours.substring(0, strHours.length - 1);
                        }
                    }
                }
                else {
                    //Use the lesser of regular club hours or the holiday hours		
                    var clubClosesAtMidnight = (regHours.Close == '01/01/1900 00:00:00');
                    var clubOpen = (clubHoliday.Regular == '1' || clubHoliday.Open < regHours.Open) ? regHours.Open : clubHoliday.Open;
                    var clubClose = (clubHoliday.Regular == '1' || (clubHoliday.Close > regHours.Close && !clubClosesAtMidnight)) ? regHours.Close : clubHoliday.Close;
                    
                    strHours += laf.dateTime.toTimeString((clubHoliday.KKOpen > clubOpen) ? clubHoliday.KKOpen : clubOpen);
                    strHours += ' - ';
                    strHours += laf.dateTime.toTimeString((clubHoliday.KKClose < clubClose) ? clubHoliday.KKClose : clubClose);
                }
            }
        }
        
        return new laf.table.infoRow(strHours, 'center');
    }
    
    function getDayRow(dayID){
        var strHours = '';
        if (hours[dayID] == undefined) {
            strHours = 'Closed';
        }
        else {
            if (hours[dayID].Closed24 == '1') {
                strHours = 'Closed';
            }
            else 
                if (hours[dayID].Open24 == '1') {
                    strHours = 'Open 24 Hours';
                }
                else {
                    strHours = laf.dateTime.toTimeString(hours[dayID].Open, false) + ' - ';
                    strHours += laf.dateTime.toTimeString(hours[dayID].Close, false);
                }
        }
        
        var strKKHours = '';
        if (kidsKlubHours[dayID] == undefined || kidsKlubHours[dayID].length == 0) {
            strKKHours = 'Closed';
        }
        else {
            if (kidsKlubHours[dayID][0].Closed24 == '1') {
                strKKHours = 'Closed';
            }
            else {
                if (kidsKlubHours[dayID][0].Open24 == '1') {
                    strKKHours = 'Open 24 Hrs.';
                }
                else {
                    for (var kkHourItr = 0, kkHourLen = kidsKlubHours[dayID].length; kkHourItr < kkHourLen; kkHourItr++) {
                        strKKHours += laf.dateTime.toTimeString(kidsKlubHours[dayID][kkHourItr].Open, false) + ' - ';
                        strKKHours += laf.dateTime.toTimeString(kidsKlubHours[dayID][kkHourItr].Close, false) + '\n';
                    }
                    if (strKKHours.length > 0) {
                        strKKHours = strKKHours.substring(0, strKKHours.length - 1);
                    }
                }
            }
        }
        
        var tvRow = Ti.UI.createTableViewRow({
            height: 40,
            backgroundColor: (dayID == loadDate.getDay()) ? '#C5E5F2' : 'white'
        });
        
        tvRow.add(Ti.UI.createLabel({
            color: 'black',
            font: {
                fontSize: 18,
                fontWeight: 'bold',
                fontFamily: 'Arial'
            },
            left: 5,
            height: 40,
            text: daysOfWeek[dayID]
        }));
        
        tvRow.add(Ti.UI.createLabel({
            color: 'black',
            font: {
                fontSize: 14,
                fontWeight: 'light',
                fontFamily: 'Arial'
            },
            left: 80,
            height: 80,
            text: strHours
        }));
        
        tvRow.add(Ti.UI.createLabel({
            color: 'black',
            font: {
                fontSize: 14,
                fontWeight: 'light',
                fontFamily: 'Arial'
            },
            right: 2,
            width: 100,
            height: 40,
            text: strKKHours
        }));
        
        return tvRow;
    }
    
    function setHoursRows(){
        var data = [];
        headers = '';
        
        
        if (!laf.object.isNullOrEmpty(holidayHours)) {
            data.push(laf.table.section('Holiday Hours (May Vary)'));
            for (var holItr = 0, holLen = holidayHours.length; holItr < holLen; holItr++) {
                data.push(getHolidayRow(holidayHours[holItr]));
            }
        }
        
        data.push(laf.table.section('Club Hours (Holidays May Vary)'));
        
        var tvHeaderRow = Ti.UI.createTableViewRow({
            height: 20,
            backgroundColor: '#A7B2BB'
        });
        var lblDay = laf.table.headerLabel('Day');
        lblDay.left = 10;
        tvHeaderRow.add(lblDay);
        
        var lblHours = laf.table.headerLabel('Hours');
        lblHours.left = 80;
        tvHeaderRow.add(lblHours);
        
        var lblKidsKlub = laf.table.headerLabel('Kids Klub');
        lblKidsKlub.right = 2;
        lblKidsKlub.width = 100;
        tvHeaderRow.add(lblKidsKlub);
        
        data.push(tvHeaderRow);
        
        for (var dayItr = 0; dayItr < 7; dayItr++) {
            data.push(getDayRow(dayItr));
        }
        
        tvClubHours.setData(data);
    }
    
    //=== EVENTS =============================
    
    //=== DISPLAY =============================
    this.hide = function(){
        tvClubHours.visible = false;
    };
    
    this.refresh = function(){
        var refreshDate = new Date();
        if (loadDate == undefined || loadDate.getDate() != refreshDate.getDate() || loadDate.getMonth() != refreshDate.getMonth()) {
            loadDate = new Date();
            vwActivity.show('Loading...');
            loadClubHours();
            setHoursRows();
            vwActivity.hide();
        }
    };
    
    this.show = function(){
        tvClubHours.visible = true;
    };
    
    this.view = function(){
        return tvClubHours;
    };
};
