//=== HEADER & DATA =============================
Ti.include('../../common/winHeader.js');
//laf.window.include('../../common/utilActivity.js');
var zipCode = Ti.App.Properties.getString('ZipCode');
var loaded = false;

//=== OBJECTS =============================
var vwActivity = new activityIndicator();
var listClubs, listClasses, listAmenities, listLeagues;

var vwLocation = Ti.UI.createView({
    left: 0,
    right: 0,
    top: 0,
    height: 48,
    backgroundColor: '#576996'
});

var tfLocation = Ti.UI.createTextField({
    value: zipCode,
    bottom: 2,
    top: 2,
    left: 5,
    right: (laf.device.isiPhone()) ? 90 : 55,
    hintText: (laf.network.isConnected(false)) ? 'City, State OR ZIP' : 'ZIP/Postal Code',
    autocorrect: false,
    returnKeyType: Ti.UI.RETURNKEY_DONE,
    autocapitalization: Ti.UI.TEXT_AUTOCAPITALIZATION_WORDS,
    borderStyle: Ti.UI.INPUT_BORDERSTYLE_ROUNDED,
    clearButtonMode: Ti.UI.INPUT_BUTTONMODE_ONFOCUS
});
vwLocation.add(tfLocation);

var btnGPS = Ti.UI.createButton({
    title: (laf.device.isiPhone()) ? ' GPS' : 'GPS',
    top: 1,
    height: 45,
    right: 5,
    width: (laf.device.isiPhone()) ? 80 : 47
});

if (laf.device.isiPhone()) {
    btnGPS.image = laf.path.images + 'location.png';
    btnGPS.color = 'black';
    btnGPS.borderWidth = 2.0; //iOS 3.1.3 not displaying full border without this
    btnGPS.borderRadius = 3.5;
    btnGPS.backgroundImage = laf.path.images + 'BUTT_gry_off.png';
    btnGPS.ackgroundSelectedImage = laf.path.images + 'BUTT_gry_on.png';
    btnGPS.backgroundDisabledImage = laf.path.images + 'BUTT_gry_off.png';
}
vwLocation.add(btnGPS);

//=== FUNCTIONS =============================
function tabChange(tabIndex){
    setRightNav(null);
    
    switch (tabIndex) {
        case 0:
            if (listClasses != undefined) {
                listClasses.hide();
            }
            if (listAmenities != undefined) {
                listAmenities.hide();
            }
            if (listLeagues != undefined) {
                listLeagues.hide();
            }
            
            if (listClubs == undefined) {
                laf.window.include('listClubs.js');
                listClubs = new listClubs();
                vwMain.add(listClubs.view());
            }
            listClubs.refresh();
            listClubs.show();
            break;
        case 1:
            if (listClubs != undefined) {
                listClubs.hide();
            }
            if (listAmenities != undefined) {
                listAmenities.hide();
            }
            if (listLeagues != undefined) {
                listLeagues.hide();
            }
            
            if (listClasses == undefined) {
                laf.window.include('listClasses.js');
                listClasses = new listClasses();
                vwMain.add(listClasses.view());
            }
            listClasses.refresh();
            listClasses.show();
            break;
        case 2:
            if (listClubs != undefined) {
                listClubs.hide();
            }
            if (listClasses != undefined) {
                listClasses.hide();
            }
            if (listLeagues != undefined) {
                listLeagues.hide();
            }
            
            if (listAmenities == undefined) {
                laf.window.include('listAmenities.js');
                listAmenities = new listAmenities();
                vwMain.add(listAmenities.view());
            }
            listAmenities.refresh();
            listAmenities.show();
            break;
        case 3:
            if (listClubs != undefined) {
                listClubs.hide();
            }
            if (listClasses != undefined) {
                listClasses.hide();
            }
            if (listAmenities != undefined) {
                listAmenities.hide();
            }
            
            if (listLeagues == undefined) {
                laf.window.include('listLeagues.js');
                listLeagues = new listLeagues();
                vwMain.add(listLeagues.view());
            }
            listLeagues.refresh();
            listLeagues.show();
            break;
    }
}

function updateLocation(lat, lon, location){
    Ti.App.Properties.setDouble('Latitude', lat);
    Ti.App.Properties.setDouble('Longitude', lon);
    Ti.App.Properties.setString('ZipCode', location);
    tfLocation.value = location;
    
    vwActivity.show('Filtering Clubs...');
    laf.location.filterClubs(lat, lon, 50);
    vwActivity.hide();
    
    switch (currTabIndex) {
        case 0:
            listClubs.refresh();
            break;
        case 1:
            listClasses.refresh();
            break;
        case 2:
            listAmenities.refresh();
            break;
        case 3:
            listLeagues.refresh();
            break;
    }
}

function validateAndLoad(){
    if (laf.verify.isEmpty(tfLocation)) {
        laf.window.alert('Invalid Location', 'Please enter a valid location.');
        tfLocation.focus();
        return;
    }
    
    tfLocation.blur();
    tfLocation.value = laf.verify.trim(tfLocation.value);
    
    //Check that the location has changed before recalculating lat/lon position
    if (zipCode == '' || tfLocation.value != zipCode) {
        zipCode = tfLocation.value;
        
        var Lat = 0;
        var Lon = 0;
        
        //Try looking up by zip/postal code as we have local db
        var postalLookup = laf.location.postalCode(tfLocation.value);
        if (postalLookup != undefined && postalLookup.Lat != undefined && postalLookup.Lon != undefined) {
            Lat = isNaN(postalLookup.Lat) ? 0 : postalLookup.Lat;
            Lon = isNaN(postalLookup.Lon) ? 0 : postalLookup.Lon;
        }
        
        //Zipcode lookup didn't work, try seeing if coordinates were entered
        if ((Lat == undefined || Lon == undefined || (Lat == 0 && Lon == 0))) {
            var comma = tfLocation.value.indexOf(',', 0);
            if (comma > 0 && comma < tfLocation.value.length - 1) {
                Lat = parseFloat(tfLocation.value.substring(0, comma));
                Lon = parseFloat(tfLocation.value.substring(comma + 1, tfLocation.value.length));
                if (isNaN(Lat) || isNaN(Lon)) {
                    Lat = 0;
                    Lon = 0;
                }
            }
        }
        
        //If we have internet & no results, try doing an online lookup
        if ((Lat == undefined || Lon == undefined || (Lat == 0 && Lon == 0)) && laf.network.isConnected(false)) {
            vwActivity.show('Locating...');
            laf.location.freeEntry(tfLocation.value, function(Lat, Lon, Location){
                vwActivity.hide();
                if (Lat == undefined || Lon == undefined || (Lat == 0 && Lon == 0)) {
                    zipCode = '';
                    laf.window.alert('Could Not Locate', 'Check that you have entered a valid location and try again.');
                }
                else {
                    updateLocation(Lat, Lon, Location);
                }
            });
        }
        else 
            if (Lat == undefined || Lon == undefined || (Lat == 0 && Lon == 0)) {
                zipCode = '';
                if (!laf.network.isConnected(false) && !laf.verify.isZipCode(tfLocation.value)) {
                    laf.window.alert('Cannot Connect', 'You must connect to a Wi-Fi or cellular data network to lookup locations other than US ZIP Codes.');
                }
                else {
                    var locMessage = 'Check that you have entered a valid location and try again.';
                    if (!laf.network.isConnected(false)) {
                        locMessage += ' Connecting to a Wi-Fi or cellular data network may help.';
                    }
                    laf.window.alert('Could Not Locate', locMessage);
                }
            }
            else {
                updateLocation(Lat, Lon, tfLocation.value);
            }
    }
}

//=== EVENTS =============================
btnGPS.addEventListener('click', function(e){
    if (!laf.location.enabled()) {
        laf.window.alert('GPS Disabled', 'Your device has GPS location turned off, please enable it.');
        return;
    }
    
    tfLocation.blur();
    vwActivity.show('Locating...');
	
    laf.location.gps(function(lat, lon, location){
        vwActivity.hide();
        if (lat == undefined || lon == undefined || (lat == 0 && lon == 0)) {
            tfLocation.value = '';
        }
        else {
            if (location != undefined && location.length > 0) {
                tfLocation.value = location;
            }
            else {
                tfLocation.value = lat + ', ' + lon;
            }
            validateAndLoad();
        }
    }, (laf.device.isAndroid()) ? Ti.Android.currentActivity : undefined);
});

tfLocation.addEventListener('return', function(){
    validateAndLoad();
});

tfLocation.addEventListener('focus', function(){
    if (loaded && laf.device.isiPhone()) {
        if (listClubs != undefined) {
            listClubs.hide();
        }
        if (listClasses != undefined) {
            listClasses.hide();
        }
        if (listAmenities != undefined) {
            listAmenities.hide();
        }
        if (listLeagues != undefined) {
            listLeagues.hide();
        }
    }
});

tfLocation.addEventListener('blur', function(){
    switch (currTabIndex) {
        case 0:
            listClubs.show();
            break;
        case 1:
            listClasses.show();
            break;
        case 2:
            listAmenities.show();
            break;
        case 3:
            listLeagues.show();
            break;
    }
});

//=== DISPLAY =============================
vwMain.add(vwLocation);
laf.window.footerTabs(['Clubs', 'Classes', 'Amenities', 'Leagues'], tabChange, 0);
tfLocation.blur();

setTimeout(function(){
    loaded = true;
    if (laf.verify.isEmpty(tfLocation)) {
        tfLocation.focus();
    }
    else {
        tfLocation.blur();
        validateAndLoad();
        tfLocation.blur();
        setTimeout(function() {
            tfLocation.blur(); //Android textfield focus unless delayed blur
        }, 1000);        
    }
}, 125);
