function listAmenities(){
    //=== HEADER & DATA =============================
    var lastFilteredClubs = '';
    var filteredAmenityID = -1;
    var amenities = [];
    var clubs = [];
    
    //=== OBJECTS =============================	
    var vwActivity = new activityIndicator();
    
    var tvAmenityList = Ti.UI.createTableView({
        top: 48,
        backgroundColor: 'white',
        rowBackgroundColor: 'transparent',
        separatorColor: '#e1e1e1'
    });
    
    var btnRightNav = Ti.UI.createButton({
        title: 'All Amenities'
    });
    
    //=== FUNCTIONS =============================
    function getImageForAmenity(amenityID){
        switch (amenityID + '') {
            case '1':
                return laf.path.images + 'racquetball.png';
            case '2':
                return laf.path.images + 'squash.png';
            case '3':
                return laf.path.images + 'basketball.png';
            case '4':
                return laf.path.images + 'tennis.png';
            case '5':
                return laf.path.images + 'aerobics.png';
            case '6':
                return laf.path.images + 'steamroom.png';
            case '7':
                return laf.path.images + 'hotStrech.png';
            case '8':
                return laf.path.images + 'jacuzzi.png';
            case '9':
                return laf.path.images + 'sauna.png';
            case '10':
            case '11':
                return laf.path.images + 'pool.png';
            case '12':
                return laf.path.images + 'towell.png';
            case '13':
                return laf.path.images + 'kidsKlub.png';
            case '14':
                return laf.path.images + 'bicycle.png';
            case '15':
                return laf.path.images + 'yoga.png';
            default:
                return laf.path.images + 'check.png';
        }
    }
    
    function loadFilteredAmenities(){
        filteredAmenityID = -1;
        if (laf.location.clubFilterString() != '') {
            lastFilteredClubs = laf.location.clubFilterString();
            amenities = laf.data.clubSet('SELECT DISTINCT ClubAmenity.AmenityID, Amenity.Description FROM ClubAmenity INNER JOIN Amenity ON ClubAmenity.AmenityID = Amenity.AmenityID WHERE ClubAmenity.CLUB_ID IN (' + lastFilteredClubs + ') ORDER BY Amenity.Description', ['AmenityID', 'Description']);
        }
        else {
            amenities = [];
        }
    }
    
    function loadFilteredClubs(amenityID){
        filteredAmenityID = amenityID;
        clubs = laf.data.clubSet('SELECT DISTINCT ClubAmenity.CLUB_ID, Club.DESCRIPTION, Club.CITY, Club.STATE FROM ClubAmenity INNER JOIN Club ON ClubAmenity.CLUB_ID = Club.CLUB_ID WHERE ClubAmenity.CLUB_ID IN (' + lastFilteredClubs + ') AND AmenityID = \'' + amenityID + '\'', ['ClubID', 'Description', 'City', 'State']);
        laf.location.addClubDistance(clubs);
    }
    
    function setAmenityRows(){
        var data = [];
        headers = '';
        filteredAmenityID = -1;
        setRightNav(null);
        
        data.push(laf.table.section('Amenities'));
        
        if (amenities == undefined || amenities.length == 0) {
            tvAmenityList.touchEnabled = false;
            laf.table.hideEmptyRows(tvAmenityList, false);
            
            var tvrEnterLocation = Ti.UI.createTableViewRow({
                height: 105,
                className: 'EnterSearchLocation'
            });
            tvrEnterLocation.add(Ti.UI.createLabel({
                color: '#7F7F7F',
                font: {
                    fontSize: 18,
                    fontFamily: 'Arial'
                },
                top: 25,
                left: 5,
                right: 5,
                height: 80,
                textAlign: 'center',
                text: 'No amenities found within 50 miles,\ncheck your spelling and change\nyour search location above.'
            }));
            data.push(tvrEnterLocation);
        }
        else {
            tvAmenityList.touchEnabled = true;
            laf.table.showEmptyRows(tvAmenityList);
            
            //Create Filtered Amenity List		
            for (var i = 0, len = amenities.length; i < len; i++) {
                var tvrAmenity = Ti.UI.createTableViewRow({
                    height: 50,
                    className: 'listAmenitiesAmenity',
                    hasChild: true,
                    rowType: 'Amenity',
                    amenityID: amenities[i].AmenityID,
                    amenityName: amenities[i].Description
                });
                
                tvrAmenity.add(Ti.UI.createLabel({
                    color: 'black',
                    font: {
                        fontSize: 16,
                        fontFamily: 'Arial',
                        fontWeight: 'bold'
                    },
                    text: amenities[i].Description,
                    height: 'auto',
                    width: 'auto',
                    left: 45
                }));
                
                tvrAmenity.add(Ti.UI.createView({
                    backgroundImage: getImageForAmenity(amenities[i].AmenityID),
                    left: 5,
                    width: 29,
                    height: 29
                }));
                
                laf.table.makeRowSelectable(tvrAmenity);
                data.push(tvrAmenity);
            }
        }
        
        tvAmenityList.setData(data);
        laf.table.scrollToTop(tvAmenityList, false);
    };
    
    function setClubRows(amenityDescription){
        var data = [];
        setRightNav(btnRightNav);
        
        data.push(laf.table.section((amenityDescription != undefined && amenityDescription != '') ? amenityDescription : 'Clubs'));
        
        //Create Filtered Club List		
        for (var i = 0, len = clubs.length; i < len; i++) {
            var tvrClub = Ti.UI.createTableViewRow({
                height: 50,
                className: 'listAmenitiesClub',
                hasChild: true,
                rowType: 'Club',
                clubID: clubs[i].ClubID
            });
            
            tvrClub.add(Ti.UI.createLabel({
                font: {
                    fontSize: 16,
                    fontWeight: 'bold',
                    fontFamily: 'Arial'
                },
                color: 'black',
                top: 5,
                left: 5,
                right: laf.table.leftDataRightMargin,
                height: 20,
                textAlign: 'left',
                text: clubs[i].Description
            }));
            
            tvrClub.add(Ti.UI.createLabel({
                color: '#7F7F7F',
                font: {
                    fontSize: 14,
                    fontFamily: 'Arial'
                },
                top: 25,
                left: 5,
                right: laf.table.leftDataRightMargin,
                height: 20,
                textAlign: 'left',
                text: clubs[i].City + ', ' + clubs[i].State
            }));
            
            
            tvrClub.add(Ti.UI.createLabel({
                color: '#576996',
                font: {
                    fontSize: 16,
                    fontWeight: 'bold',
                    fontFamily: 'Arial'
                },
                height: 20,
                textAlign: 'right',
                right: laf.table.detailsRight,
                text: isNaN(clubs[i].Distance) ? '' : parseInt(clubs[i].Distance, 10) + ' Mi'
            }));
            
            laf.table.makeRowSelectable(tvrClub);
            data.push(tvrClub);
        }
        
        tvAmenityList.setData(data);
        laf.table.scrollToTop(tvAmenityList, false);
    };
    
    //=== EVENTS =============================
    tvAmenityList.addEventListener('click', function(e){
        if (e.rowData != undefined && e.rowData.rowType != undefined) {
            switch (e.rowData.rowType) {
                case 'Club':
                    if (e.rowData.clubID >= 0) {
                        laf.window.create('Club', '/views/search/club.js', {
                            clubID: e.rowData.clubID
                        });
                        laf.window.open();
                    }
                    break;
                case 'Amenity':
                    if (e.rowData.amenityID >= 0) {
                        vwActivity.show('Loading...');
                        loadFilteredClubs(e.rowData.amenityID);
                        setClubRows(e.rowData.amenityName);
                        vwActivity.hide();
                    }
                    break;
            }
        }
    });
    
    btnRightNav.addEventListener('click', function(e){
        vwActivity.show('Loading...');
        loadFilteredAmenities();
        setAmenityRows();
        vwActivity.hide();
    });
    
    //=== DISPLAY =============================	
    this.hide = function(){
        tvAmenityList.visible = false;
        setRightNav(null);
    };
    
    this.refresh = function(){
        if (filteredAmenityID >= 0 || laf.location.clubFilterString() == '' || laf.location.clubFilterString() != lastFilteredClubs) {
            vwActivity.show('Loading...');
            loadFilteredAmenities();
            setAmenityRows();
            vwActivity.hide();
        }
    };
    
    this.show = function(){
        tvAmenityList.visible = true;
        if (filteredAmenityID >= 0) {
            setRightNav(btnRightNav);
        }
    };
    
    this.view = function(){
        return tvAmenityList;
    };
};
