function listClasses(){
    //=== HEADER & DATA =============================
    var lastFilteredClubs = '';
    var filteredClassID = -1;
    var filteredClassTitle = '';
    var vwActivity = new activityIndicator();
    var classes = [];
    var clubs = [];
    var daysOfWeek = ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'];
    
    //=== OBJECTS =============================	
    var tvClassList = Ti.UI.createTableView({
        top: 48,
        backgroundColor: 'white',
        rowBackgroundColor: 'transparent',
        separatorColor: '#e1e1e1'
    });
    
    var btnRightNav = Ti.UI.createButton({
        title: 'All Classes'
    });
    
    function newClassRow(classObj){
        var tvrClass = Ti.UI.createTableViewRow({
            height: 'auto',
            className: 'listClassesClass',
            hasChild: true,
            rowType: 'Class',
            classID: classObj.ClassID,
            classTitle: classObj.Name
        });
        
        tvrClass.add(Ti.UI.createLabel({
            color: 'black',
            font: {
                fontSize: 16,
                fontWeight: 'bold',
                fontFamily: 'Arial'
            },
            height: 22,
            left: 5,
            top: 5,
            text: classObj.Name
        }));
        
        tvrClass.add(Ti.UI.createLabel({
            color: '#7F7F7F',
            font: {
                fontSize: 12,
                fontFamily: 'Arial'
            },
            text: (laf.device.isiPhone()) ? classObj.Description + '\n\n' : classObj.Description + '\n',
            height: 'auto',
            left: 5,
            top: 30,
            right: laf.table.detailsRight
        }));
        
        laf.table.makeRowSelectable(tvrClass);
        return tvrClass;
    }
    
    function newClubRow(club){
        var tvrClub = Ti.UI.createTableViewRow({
            height: 50,
            className: 'listClassesClub',
            hasChild: true,
            rowType: 'Club',
            clubID: club.ClubID
        });
        
        tvrClub.add(Ti.UI.createLabel({
            font: {
                fontSize: 16,
                fontWeight: 'bold',
                fontFamily: 'Arial'
            },
            color: 'black',
            top: 5,
            left: 5,
            right: laf.table.leftDataRightMargin,
            height: 20,
            textAlign: 'left',
            text: club.Description
        }));
        
        tvrClub.add(Ti.UI.createLabel({
            color: '#7F7F7F',
            font: {
                fontSize: 14,
                fontFamily: 'Arial'
            },
            top: 25,
            left: 5,
            right: laf.table.leftDataRightMargin,
            height: 20,
            textAlign: 'left',
            text: club.City + ', ' + club.State
        }));
        
        tvrClub.add(Ti.UI.createLabel({
            color: '#576996',
            font: {
                fontSize: 16,
                fontWeight: 'bold',
                fontFamily: 'Arial'
            },
            height: 20,
            textAlign: 'right',
            right: laf.table.detailsRight,
            text: isNaN(club.Distance) ? '' : parseInt(club.Distance, 10) + ' Mi'
        }));
        
        laf.table.makeRowSelectable(tvrClub);
        return tvrClub;
    }
    
    function newScheduleRow(classObj){
        var tvRow = Ti.UI.createTableViewRow({
            height: 40,
            className: 'listClassesSchedule',
            hasChild: (laf.device.isiPhone()) ? false : true,
            clubID: classObj.ClubID,
            rowType: 'Club'
        });
        
        tvRow.add(Ti.UI.createLabel({
            color: 'black',
            font: {
                fontSize: 16,
                fontWeight: 'bold',
                fontFamily: 'Arial'
            },
            height: 20,
            left: 5,
            top: 2,
            text: laf.dateTime.toTimeString(classObj.Start)
        }));
        
        tvRow.add(Ti.UI.createLabel({
            font: {
                fontSize: 14,
                fontFamily: 'Arial'
            },
            height: 20,
            left: 5,
            bottom: 2,
            color: '#7F7F7F',
            text: classObj.Description
        }));
        
        tvRow.add(Ti.UI.createLabel({
            color: '#576996',
            font: {
                fontSize: 16,
                fontWeight: 'bold',
                fontFamily: 'Arial'
            },
            height: 20,
            textAlign: 'right',
            right: laf.table.detailsRight,
            text: isNaN(classObj.Distance) ? '' : parseInt(classObj.Distance, 10) + ' Mi'
        }));
        
        laf.table.makeRowSelectable(tvRow);
        return tvRow;
    }
    
    //=== FUNCTIONS =============================	
    function loadFilteredClasses(){
        filteredClassID = -1;
        if (laf.location.clubFilterString() != '') {
            lastFilteredClubs = laf.location.clubFilterString();
            classes = laf.data.clubSet('SELECT DISTINCT ClassSchedule.CLASSES_ID, Class.NAME, Class.DESCRIPTION FROM ClassSchedule INNER JOIN Class ON ClassSchedule.CLASSES_ID = Class.CLASSES_ID WHERE ClassSchedule.CLUB_ID IN (' + lastFilteredClubs + ') ORDER BY Class.Name', ['ClassID', 'Name', 'Description']);
        }
        else {
            classes = [];
        }
    }
    
    function loadFilteredClubs(classID, classTitle){
        filteredClassID = classID;
        filteredClassTitle = classTitle;
        clubs = laf.data.clubSet('SELECT DISTINCT ClassSchedule.CLUB_ID, Club.DESCRIPTION, Club.CITY, Club.STATE FROM ClassSchedule INNER JOIN Club ON ClassSchedule.CLUB_ID = Club.CLUB_ID WHERE ClassSchedule.CLUB_ID IN (' + lastFilteredClubs + ') AND CLASSES_ID = \'' + classID + '\'', ['ClubID', 'Description', 'City', 'State']);
        laf.location.addClubDistance(clubs);
    }
    
    function loadFilteredSchedule(classID, classTitle){
        filteredClassID = classID;
        filteredClassTitle = classTitle;
        if (laf.location.clubFilterString() != '') {
            lastFilteredClubs = laf.location.clubFilterString();
            classes = laf.data.clubSet('SELECT DISTINCT ClassSchedule.CLUB_ID, Club.DESCRIPTION, (DAY_ID-1) AS DAY_ID, strftime("%m/%d/%Y %H:%M:%S", t1.Time) AS START_TIME FROM ClassSchedule INNER JOIN Class on ClassSchedule.CLASSES_ID = Class.CLASSES_ID JOIN Time t1 on t1.TimeID=ClassSchedule.START_TIME INNER JOIN Club ON ClassSchedule.CLUB_ID = Club.CLUB_ID WHERE ClassSchedule.CLUB_ID IN (' + lastFilteredClubs + ') AND ClassSchedule.CLASSES_ID = \'' + classID + '\' ORDER BY DAY_ID, START_TIME', ['ClubID', 'Description', 'DayID', 'Start']);
            laf.location.addClubDistance(classes, false);
            
            //Lots of offerings, reduce mileage filter just for schedule display
            if (classes.length > 100) {
                for (var classItr = 0, classLen = classes.length; classItr < classLen; classItr++) {
                    if (classes[classItr].Distance > 20) {
                        classes.splice(classItr, 1);
                        classItr--;
                        classLen--;
                    }
                }
            }
            
            //Sort based on distance
            classes.sort(function(a, b){
                if (a.DayID != b.DayID || a.Start != b.Start) {
                    return 0; //Date & time already sorted by DB
                }
                else {
                    return laf.location.distanceSort(a, b);
                }
            });
        }
        else {
            classes = [];
        }
    }
    
    function setClassRows(){
        var data = [];
        headers = '';
        
        filteredClassID = -1;
        setRightNav(null);
        
        data.push(laf.table.section('Classes'));
        
        if (classes == undefined || classes.length == 0) {
            tvClassList.touchEnabled = false;
            laf.table.hideEmptyRows(tvClassList, false);
            
            var tvrEnterLocation = Ti.UI.createTableViewRow({
                height: 105,
                className: 'EnterSearchLocation'
            });
            tvrEnterLocation.add(Ti.UI.createLabel({
                color: '#7F7F7F',
                font: {
                    fontSize: 18,
                    fontFamily: 'Arial'
                },
                top: 25,
                left: 5,
                right: 5,
                height: 80,
                textAlign: 'center',
                text: 'No classes found within 50 miles,\ncheck your spelling and change\nyour search location above.'
            }));
            data.push(tvrEnterLocation);
        }
        else {
            tvClassList.touchEnabled = true;
            laf.table.showEmptyRows(tvClassList);
            
            //Create Filtered Class List		
            for (var i = 0, len = classes.length; i < len; i++) {
                data.push(newClassRow(classes[i]));
            }
        }
        
        if (laf.device.isiPhone()) {
            tvClassList.setIndex(null);
        }
        tvClassList.setData(data);
        laf.table.scrollToTop(tvClassList, false);
    };
    
    function setClubRows(){
        var data = [];
        setRightNav(btnRightNav);
        
        data.push(laf.table.section((filteredClassTitle != undefined && filteredClassTitle != '') ? filteredClassTitle : 'Clubs'));
        
        if (clubs.length > 1) {
            data.push(laf.table.actionRow('Switch to Schedule View', 'ScheduleView', 48, 'switch.png'));
            data.push(laf.table.section('Clubs'));
        }
        
        //Create Filtered Club List		
        for (var i = 0, len = clubs.length; i < len; i++) {
            data.push(newClubRow(clubs[i]));
        }
        
        if (laf.device.isiPhone()) {
            tvClassList.setIndex(null);
        }
        tvClassList.setData(data);
        laf.table.scrollToTop(tvClassList, false);
    };
    
    function setScheduleRows(){
        var data = [];
        var index = [];
        var rowCounter = 0
		;		
        setRightNav(btnRightNav);
        
        data.push(laf.table.section((filteredClassTitle != undefined && filteredClassTitle != '') ? filteredClassTitle : 'Schedule'));
        
		index.push({
			title: 'View',
			index: rowCounter++
		});		
        data.push(laf.table.actionRow('Switch to Club View', 'ClubView', 48, 'switch.png'));
        
        var lastDay = -1;

        for (var scheduleItr = 0, scheduleLen = classes.length; scheduleItr < scheduleLen; scheduleItr++) {
            var curClassItem = classes[scheduleItr];
            if (lastDay != curClassItem.DayID) {
                lastDay = curClassItem.DayID;
                index.push({
                    title: daysOfWeek[curClassItem.DayID].substring(0, 3),
                    index: rowCounter
                });
                data.push(laf.table.section(daysOfWeek[curClassItem.DayID]));
            }
            data.push(newScheduleRow(curClassItem));
            rowCounter++;
        }
        
        tvClassList.setData(data);
        if (laf.device.isiPhone()) {
            tvClassList.setIndex(index);
        }
        
        laf.table.scrollToTop(tvClassList, false);
    }
    
    //=== EVENTS =============================
    tvClassList.addEventListener('click', function(e){
        if (e.rowData != undefined && e.rowData.rowType != undefined) {
            switch (e.rowData.rowType) {
                case 'Club':
                    if (e.rowData.clubID >= 0) {
                        laf.window.create('Club', '/views/search/club.js', {
                            clubID: e.rowData.clubID,
                            classID: filteredClassID
                        });
                        laf.window.open();
                    }
                    break;
                case 'Class':
                    if (e.rowData.classID >= 0) {
                        vwActivity.show('Loading...');
                        if (laf.object.load('SearchClasses') == 'scheduleView') {
                            loadFilteredSchedule(e.rowData.classID, e.rowData.classTitle);
                            setScheduleRows();
                        }
                        else {
                            loadFilteredClubs(e.rowData.classID, e.rowData.classTitle);
                            setClubRows();
                        }
                        vwActivity.hide();
                    }
                    break;
                case 'ScheduleView':
                    vwActivity.show('Loading...');
                    loadFilteredSchedule(filteredClassID, filteredClassTitle);
                    setScheduleRows();
                    laf.object.save('SearchClasses', 'scheduleView');
                    vwActivity.hide();
                    break;
                case 'ClubView':
                    vwActivity.show('Loading...');
                    loadFilteredClubs(filteredClassID, filteredClassTitle);
                    setClubRows();
                    laf.object.save('SearchClasses', 'clubView');
                    vwActivity.hide();
                    break;
            }
        }
    });
    
    btnRightNav.addEventListener('click', function(e){
        vwActivity.show('Loading...');
        loadFilteredClasses();
        setClassRows();
        vwActivity.hide();
    });
    
    //=== DISPLAY =============================	
    this.hide = function(){
        tvClassList.visible = false;
        setRightNav(null);
    };
    
    this.refresh = function(){
        if (filteredClassID >= 0 || laf.location.clubFilterString() == '' || laf.location.clubFilterString() != lastFilteredClubs) {
            vwActivity.show('Loading...');
            loadFilteredClasses();
            setClassRows();
            vwActivity.hide();
        }
    };
    
    this.show = function(){
        tvClassList.visible = true;
        if (filteredClassID >= 0) {
            setRightNav(btnRightNav);
        }
    };
    
    this.view = function(){
        return tvClassList;
    };
};
