function listClubs(){
    //=== HEADER & DATA =============================
    var lastFilteredClubs = '';
    var clubs = [];
    
    //=== OBJECTS =============================	
    var vwActivity = new activityIndicator();
    
    var tvClubList = Ti.UI.createTableView({
        top: 48,
        backgroundColor: 'white',
        rowBackgroundColor: 'transparent',
        separatorColor: '#e1e1e1'
    });
    
    var btnMap = Ti.UI.createButton({
        title: 'Map'
    });
    
    //=== FUNCTIONS =============================	
    function loadFilteredClubs(){
        if (laf.location.clubFilterString() != '') {
            lastFilteredClubs = laf.location.clubFilterString();
            clubs = laf.data.clubSet('SELECT CLUB_ID, DESCRIPTION, CITY, STATE FROM Club WHERE CLUB_ID IN (' + lastFilteredClubs + ')', ['ClubID', 'Description', 'City', 'State']);
            laf.location.addClubDistance(clubs);
        }
        else {
            clubs = [];
        }
    }
    
    function setClubRows(){
        var data = [];
        
        data.push(laf.table.section('Clubs'));
        
        if (clubs == undefined || clubs.length == undefined || clubs.length == 0) {
            tvClubList.touchEnabled = false;
			laf.table.hideEmptyRows(tvClubList, false);
            
            var tvrEnterLocation = Ti.UI.createTableViewRow({
                height: 105,
                className: 'EnterSearchLocation'
            });
            tvrEnterLocation.add(Ti.UI.createLabel({
                color: '#7F7F7F',
                font: {
                    fontSize: 18,
                    fontFamily: 'Arial'
                },
                top: 25,
                left: 5,
                right: 5,
                height: 80,
                textAlign: 'center',
                text: 'No clubs found within 50 miles,\ncheck your spelling and change\nyour search location above.'
            }));
            data.push(tvrEnterLocation);
        }
        else {
            tvClubList.touchEnabled = true;
			laf.table.showEmptyRows(tvClubList);			
            
            //Create Filtered Club List		
            for (var i = 0, len = clubs.length; i < len; i++) {
                var tvrClub = Ti.UI.createTableViewRow({
                    height: 50,
                    className: 'listClubsClub',
                    hasChild: true,
                    rowType: 'Club',
                    clubID: clubs[i].ClubID
                });
                
                tvrClub.add(Ti.UI.createLabel({
                    font: {
                        fontSize: 16,
                        fontWeight: 'bold',
                        fontFamily: 'Arial'
                    },
                    color: 'black',
                    top: 5,
                    left: 5,
                    right: laf.table.leftDataRightMargin,
                    height: 20,
                    textAlign: 'left',
                    text: clubs[i].Description
                }));
                
                tvrClub.add(Ti.UI.createLabel({
                    color: '#7F7F7F',
                    font: {
                        fontSize: 14,
                        fontFamily: 'Arial'
                    },
                    top: 25,
                    left: 5,
                    right: laf.table.leftDataRightMargin,
                    height: 20,
                    textAlign: 'left',
                    text: clubs[i].City + ', ' + clubs[i].State
                }));
                
                tvrClub.add(Ti.UI.createLabel({
                    color: '#576996',
                    font: {
                        fontSize: 16,
                        fontWeight: 'bold',
                        fontFamily: 'Arial'
                    },
                    height: 20,
                    textAlign: 'right',
                    right: laf.table.detailsRight,
                    text: isNaN(clubs[i].Distance) ? '' : parseInt(clubs[i].Distance, 10) + ' Mi'
                }));
                
				laf.table.makeRowSelectable(tvrClub);				
                data.push(tvrClub);
            }
        }
        
        tvClubList.setData(data);
        laf.table.scrollToTop(tvClubList, false);
    };
    
    //=== EVENTS =============================		
    tvClubList.addEventListener('click', function(e){
        if (e.rowData != undefined && e.rowData.rowType != undefined && e.rowData.rowType == 'Club') {
            if (e.rowData.clubID >= 0) {
                laf.window.create('Club', '/views/search/club.js', {
                    clubID: e.rowData.clubID
                });
                laf.window.open();
            }
        }
    });
    
    btnMap.addEventListener('click', function(e){
        if (laf.verify.isEmpty(tfLocation)) {
            laf.window.alert('Invalid Location', 'Please enter a valid location.');
            tfLocation.focus();
            return;
        }
        
        if (laf.network.isConnected(true)) {
            laf.window.create('Map', '/views/common/clubMap.js');
            laf.window.open();
        }
    });
    
    //=== DISPLAY =============================	
    this.hide = function(){
        tvClubList.visible = false;
        setRightNav(null);
    };
    
    this.refresh = function(){
        if (laf.location.clubFilterString() == '' || laf.location.clubFilterString() != lastFilteredClubs) {
            vwActivity.show('Loading...');
            loadFilteredClubs();
            setClubRows();
            vwActivity.hide();
        }
    };
    
    this.show = function(){
        tvClubList.visible = true;	
        setRightNav(btnMap);
    };
    
    this.view = function(){
        return tvClubList;
    };
};
