function listLeagues(){
    //=== HEADER & DATA =============================
    var lastFilteredClubs = '';
    var filteredSport = '';
    var leagues = [];
    var clubs = [];
    
    var leagueNames = [];
    leagueNames.BB = 'Basketball';
    leagueNames.RB = 'Racquetball';
	leagueNames.SQ = 'Squash';
    leagueNames.VB = 'Volleyball';
    
    var leagueIcons = [];
    leagueIcons.BB = 'basketball.png';
    leagueIcons.RB = 'racquetball.png';
	leagueIcons.SQ = 'squash.png';	
    leagueIcons.VB = 'volleyball.png';
    
    //=== OBJECTS =============================	
    var vwActivity = new activityIndicator();
    
    var tvLeagueList = Ti.UI.createTableView({
        top: 48,
        backgroundColor: 'white',
        rowBackgroundColor: 'transparent',
        separatorColor: '#e1e1e1'
    });
    
    var btnRightNav = Ti.UI.createButton({
        title: 'All Leagues'
    });
    
    //=== FUNCTIONS =============================
    function loadFilteredLeagues(){
        filteredSport = '';
        if (laf.location.clubFilterString() != '') {
            lastFilteredClubs = laf.location.clubFilterString();
            leagues = laf.data.clubSet('SELECT DISTINCT League.SPORT FROM League WHERE LEAGUE.CLUB_ID IN (' + lastFilteredClubs + ')  ORDER BY League.SPORT', ['Sport']);
        }
        else {
            leagues = [];
        }
    }
    
    function loadFilteredClubs(){
        if (laf.location.clubFilterString() != '') {
            lastFilteredClubs = laf.location.clubFilterString();
            clubs = laf.data.clubSet('SELECT DISTINCT League.CLUB_ID, Club.DESCRIPTION, Club.CITY, Club.STATE FROM League INNER JOIN Club ON League.CLUB_ID = Club.CLUB_ID WHERE League.CLUB_ID IN (' + lastFilteredClubs + ') AND League.SPORT = \'' + filteredSport + '\'', ['ClubID', 'Description', 'City', 'State']);
            laf.location.addClubDistance(clubs);
        }
        else {
            clubs = [];
        }
    }
    
    function setLeagueRows(){
        var data = [];
        filteredSport = '';
        headers = '';
        setRightNav(null);
        
        data.push(laf.table.section('Leagues'));
        
        if (leagues == undefined || leagues.length == undefined || leagues.length == 0) {
            tvLeagueList.touchEnabled = false;
            laf.table.hideEmptyRows(tvLeagueList, false);   			
            
            var tvrEnterLocation = Ti.UI.createTableViewRow({
                height: 105,
                className: 'EnterSearchLocation'
            });
            tvrEnterLocation.add(Ti.UI.createLabel({
                color: '#7F7F7F',
                font: {
                    fontSize: 18,
                    fontFamily: 'Arial'
                },
                top: 25,
                left: 5,
                right: 5,
                height: 80,
                textAlign: 'center',
                text: 'No leagues found within 50 miles,\ncheck your spelling and change\nyour search location above.'
            }));
            data.push(tvrEnterLocation);
        }
        else {
            tvLeagueList.touchEnabled = true;
			laf.table.showEmptyRows(tvLeagueList);
			            
            //Create Filtered League List		
            for (var i = 0, len = leagues.length; i < len; i++) {
                var tvrLeague = Ti.UI.createTableViewRow({
                    height: 50,
                    className: 'listLeaguesLeague',
                    hasChild: true,
                    sport: leagues[i].Sport,
                    rowType: 'League',
                    leagueDescription: leagueNames[leagues[i].Sport]
                });
                
                tvrLeague.add(Ti.UI.createLabel({
                    color: 'black',
                    font: {
                        fontSize: 16,
                        fontFamily: 'Arial',
                        fontWeight: 'bold'
                    },
                    text: leagueNames[leagues[i].Sport] || 'League',
                    height: 'auto',
                    width: 'auto',
                    left: 45
                }));
                
                tvrLeague.add(Ti.UI.createView({
                    backgroundImage: laf.path.images + (leagueIcons[leagues[i].Sport] || 'gear.png'),
                    left: 5,
                    width: 29,
                    height: 29
                }));
                
                laf.table.makeRowSelectable(tvrLeague);
                data.push(tvrLeague);
            }
        }
        
        tvLeagueList.setData(data);
        laf.table.scrollToTop(tvLeagueList, false);
    };
    
    function setClubRows(leagueDescription){
        var data = [];
        setRightNav(btnRightNav);
        
        data.push(laf.table.section((leagueDescription != undefined && leagueDescription != '') ? leagueDescription : 'Clubs'));
        
        for (var i = 0, len = clubs.length; i < len; i++) {
            var tvrClub = Ti.UI.createTableViewRow({
                height: 50,
                className: 'listLeaguesLeague',
                hasChild: true,
                rowType: 'Club',
                clubID: clubs[i].ClubID
            });
            
            tvrClub.add(Ti.UI.createLabel({
                font: {
                    fontSize: 16,
                    fontWeight: 'bold',
                    fontFamily: 'Arial'
                },
                color: 'black',
                top: 5,
                left: 5,
                right: laf.table.leftDataRightMargin,
                height: 20,
                textAlign: 'left',
                text: clubs[i].Description
            }));
            
            tvrClub.add(Ti.UI.createLabel({
                color: '#7F7F7F',
                font: {
                    fontSize: 14,
                    fontFamily: 'Arial'
                },
                top: 25,
                left: 5,
                right: laf.table.leftDataRightMargin,
                height: 20,
                textAlign: 'left',
                text: clubs[i].City + ', ' + clubs[i].State
            }));
            
            tvrClub.add(Ti.UI.createLabel({
                color: '#576996',
                font: {
                    fontSize: 16,
                    fontWeight: 'bold',
                    fontFamily: 'Arial'
                },
                height: 20,
                textAlign: 'right',
                right: laf.table.detailsRight,
                text: isNaN(clubs[i].Distance) ? '' : parseInt(clubs[i].Distance, 10) + ' Mi'
            }));
            
            laf.table.makeRowSelectable(tvrClub);
            data.push(tvrClub);
        }
        
        tvLeagueList.setData(data);
        laf.table.scrollToTop(tvLeagueList, false);
    };
    
    //=== EVENTS =============================		
    tvLeagueList.addEventListener('click', function(e){
        if (e.rowData != undefined && e.rowData.rowType != undefined) {
            switch (e.rowData.rowType) {
                case 'Club':
                    if (e.rowData.clubID >= 0) {
                        laf.window.create('Club', '/views/search/club.js', {
                            clubID: e.rowData.clubID
                        });
                        laf.window.open();
                    }
                    break;
                case 'League':
                    if (e.rowData.sport != '') {
                        vwActivity.show('Loading...');
                        filteredSport = e.rowData.sport;
                        loadFilteredClubs(e.rowData.sport);
                        setClubRows(e.rowData.leagueDescription);
                        vwActivity.hide();
                    }
                    break;
            }
        }
    });
    
    btnRightNav.addEventListener('click', function(e){
        vwActivity.show('Loading...');
        loadFilteredLeagues();
        setLeagueRows();
        vwActivity.hide();
    });
    
    //=== DISPLAY =============================
    this.hide = function(){
        tvLeagueList.visible = false;
    };
    
    this.refresh = function(){
        if (filteredSport != '' || laf.location.clubFilterString() == '' || laf.location.clubFilterString() != lastFilteredClubs) {
            vwActivity.show('Loading...');
            loadFilteredLeagues();
            setLeagueRows();
            vwActivity.hide();
        }
    };
    
    this.show = function(){
        tvLeagueList.visible = true;
        if (filteredSport != '') {
            setRightNav(btnRightNav);
        }
    };
    
    this.view = function(){
        return tvLeagueList;
    };
};
