(function(){
    //=== HEADER & DATA =============================
    Ti.include('../../common/winHeader.js');
    
    //=== OBJECTS =============================
    var vwHeader = Ti.UI.createView({
        left: 0,
        right: 0,
        top: 0,
        height: 48,
        backgroundColor: '#576996'
    });
    vwHeader.add(Ti.UI.createLabel({
        color: 'white',
        font: {
            fontSize: 18,
            fontWeight: 'bold'
        },
        left: 5,
        minimumFontSize: 10,
        text: 'BMI'
    }));
    vwHeader.add(Ti.UI.createLabel({
        color: 'white',
        font: {
            fontSize: 18,
            fontWeight: 'bold'
        },
        right: 5,
        minimumFontSize: 10,
        textAlign: 'right',
        text: (winData.BMI != undefined) ? winData.BMI : ''
    }));
    
    var tvProgressBMI = Ti.UI.createTableView({
        top: 48,
        backgroundColor: 'white',
        rowBackgroundColor: 'transparent',
        separatorColor: 'transparent'
    });
    
    var btnGraph = Ti.UI.createButton({
        title: 'Graph'
    });
    
    if (laf.device.isiPhone()) {
        btnGraph.style = Ti.UI.iPhone.SystemButtonStyle.BORDERED;
        btnGraph.image = laf.path.images + 'graph.png';
    }
    setRightNav(btnGraph);
    
    //=== FUNCTIONS =============================
    function createTableRow(){
        var data = [];
        data.push(laf.table.section('Body Mass Index'));
        data.push(laf.table.infoRow('\nBody Mass Index is an estimate of healthy body weight, based on a person\'s weight and height. It does not take into account distribution of muscle and bone mass making it a poor measurement for the highly athletic, elderly, or children.\n\nUnderweight < 18.5\nNormal = 18.5 - 24.9\nOverweight = 25 - 29.9\nObese >= 30\n'));
        laf.table.hideEmptyRows(tvProgressBMI, true);
        tvProgressBMI.setData(data);
    }
    //=== EVENTS =============================
    btnGraph.addEventListener('click', function(e){
        laf.window.create('BMI', '/views/track/progressBMIGraph.js');
        laf.window.open();
    });
    
    //=== DISPLAY =============================
    vwMain.add(vwHeader);
    vwMain.add(tvProgressBMI);
    createTableRow();
})();
