(function(){
    //=== HEADER & DATA =============================
    Ti.include('../../common/winHeader.js');
    laf.window.include('../../common/utilGraph.js');
    
    var tabNames = ['1 Year', '6 Months', '1 Month', '2 Weeks', '1 Week'];
    var tabDurations = ['-12 month', '-6 month', '-1 month', '-14 day', '-7 day'];
    
    var currOrientation = Ti.Gesture.orientation;
    win.orientationModes = [Ti.UI.LANDSCAPE_LEFT, Ti.UI.LANDSCAPE_RIGHT];
    
    //=== OBJECTS ===================================
    var vwGraph;
    
    //=== FUNCTIONS =================================
    function loadGraph(tabIndex){
        var BMI = [];
        var smallest = 99999999;
        var yMin = 0;
        
        var minDate = laf.dateTime.toDateString(laf.data.workoutScalar("SELECT date('now','" + tabDurations[tabIndex] + "')"), '/');
        var result = laf.data.workoutSet('SELECT IFNULL(BMI, 0) FROM BMIOnDate WHERE OnDate >= "' + minDate + '" AND OnDate <= "' + laf.dateTime.toDateString() + '" ORDER BY OnDate ', ['BMI']);
        var currResult;
        if (result != undefined && result.length > 0) {
            for (var resultItr = 0, resultLen = result.length; resultItr < resultLen; resultItr++) {
                if (tabIndex > 1 || resultItr % 3 == 0) {
                    currResult = result[resultItr].BMI;
                    BMI.push(currResult);
                    
                    if (currResult < smallest && currResult > 0) {
                        smallest = currResult;
                    }
                }
            }
            
            //Prevent Asymptote by not jumping from 0 to values
            yMin = (Math.floor((smallest * (9 / 10))));
            for (var BMIItr = 0, BMILen = BMI.length; BMIItr < BMILen; BMIItr++) {
                if (BMI[BMIItr] == '0') {
                    BMI[BMIItr] = yMin - 1;
                }
            }
        }
        
        //No data 
        if (smallest == 99999999) {
            smallest = 0;
        }
        
        var htmlContent = "<!DOCTYPE html> <html> <head> ";
        htmlContent += laf.device.os({
            iphone: "<script src='../../library/RGraph.common.core.js'></script> <script src='../../library/RGraph.line.js'></script> <script> ",
            android: "<script src='file:///android_asset/Resources/library/RGraph.common.core.js'></script> <script src='file:///android_asset/Resources/library/RGraph.line.js'></script> <script> "
        });
        htmlContent += "window.onload = function() { var line = new RGraph.Line('line', [" +
        BMI +
        "]); " +
        "line.Set('chart.key', ['BMI']); " +
        "line.Set('chart.key.background', '#fff'); " +
        "line.Set('chart.key.shadow', true); " +
        "line.Set('chart.gutter', 35); " +
        "line.Set('chart.scale.decimals', 0); " +
        "line.Set('chart.ymin', " +
        yMin +
        "); " +
        "line.Set('chart.filled', false); " +
        "line.Set('chart.tickmarks', null); " +
        "line.Set('chart.background.barcolor1', 'white'); " +
        "line.Set('chart.background.barcolor2', 'white'); " +
        "line.Set('chart.title', 'Body Mass Index'); " +
        "line.Set('chart.colors', ['green']); " +
        "line.Set('chart.yaxispos', 'left'); " +
        "line.Set('chart.linewidth', 3); " +
        "line.Draw();} " +
        "</script> </head> " +
        "<body leftmargin=0px marginheight=0px marginwidth=0px topmargin=0px rightmargin=0px> ";
        
        htmlContent += laf.device.os({
            iphone: "<div> <div> <canvas id=line width=500px height=260px> [Please wait...] </canvas> </div> </div> </body> </html> ",
            android: "<div> <div> <canvas id=line width=520px height=240px> [Please wait...] </canvas> </div> </div> </body> </html> "
        });
        vwGraph.setHtml(htmlContent);
    }
    
    //=== EVENT =====================================
    win.addEventListener('close', function(){
        if (currOrientation == Ti.UI.PORTRAIT || currOrientation == Ti.UI.UPSIDE_PORTRAIT) {
            Ti.UI.orientation = currOrientation;
        }
    });
    
    //=== DISPLAY ===================================    
    vwGraph = new graph(2, tabNames, loadGraph);
    loadGraph(2);
})();
