(function(){
    //=== HEADER & DATA =============================
    Ti.include('../../common/winHeader.js');
    
    var progressPhotos = (winData.progressPhotos != undefined) ? winData.progressPhotos : [];
    var imageDate = (winData.imageDate != undefined) ? winData.imageDate : undefined;
    
    var member = (laf.object.isSaved('Member')) ? laf.object.load('Member') : undefined;
    var memberID = (member == undefined || member.ID == undefined) ? '0' : member.ID.toString();
    var memberDir = Ti.Filesystem.getFile(Ti.Filesystem.applicationDataDirectory, memberID);
    
    for (var indexItr = 0, indexLen = progressPhotos.length; indexItr < indexLen; indexItr++) {
        if (progressPhotos[indexItr] == imageDate) {
            var index = indexItr;
            break;
        }
    }
    
    var result = {};
    var xStart;
    
    //=== OBJECTS ===================================		
    var ivPhoto = Ti.UI.createImageView({
        width: 320,
        height: 320,
        top: (laf.device.isiPhone()) ? 0 : 20,
        left: 0,
        right: 0,
        bottom: (laf.device.isiPhone()) ? 0 : 30
    });
    
    var lblDate = Ti.UI.createLabel({
        color: 'white',
        textAlign: 'left',
        height: 20,
        top: 0,
        left: 5
    });
    
    var lblStats = Ti.UI.createLabel({
        color: 'white',
        textAlign: 'right',
        height: 20,
        top: 0,
        right: 5
    });
    
    var btnLeft = Ti.UI.createButton({
        bottom: 12,
        left: 40,
        height: 30,
        width: 30,
        backgroundImage: laf.path.images + 'arrowLeft.png',
        visible: (index == 0) ? false : true
    });
    
    var btnRight = Ti.UI.createButton({
        bottom: 12,
        right: 40,
        height: 30,
        width: 30,
        backgroundImage: laf.path.images + 'arrowRight.png',
        visible: (index == progressPhotos.length - 1) ? false : true
    });
    
    var btnMiddle = Ti.UI.createButton({
        bottom: 7,
        height: 40,
        width: 40,
        backgroundImage: laf.path.images + 'edit2.png'
    });
    
    //=== FUNCTIONS ================================
    function getStatsHistoryByDate(queryDate){
        var statsHistory = '';
        
        var result = laf.data.workoutScalar('SELECT Weight FROM WeightOnDate WHERE OnDate = "' + queryDate + '" ');
        if (result != null) {
            statsHistory += result.toString() + ' lbs';
        }
        
        result = laf.data.workoutScalar('SELECT BodyFat FROM BodyFatOnDate WHERE OnDate = "' + queryDate + '" ');
        if (result != null) {
            if (statsHistory.length > 0) {
                statsHistory += ', ';
            }
            statsHistory += result + '% fat';
        }
        
        return statsHistory;
    }
    
    function setPhotoInfo(photo){
        lblDate.text = photo.toString().substring(0, photo.toString().indexOf('.'));
        lblStats.text = '';
        ivPhoto.image = memberDir.nativePath + '/' + photo;
        lblStats.text = getStatsHistoryByDate(laf.dateTime.toDateString(lblDate.text));
    }
    
    //=== EVENTS ===================================
    btnLeft.addEventListener('click', function(e){
        setPhotoInfo(progressPhotos[--index]);
        btnRight.visible = (index == progressPhotos.length - 1) ? false : true;
        btnLeft.visible = (index == 0) ? false : true;
    });
    
    btnRight.addEventListener('click', function(e){
        setPhotoInfo(progressPhotos[++index]);
        btnRight.visible = (index == progressPhotos.length - 1) ? false : true;
        btnLeft.visible = (index == 0) ? false : true;
    });
    
    btnMiddle.addEventListener('click', function(e){
        var dlgPhotoViewOptions;
        
        if (laf.device.isAndroid()) {
            dlgPhotoViewOptions = Ti.UI.createOptionDialog({				
                options: ['Delete', 'Share'],                
                buttonNames: ['Cancel']
            });
        }
        else {
            dlgPhotoViewOptions = Ti.UI.createOptionDialog({				
                options: ['Delete', 'Share', 'Cancel'],
                destructive: 0,
                cancel: 2
            });
        }
        
        dlgPhotoViewOptions.addEventListener('click', function(e){
            if (e.index == 0 && (!laf.device.isAndroid() || !e.button)) {
            
                laf.window.alert('Confirmation', 'Are you sure you want to delete?', ['Yes', 'No'], function(msg){
                    if (msg.index == 0) {
                        var file = Ti.Filesystem.getFile(memberDir.nativePath, lblDate.text + '.png');
                        
                        if (file.exists()) {
                            file.deleteFile();
                            progressPhotos.splice(index, 1);
                            
                            laf.window.fire('PhotosChange', {
                                index: index
                            });
                            
                            if (index == progressPhotos.length) {
                                --index;
                            }
                            
                            if (progressPhotos.length == 0) {
                                lblDate.text = '';
                                lblStats.text = '';
                                btnMiddle.visible = false;
                                ivPhoto.image = laf.path.images + 'photo.png';
                            }
                            else {
                                setPhotoInfo(progressPhotos[index]);
                                btnRight.visible = (index == progressPhotos.length - 1) ? false : true;
                                btnLeft.visible = (index == 0) ? false : true;
                            }
                        }
                    }
                });
            }
            if (e.index == 1) {
            
				//This coding was taken from the kitchen sink app.  Would work but have to change structure of program
                Ti.Media.openPhotoGallery({
                    allowEditing: true,
                    
                    success: function(event){
                        var emailDialog = Ti.UI.createEmailDialog();
                        if (!emailDialog.isSupported()) {
                            Ti.UI.createAlertDialog({
                                title: 'Error',
                                message: 'Email not available'
                            }).show();
                            return;
                        }
                        
                        var currPhoto = progressPhotos[index];
                        var currDate = currPhoto.toString().substring(0, currPhoto.toString().indexOf('.'));
                        emailDialog.setSubject('LA Fitness: Progress Photo ' + currDate);
                        
                        emailDialog.setMessageBody(currDate + ' \n' + getStatsHistoryByDate(laf.dateTime.toDateString(currDate)));
                        
						// attach a blob
                        emailDialog.addAttachment(event.media);
                        emailDialog.open();
                    }                                  
                });
                
				//This coding would attach the image but once receieve, the attachment would be empty.  (tested on android)
                //var currPhoto = progressPhotos[index];
                //var currDate = currPhoto.toString().substring(0, currPhoto.toString().indexOf('.'));                
                //var emailDialog = Ti.UI.createEmailDialog();
                //emailDialog.setSubject('LA Fitness: Progress Photo ' + currDate);
                //emailDialog.setMessageBody(currDate + ' \n' + getStatsHistoryByDate(laf.dateTime.toDateString(currDate)));
                //emailDialog.addAttachment(Ti.Filesystem.getFile(memberDir.nativePath, currDate + '.png'));                
                //emailDialog.open();
            }
        });
        
        dlgPhotoViewOptions.show();
    });
    
    ivPhoto.addEventListener('touchstart', function(e){
        xStart = e.x;
    });
    
    ivPhoto.addEventListener('touchend', function(e){
        if (e.x > xStart) {
            if (btnRight.visible == true) {
                setPhotoInfo(progressPhotos[++index]);
                btnRight.visible = (index == progressPhotos.length - 1) ? false : true;
                btnLeft.visible = (index == 0) ? false : true;
            }
        }
        else {
            if (btnLeft.visible == true) {
                setPhotoInfo(progressPhotos[--index]);
                btnRight.visible = (index == progressPhotos.length - 1) ? false : true;
                btnLeft.visible = (index == 0) ? false : true;
            }
        }
    });
    
    //=== DISPLAY ==================================
    vwMain.backgroundColor = 'black';
    vwMain.add(ivPhoto);
    vwMain.add(lblDate);
    vwMain.add(lblStats);
    vwMain.add(btnLeft);
    vwMain.add(btnRight);
    vwMain.add(btnMiddle);
    
    setPhotoInfo(progressPhotos[index]);
})();
