(function(){
    //=== HEADER & DATA =============================
    Ti.include('../../common/winHeader.js');

    //=== OBJECTS =============================	
    var vwHeader = Ti.UI.createView({
        left: 0,
        right: 0,
        top: 0,
        height: 48,
        backgroundColor: '#576996'
    });
    vwHeader.add(Ti.UI.createLabel({
        color: 'white',
        font: {
            fontSize: 18,
            fontWeight: 'bold'
        },
        left: 5,
        minimumFontSize: 10,
        text: 'RMR'
    }));
    vwHeader.add(Ti.UI.createLabel({
        color: 'white',
        font: {
            fontSize: 18,
            fontWeight: 'bold'
        },
        right: 5,
        minimumFontSize: 10,
		textAlign: 'right',
        text: (winData.RMR != undefined) ? winData.RMR : ''
    }));
    
    var tvProgressRMR = Ti.UI.createTableView({
		top: 48,
        backgroundColor: 'white',
        rowBackgroundColor: 'transparent',
        separatorColor: 'transparent'
    });
    
    //=== FUNCTIONS =============================
    function createTableRow(){
		var data = [];		
        data.push(laf.table.section('Resting Metabolic Rate'));
		data.push(laf.table.infoRow('\nResting Metabolic Rate is an estimate of how many calories you would burn if you were to do nothing but rest for 24 hours. It is representative of the minimum amount of energy your body requires to function. This estimate does not take into account body composition or metabolic state.\r\n'));        
        laf.table.hideEmptyRows(tvProgressRMR, true);
        tvProgressRMR.setData(data);
    }
    //=== EVENTS =============================
    
    //=== DISPLAY =============================
	vwMain.add(vwHeader);
    vwMain.add(tvProgressRMR);
    createTableRow();
})();
