(function(){
    //=== HEADER & DATA =============================
    Ti.include('../../common/winHeader.js');
    
    var strRecovery, strTHR, strAnaerobic, strRedLine;
    strRecovery = strTHR = strAnaerobic = strRedLine = 0;
    
    if (winData.Age != undefined) {
        var age = parseInt(winData.Age, 10);
        maxHeartRate = 191.5 - (0.007 * age * age);
        
        strRecovery = parseInt(maxHeartRate * 0.6, 10) + '-' + parseInt(maxHeartRate * 0.7, 10);
        strTHR = parseInt(maxHeartRate * 0.7, 10) + '-' + parseInt(maxHeartRate * 0.8, 10);
        strAnaerobic = parseInt(maxHeartRate * 0.8, 10) + '-' + parseInt(maxHeartRate * 0.9, 10);
        strRedLine = parseInt(maxHeartRate * 0.9, 10) + '-' + parseInt(maxHeartRate, 10);
    }
    
    //=== OBJECTS =============================
    var vwHeader = Ti.UI.createView({
        left: 0,
        right: 0,
        top: 0,
        height: 48,
        backgroundColor: '#576996'
    });
    vwHeader.add(Ti.UI.createLabel({
        color: 'white',
        font: {
            fontSize: 18,
            fontWeight: 'bold'
        },
        left: 5,
        minimumFontSize: 10,
        text: 'Heart Rate Zones'
    }));
    
    var tvProgressTHR = Ti.UI.createTableView({
        top: 48,
        backgroundColor: 'white',
        rowBackgroundColor: 'transparent',
        separatorColor: 'transparent' //'#e1e1e1'
    });
    
    function newZoneRow(range, details){
        var tvrRow = Ti.UI.createTableViewRow({
            height: 140
        });
        laf.table.ignoreRowSelection(tvrRow);
        
        tvrRow.add(Ti.UI.createLabel({
            color: '#576996',
            font: {
                fontSize: 18,
                fontFamily: 'Arial',
                fontWeight: 'bold'
            
            },
            top: 10,
            height: 20,
            textAlign: 'center',
            text: range + ' BPM'
        }));
        
        tvrRow.add(Ti.UI.createLabel({
            font: {
                fontSize: 16,
                fontFamily: 'Arial'
            },
            top: 12,
            height: 140,
            left: 5,
            textAlign: 'left',
            text: details
        }));
        
        return tvrRow;
    }
    
    //=== FUNCTIONS =============================
    function createTableLabelRight(description){
        return Ti.UI.createLabel({
            color: '#576996',
            font: {
                fontSize: 16,
                fontFamily: 'Arial'
            },
            top: 10,
            height: 20,
            right: laf.table.detailsRight,
            textAlign: 'right',
            text: description
        });
    }
    
    function createTableLabelLeft(description){
        return Ti.UI.createLabel({
            font: {
                fontSize: 16,
                fontFamily: 'Arial'
            },
            top: 10,
            height: 20,
            left: 5,
            right: laf.table.leftDataRightMargin,
            textAlign: 'left',
            text: description
        });
    }
    
    function createTableLabelBody(description, top){
        return Ti.UI.createLabel({
            font: {
                fontSize: 16,
                fontFamily: 'Arial'
            },
            top: (top == undefined) ? 30 : top,
            height: 140,
            left: 5,
            textAlign: 'left',
            text: description
        });
    }
    
    function createTableRow(){
        var data = [];
        
        data.push(laf.table.infoRow('Heart rate ranges are estimates based on average values and may be inaccurate for the highly athletic, children, smaller individuals, and those on blood pressure medication.\n'));
        
        data.push(laf.table.section('Warmup / Recovery'));
        data.push(newZoneRow(strRecovery, 'Warmup / Recovery zone training works toward endurance and aerobic capacity. The body becomes more efficient at feeding and working muscles while metabolizing fat.'));
        
        data.push(laf.table.section('Target / Aerobic'));
        data.push(newZoneRow(strTHR, 'Target Heart Rate or Aerobic Zone training provides the most benefit to cardiovascular fitness, while also helping increase overall muscle strength.'));
        
        data.push(laf.table.section('Anaerobic'));
        data.push(newZoneRow(strAnaerobic, 'Anaerobic Zone training develops your lactic acid system. The body utilizes less energy from fat and instead uses glycogen stored within muscle.'));
        
        data.push(laf.table.section('Red Line / VO2 Max'));
        data.push(newZoneRow(strRedLine, 'Red Line Zone or VO2 Max training is only possible for short periods and should only be done by the very fit to train fast twitch muscle fibers.'));
        
        tvProgressTHR.setData(data);
    }
    //=== EVENTS =============================
    
    //=== DISPLAY =============================
    vwMain.add(vwHeader);
    vwMain.add(tvProgressTHR);
    createTableRow();
})();
