function summary(){
    //=== HEADER & DATA =============================
    var buttonsEnabled = true;
    
    //=== OBJECTS ===================================	
    var vwSummary = Ti.UI.createView({
        backgroundColor: '#F2F2F2',
        top: 0,
        bottom: 0
    });
    
    vwSummary.add(Ti.UI.createView({
        backgroundImage: laf.path.images + 'background.png',
        left: 0,
        right: 0,
        top: 0,
        bottom: 0,
        opacity: 0.85
    }));
    
    var tvSummary = Ti.UI.createTableView({
        backgroundColor: 'transparent',
        rowBackgroundColor: 'transparent',
        separatorColor: 'transparent'
    });
    vwSummary.add(tvSummary);
    
    function createButton(align, title, image){
        var btnView = Ti.UI.createView({
            height: 100,
            width: 90,
            bottom: 20,
            borderRadius: 10,
            name: title
        });
        if (align == 0) {
            btnView.left = 5;
        }
        if (align == 2) {
            btnView.right = 5;
        }
        btnView.add(Ti.UI.createView({
            backgroundImage: laf.path.images + image,
            height: 48,
            left: 20,
            width: 48,
            top: 5,
            borderRadius: 10
        }));
        btnView.add(Ti.UI.createLabel({
            color: '#D9D9D9',
            font: {
                fontWeight: 'bold'
            },
            height: 40,
            left: 0,
            width: 90,
            top: 60,
            text: title,
            textAlign: 'center'
        }));
        btnView.addEventListener('click', function(e){
            buttonClick(btnView);
        });
        return btnView;
    }
    
    //=== FUNCTIONS =================================
    function buttonClick(sourceButton){
        if (buttonsEnabled) { //Prevent multiple clicks
            buttonsEnabled = false;
            sourceButton.backgroundColor = '#576996';// '#C5CCD4';
            setTimeout(function(){
                switch (sourceButton.name) {
                    case 'Fitness\nTips':
                        laf.window.create('Fitness Tips', 'views/track/tips.js');
                        laf.window.open();
                        break;
                    case 'Video\nTest':
                        if (laf.network.isConnected(true)) {
                            laf.window.create('Contact Us', 'views/common/videoPlayer.js');
                            laf.window.open();
                        }
                        break;						
                    case 'Friends\nProgress':
                        if (laf.network.isConnected(true)) {
                            //laf.window.create('Contact Us', 'views/about/contactUs.js');
                            //laf.window.open();
                        }
                        break;
                }
                sourceButton.backgroundColor = 'transparent';
                buttonsEnabled = true;
            }, 600);
        }
    }
    
    function setData(){
        Ti.API.info('Set Data');
        
        var data = [];
        
        var tvRow = Ti.UI.createTableViewRow({
            height: 120,
            className: 'buttonsAndText'
        });
        laf.table.ignoreRowSelection(tvRow);
        
        tvRow.add(createButton(0, 'Fitness\nTips', 'check.png'));
        tvRow.add(createButton(1, 'Video\nTest', 'star.png'));		
        tvRow.add(createButton(2, 'Friends\nProgress', 'chat.png'));
        data.push(tvRow);
        
        tvSummary.setData(data);
    }
    
    //=== EVENTS ====================================
    
    //=== DISPLAY ===================================
    this.hide = function(){
        vwSummary.visible = false;
    };
    
    this.refresh = function(){
        setData();
    };
    
    this.show = function(){
        vwSummary.visible = true;
    };
    
    this.view = function(){
        return vwSummary;
    };
};
