(function(){
    //=== HEADER & DATA =============================  
	Ti.include('../../common/winHeader.js');
	  
    var numberOfTips = 0;
    var currentTipID = 0;
    
    //=== OBJECTS ===================================	
    var vwTips = Ti.UI.createView({
        backgroundColor: '#F2F2F2',
        top: 0,
        bottom: 0
    });
	
	vwTips.add(Ti.UI.createView({
        backgroundImage: laf.path.images + 'background3.png',
        left: 0,
        right: 0,
        top: 0,
        bottom: 0,
        opacity: 0.20
    }));
    
    var vwHeader = Ti.UI.createView({
        left: 0,
        right: 0,
        top: 0,
        height: (Ti.Gesture.orientation != 1) ? 30 : 50,
        backgroundColor: '#576996'
    });
    
    vwHeader.add(Ti.UI.createView({
        backgroundImage: laf.path.images + 'check.png',
        left: 5,
        width: 30,
        height: 30
    }));
    
    vwHeader.add(Ti.UI.createLabel({
        color: '#FFFFFF',
        font: {
            fontSize: 18,
            fontWeight: 'bold',
            fontFamily: 'Arial'
        },
        top: 5,
        left: 45,
        textAlign: 'Left',
        text: 'Fitness Tips'
    }));
    
    var btnShake = Ti.UI.createButton({
        title: 'Shake',
        color: 'black',
        font: {
            fontSize: 25,
            fontFamily: 'Helvetica'
        },
        bottom: 10,
        width: 220,
        height: (Ti.Gesture.orientation != 1) ? 30 : 40,
        backgroundImage: laf.path.images + 'BUTT_gry_off.png',
        backgroundSelectedImage: laf.path.images + 'BUTT_gry_on.png'
    });
    
    var lblStart = Ti.UI.createLabel({
        //color: 'black',
		color: (Titanium.Platform.name == 'iPhone OS') ? '#4D576D' : '#BDBEBD',
        font: {
            fontSize: 22,
            fontWeight: 'Bold',
            fontFamily: 'Helvetica'
        },
        textAlign: 'center',
        shadowColor: '#FAFAFA',
        shadowOffset: {
            x: 1,
            y: 1
        },
        text: 'Shake your device\nfor fitness tips.'
    });
    
    var lblTips = Ti.UI.createLabel({
        color: 'black',
        font: {
            fontSize: (Ti.Gesture.orientation != 1) ? 18 : 22,
            fontFamily: 'Arial'
        },
        textAlign: 'left',
        text: '',
        left: 5,
        right: 5
    });
    
    vwTips.add(vwHeader);
    vwTips.add(btnShake);
    vwTips.add(lblStart);
    vwTips.add(lblTips);
    
    //=== FUNCTIONS =================================
    function getRandomTip(){
        if (numberOfTips == 0) {
            numberOfTips = parseInt(laf.data.fitnessTipsScalar('SELECT COUNT(*) FROM FitnessTips'), 10);
        }
        
        var randomNumber = 0;
        while (randomNumber == 0 || randomNumber == currentTipID) {
            randomNumber = Math.floor(Math.random() * numberOfTips);
        }
        currentTipID = randomNumber;
        lblStart.visible = false;
        lblTips.visible = true;
        
        lblTips.text = laf.data.fitnessTipsScalar('SELECT text FROM FitnessTips WHERE ID = ' + currentTipID + ' ');
    }
    
    //=== EVENTS ====================================		
    Ti.Gesture.addEventListener('shake', function(e){
        getRandomTip();
    });
    
    btnShake.addEventListener('click', function(){
        getRandomTip();
    });
    
    Ti.Gesture.addEventListener('orientationchange', function(e){
        vwHeader.height = (e.orientation != 1) ? 30 : 50;
        btnShake.height = (e.orientation != 1) ? 30 : 40;
        lblTips.font = {
            fontSize: (e.orientation != 1) ? 18 : 22
        };
    });
    
    //=== DISPLAY ===================================
	vwMain.add(vwTips);
})();
