function workout(){
    //=== HEADER & DATA =============================   
    var routines = laf.data.workoutSet('SELECT GUID, RoutineName, RoutineOrderID FROM WorkoutPlan WHERE Inactive = "0" ORDER BY RoutineOrderID, CreateUTC DESC', ['GUID', 'Name', 'OrderID']);
    var deletedRoutines = [];
    
    //=== OBJECTS ===================================
    var vwActivity = new activityIndicator();
    
    var vwWorkout = Ti.UI.createView({
        top: 0,
        bottom: 0
    });
    
    vwWorkout.add(Ti.UI.createView({
        backgroundImage: laf.path.images + 'background.png',
        left: 0,
        right: 0,
        top: 0,
        bottom: 0,
        opacity: 0.20
    }));
    
    var vwHeader = Ti.UI.createView({
        left: 0,
        right: 0,
        top: 0,
        height: 48,
        backgroundColor: '#576996'
    });
    
    var btnAddExercise = Ti.UI.createButton({
        left: 5,
        title: '+ Record Exercise',
        color: 'black',
        opacity: 0.5,
        enabled: false,
        font: {
            fontSize: 15,
            fontFamily: 'Helvetica'
        },
        width: 150,
        top: 2,
        bottom: 2,
        backgroundImage: laf.path.images + 'BUTT_gry_off.png',
        backgroundSelectedImage: laf.path.images + 'BUTT_gry_on.png'
    });
    vwHeader.add(btnAddExercise);
    
    var btnAddRoutine = Ti.UI.createButton({
        right: 5,
        title: '+ New Routine',
        color: 'black',
        font: {
            fontSize: 15,
            fontFamily: 'Helvetica'
        },
        width: 150,
        top: 2,
        bottom: 2,
        backgroundImage: laf.path.images + 'BUTT_gry_off.png',
        backgroundSelectedImage: laf.path.images + 'BUTT_gry_on.png'
    });
    vwHeader.add(btnAddRoutine);
    
    var tvRoutines = Ti.UI.createTableView({
        backgroundColor: 'transparent',
        rowBackgroundColor: 'transparent',
        separatorColor: '#e1e1e1',
        top: 48,
        editable: true
    });
    
    var btnEdit = Ti.UI.createButton({
        title: 'Edit'
    });
    
    var btnDone = Ti.UI.createButton({
        title: 'Done',
        style: Ti.UI.iPhone.SystemButtonStyle.DONE
    });
    
    function newRoutineRow(planGUID, routineName, routineSummary){
        var tvrRoutineRow = Ti.UI.createTableViewRow({
            height: 50,
            className: 'workoutRoutineRow',
            hasChild: true,
            guid: planGUID
        });
        
        tvrRoutineRow.add(Ti.UI.createLabel({
            font: {
                fontSize: 16,
                fontWeight: 'bold',
                fontFamily: 'Arial'
            },
            color: 'black',
            top: 5,
            left: 5,
            right: laf.table.leftDataRightMargin,
            height: 20,
            textAlign: 'left',
            text: routineName
        }));
        
        tvrRoutineRow.add(Ti.UI.createLabel({
            color: '#7F7F7F',
            font: {
                fontSize: 14,
                fontFamily: 'Arial'
            },
            top: 25,
            left: 5,
            right: laf.table.leftDataRightMargin,
            height: 20,
            textAlign: 'left',
            text: routineSummary
        }));
        
        laf.table.makeRowSelectable(tvrRoutineRow);
        return tvrRoutineRow;
    }
    
    //=== FUNCTIONS =================================  
    function setRoutineRows(){
        var data = [];
        
        data.push(laf.table.section('Routines'));
        if (routines == undefined || routines == null || routines.length == 0) {
            setRightNav(null);
            tvRoutines.touchEnabled = false;
            tvRoutines.backgroundColor = 'transparent';
            tvRoutines.separatorColor = 'transparent';
            
            var tvrNoRoutines = Ti.UI.createTableViewRow({
                height: 105,
                className: 'workoutNoRoutines'
            });
            tvrNoRoutines.add(Ti.UI.createLabel({
                color: 'black',
                font: {
                    fontSize: 18,
                    fontFamily: 'Arial'
                },
                top: 15,
                left: 5,
                right: 5,
                height: 120,
                textAlign: 'center',
                text: 'No workout routines saved.\n\nClick \'New Routine\' to setup one\nor click \'Record Exercise\' to record\nindividual exercises.'
            }));
            data.push(tvrNoRoutines);
        }
        else {
            setRightNav(btnEdit);
            tvRoutines.touchEnabled = true;
            tvRoutines.backgroundColor = 'white';
            tvRoutines.separatorColor = '#e1e1e1';
            
            var sqlQueryExID;
            var sqlQueryMuGr;
            var routineSummary = '';
            
            for (var routineItr = 0, routineLen = routines.length; routineItr < routineLen; routineItr++) {
                var currRoutine = routines[routineItr];
                sqlQueryExID = laf.data.workoutSet('SELECT ExerciseID FROM WorkoutRoutine WHERE PlanGUID = "' + currRoutine.GUID + '" AND Inactive = "0" ');
                
                for (var sqlQueryItr = 0, sqlQueryLen = sqlQueryExID.length; sqlQueryItr < sqlQueryLen; sqlQueryItr++) {
                    sqlQueryMuGr = laf.data.exerciseRow('SELECT MuscleID FROM Exercise WHERE ExerciseID = "' + sqlQueryExID[sqlQueryItr].ExerciseID + '" AND Inactive = "0" ');
                    if (sqlQueryMuGr.MuscleID == null || sqlQueryMuGr.MuscleID == 'NULL') {
                        if (routineSummary.indexOf('Cardio') == -1) {
                            routineSummary += (routineSummary.length == 0) ? 'Cardio' : ', Cardio';
                        }
                    }
                    else {
                        sqlQueryMuGr = laf.data.exerciseRow('SELECT mg.Name FROM Exercise ex, Muscle mu, MuscleGroup mg WHERE ex.ExerciseID = "' + sqlQueryExID[sqlQueryItr].ExerciseID + '" AND mu.MuscleID = ex.MuscleID AND mg.MuscleGroupID = mu.MuscleGroupID AND ex.Inactive = "0" AND mu.Inactive = "0" AND mg.Inactive = "0" ');
                        if (routineSummary.indexOf(sqlQueryMuGr.Name) == -1) {
                            routineSummary += (routineSummary.length == 0) ? sqlQueryMuGr.Name : ', ' + sqlQueryMuGr.Name;
                        }
                    }
                }
                
                data.push(newRoutineRow(currRoutine.GUID, currRoutine.Name, routineSummary));
            }
        }
        
        tvRoutines.setData(data);
        laf.table.scrollToTop(tvRoutines, false);
    }
    
    function moveRow(fromIndex, toIndex){
        if (fromIndex != toIndex) {
            var toCopy = routines[fromIndex];
            routines.splice(fromIndex, 1);
            routines.splice(toIndex, 0, toCopy);
            
            var minIndex = (fromIndex < toIndex) ? fromIndex : toIndex;
            var maxIndex = (toIndex > fromIndex) ? toIndex : fromIndex;
            
            for (var moveIndexItr = minIndex; moveIndexItr <= maxIndex; moveIndexItr++) {
                var currRoutine = routines[moveIndexItr];
                if (currRoutine != undefined) {
                    currRoutine.OrderID = moveIndexItr;
                }
            }
            
            //Android doesn't move rows for us automatically
            if (!laf.device.isiPhone()) {
                setRoutineRows();
            }
        }
    }
    
    //=== EVENTS ====================================    
    btnAddRoutine.addEventListener('click', function(){
        laf.window.create('Routine', '/views/track/workoutRoutineAdd.js');
        laf.window.open();
    });
    
    btnEdit.addEventListener('click', function(){
        tvRoutines.editing = tvRoutines.moving = true;
        setRightNav(btnDone);
    });
    
    btnDone.addEventListener('click', function(){
        //Check for moved rows, update DB when different
        for (var routineItr = 0, routineLen = routines.length; routineItr < routineLen; routineItr++) {
            var currRoutine = routines[routineItr];
            var orderID = laf.data.workoutScalar('SELECT RoutineOrderID FROM WorkoutPlan WHERE GUID = "' + currRoutine.GUID + '"');
            if (orderID != currRoutine.OrderID) {
                laf.data.workoutMakeSync('WorkoutPlan', currRoutine.GUID, false, ['RoutineOrderID'], [currRoutine.OrderID]);
            }
        }
        
        //Remove deleted routines
        for (var deletedRoutineItr = 0, deletedRoutineLen = deletedRoutines.length; deletedRoutineItr < deletedRoutineLen; deletedRoutineItr++) {
            var currGUID = deletedRoutines[deletedRoutineItr];
            laf.data.workoutMakeSync('WorkoutPlan', currGUID, true);
            laf.data.workoutNonQuery('DELETE FROM WorkoutRoutine WHERE PlanGUID = "' + currGUID + '" ');
        }
        deletedRoutines = [];
        
        tvRoutines.moving = tvRoutines.editing = false;
        if (routines == undefined || routines.length == 0) {
            routines = [];
            setRoutineRows();
        }
        else {
            setRightNav(btnEdit);
        }
    });
    
    tvRoutines.addEventListener('delete', function(e){
        deletedRoutines.push(e.rowData.guid);
        routines.splice(e.index, 1);
    });
    
    tvRoutines.addEventListener('move', function(e){
        moveRow(e.fromIndex, e.index);
    });
    
    tvRoutines.addEventListener('click', function(e){
        if (e.rowData != undefined && e.rowData.guid != undefined) {
            laf.window.create('Routine', '/views/track/workoutRoutine.js', {
                editMode: false,
                planGUID: e.rowData.guid
            });
            laf.window.open();
        }
    });
    
    laf.window.listen('RoutineUpdated', function(){
        routines = laf.data.workoutSet('SELECT GUID, RoutineName, RoutineOrderID FROM WorkoutPlan WHERE Inactive = "0" ORDER BY RoutineOrderID, CreateUTC DESC', ['GUID', 'Name', 'OrderID']);
        setRoutineRows();
    });
    
    //=== DISPLAY ===================================
    vwWorkout.add(vwHeader);
    vwWorkout.add(tvRoutines);
    
    this.hide = function(){
        vwWorkout.visible = false;
        setRightNav(null);
    };
    
    this.show = function(){
        vwWorkout.visible = true;
        if (routines != undefined && routines.length > 0) {
            setRightNav((tvRoutines.moving) ? btnDone : btnEdit);
        }
    };
    
    this.view = function(){
        return vwWorkout;
    };
    
    this.refresh = function(){
        vwActivity.show('Loading...');
        deletedRoutines = [];
        setRoutineRows();
        vwActivity.hide();
    };
};
