(function(){
    //=== HEADER & DATA =============================
    Ti.include('../../common/winHeader.js');
    
    var planGUID = (winData.planGUID != undefined) ? winData.planGUID : undefined;
    var routineName = laf.data.workoutScalar('SELECT RoutineName FROM WorkoutPlan WHERE GUID = "' + planGUID + '"');
    var routine = laf.data.workoutSet('SELECT GUID, ExerciseID, Sets, SetsMax, Reps, RepsMax, Duration, DurationMax, Distance, DistanceMax, OrderID FROM WorkoutRoutine WHERE PlanGUID = "' + planGUID + '" AND Inactive = "0" ORDER BY OrderID', ['GUID', 'ExerciseID', 'Sets', 'SetsMax', 'Reps', 'RepsMax', 'Duration', 'DurationMax', 'Distance', 'DistanceMax', 'OrderID']);
    var editMode = routine.length == 0 ? true : ((winData.editMode != undefined) ? winData.editMode : false);
    var deletedExercises = [];
    
    //=== OBJECTS ===================================
    vwMain.add(Ti.UI.createView({
        backgroundImage: laf.path.images + 'background.png',
        left: 0,
        right: 0,
        top: 0,
        bottom: 0,
        opacity: 0.20
    }));
    
    var vwHeader = Ti.UI.createView({
        top: 0,
        height: 48,
        backgroundColor: '#576996'
    });
    
    var tfRoutineName = Ti.UI.createTextField({
        color: '#336699',
        left: 5,
        right: 5,
        top: 2,
        bottom: 2,
        value: routineName,
        hintText: 'Routine Name',
        autocorrect: true,
        borderStyle: Ti.UI.INPUT_BORDERSTYLE_ROUNDED,
        keyboardType: Ti.UI.KEYBOARD_DEFAULT,
        autocapitalization: Titanium.UI.TEXT_AUTOCAPITALIZATION_SENTENCES,
        returnKeyType: Ti.UI.RETURNKEY_DONE,
        clearButtonMode: Ti.UI.INPUT_BUTTONMODE_ONFOCUS
    });
    vwHeader.add(tfRoutineName);
    
    var vwRoutineImg = Ti.UI.createView({
        backgroundImage: laf.path.images + 'weightLift.png',
        left: 5,
        width: 29,
        height: 29
    });
    vwHeader.add(vwRoutineImg);
    
    var lblRoutineName = Ti.UI.createLabel({
        color: 'white',
        font: {
            fontSize: 18,
            fontWeight: 'Bold',
            fontFamily: 'Arial'
        },
        left: 47,
        top: 5,
        textAlign: 'left',
        text: routineName,
        visible: false
    });
    vwHeader.add(lblRoutineName);
    
    var tvExercises = Ti.UI.createTableView({
        backgroundColor: 'white',
        rowBackgroundColor: 'transparent',
        separatorColor: '#e1e1e1',
        editable: true,
        top: '48'
    });
    
    var btnEdit = Ti.UI.createButton({
        title: 'Edit'
    });
    
    var btnDone = Ti.UI.createButton({
        title: 'Done',
        style: Ti.UI.iPhone.SystemButtonStyle.DONE
    });
    
    function getImageForExercise(currExercise){
        switch (currExercise.ExerciseTypeID + '') {
            case '0':
                return laf.path.images + 'barbell.png';
            case '1':
                return laf.path.images + 'bodyWeight.png';
            case '2':
                return laf.path.images + 'cable.png';
            case '3':
                switch (currExercise.ExerciseID) {
                    case '13':
                        return laf.path.images + 'basketball.png';
                    case '113':
                        return laf.path.images + 'racquetball.png';
                    case '137':
                        return laf.path.images + 'swimming.png';
                    case '139':
                        return laf.path.images + 'tennis.png';
                    case '148':
                        return laf.path.images + 'volleyball.png';
                    default:
                        return laf.path.images + 'cardio.png';
                }
                break;
            case '4':
                return laf.path.images + 'cardio.png';
            case '5':
                return laf.path.images + 'dumbbell.png';
            case '6':
                return laf.path.images + 'groupExercise.png';
            case '7':
                return laf.path.images + 'machine.png';
            case '8':
                return laf.path.images + 'smithMachine.png';
            case '9':
                return laf.path.images + 'classes.png';
            default:
                return laf.path.images + 'help.png';
            //return laf.path.images + 'gearGreen.png';
        }
    }
    
    function getExerciseGuidance(currRoutineStep, logTypeID){
        var strDirections = '';
        
        switch (logTypeID + '') {
            case '1': //Sets/Reps
                if (currRoutineStep.Sets != undefined && currRoutineStep.Sets > 0 && currRoutineStep.Reps != undefined && currRoutineStep.Reps > 0) {
                    if (currRoutineStep.SetsMax != undefined && currRoutineStep.SetsMax > 0 && currRoutineStep.SetsMax != currRoutineStep.Sets) {
                        strDirections += currRoutineStep.Sets + '-' + currRoutineStep.SetsMax + ' sets of ';
                    }
                    else {
                        strDirections += currRoutineStep.Sets + ' sets of ';
                    }
                    
                    if (currRoutineStep.RepsMax != undefined && currRoutineStep.RepsMax > 0 && currRoutineStep.RepsMax != currRoutineStep.Reps) {
                        strDirections += currRoutineStep.Reps + '-' + currRoutineStep.RepsMax + ' reps';
                    }
                    else {
                        strDirections += currRoutineStep.Reps + ' reps';
                    }
                }
                break;
            case '2': //Duration
                if (currRoutineStep.Duration != undefined && currRoutineStep.Duration > 0 || currRoutineStep.Distance != undefined && currRoutineStep.Distance > 0) {
                    if (currRoutineStep.DurationMax != undefined && currRoutineStep.DurationMax > 0 && currRoutineStep.DurationMax != currRoutineStep.Duration) {
                        strDirections += currRoutineStep.Duration + '-' + currRoutineStep.DurationMax + ' minutes';
                        
                        if (currRoutineStep.Distance != undefined && currRoutineStep.Distance > 0) {
                            strDirections += ' or ' + currRoutineStep.Distance + ' miles ';
                        }
                    }
                    else {
                    
                        if (currRoutineStep.Duration > 0 && currRoutineStep.Distance > 0) {
                            strDirections += currRoutineStep.Duration + ' minutes or ' + currRoutineStep.Distance + ' miles';
                        }
                        else {
                            if (currRoutineStep.Duration == undefined || currRoutineStep.Duration == 0) {
                                strDirections += currRoutineStep.Distance + ' miles';
                            }
                            else {
                                strDirections += currRoutineStep.Duration + ' minutes';
                            }
                        }
                    }
                }
                break;
            case '3': //Reps
                if (currRoutineStep.Reps != undefined && currRoutineStep.Reps > 0) {
                    if (currRoutineStep.RepsMax != undefined && currRoutineStep.RepsMax > 0 && currRoutineStep.RepsMax != currRoutineStep.Reps) {
                        strDirections += currRoutineStep.Reps + '-' + currRoutineStep.RepsMax + ' reps';
                    }
                    else {
                        strDirections += currRoutineStep.Reps + ' reps';
                    }
                }
                break;
        }
        
        return strDirections;
    }
    
    function newGearButton(currRoutineStep, currExercise){
        var btnGear = Ti.UI.createButton({
            height: 40,
            width: 40,
            right: 5,
            backgroundImage: laf.path.images + 'gear.png',
            enabled: editMode,
            opacity: editMode ? 1.0 : 0.0,
            name: 'Gear'
        });
        
        btnGear.addEventListener('click', function(){
            laf.window.create('Routine', '/views/track/workoutRoutineExGuidance.js', {
                currRoutineStep: currRoutineStep,
                currExercise: currExercise
            });
            laf.window.open();
        });
        
        laf.window.listen('workoutRoutineEditChange', function(){
            btnGear.enabled = editMode;
            btnGear.opacity = editMode ? 1.0 : 0.0;
        });
        
        return btnGear;
    }
    
    function newExerciseRow(currRoutineStep, currExercise){
        var tvrExercise = Ti.UI.createTableViewRow({
            height: 50,
            className: 'workoutRoutineExerciseRow',
            hasChild: true,
            GUID: currRoutineStep.GUID
        });
        
        //Exercise Type Image
        tvrExercise.add(Ti.UI.createView({
            backgroundImage: getImageForExercise(currExercise),
            left: 5,
            width: 30,
            height: 30
        }));
        
        tvrExercise.add(Ti.UI.createLabel({
            font: {
                fontSize: 16,
                fontWeight: 'bold',
                fontFamily: 'Arial'
            },
            color: 'black',
            top: 5,
            left: 45,
            right: laf.table.leftDataRightMargin,
            height: 20,
            textAlign: 'left',
            text: currExercise.Name
        }));
        
        tvrExercise.add(Ti.UI.createLabel({
            color: '#7F7F7F',
            font: {
                fontSize: 14,
                fontFamily: 'Arial'
            },
            top: 25,
            left: 45,
            right: laf.table.leftDataRightMargin,
            height: 20,
            textAlign: 'left',
            text: getExerciseGuidance(currRoutineStep, currExercise.LogTypeID)
        }));
        
        laf.table.makeRowSelectable(tvrExercise);
        tvrExercise.add(newGearButton(currRoutineStep, currExercise));
        return tvrExercise;
    }
    
    if (laf.device.isiPhone()) {
        var flexSpace = Ti.UI.createButton({
            systemButton: Ti.UI.iPhone.SystemButton.FLEXIBLE_SPACE
        });
    }
    
    function createButtonFooter(title, left){
        return Ti.UI.createButton({
            title: title,
            style: Titanium.UI.iPhone.SystemButtonStyle.BORDERED
        });
    }
    
    var btnAddCardio = createButtonFooter('+ Cardio');
    var btnAddMachine = createButtonFooter('+ Machine');
    var btnAddWeights = createButtonFooter('+ Weights');
    var btnAddBodyWeights = createButtonFooter('+ Body');
    
    //=== FUNCTIONS =================================
    function setExerciseRows(){
        var data = [];
        data.push(laf.table.section('Exercises'));
        
        if (routine == undefined || routine == null || routine.length == 0) {
            tvExercises.touchEnabled = false;
            tvExercises.backgroundColor = 'transparent';
            tvExercises.separatorColor = 'transparent';
            
            var tvrNoExercises = Ti.UI.createTableViewRow({
                height: 105,
                className: 'workoutRoutineNoExercises',
                moveable: false,
                editable: false
            });
            tvrNoExercises.add(Ti.UI.createLabel({
                color: 'black',
                font: {
                    fontSize: 18,
                    fontFamily: 'Arial'
                },
                top: 15,
                left: 5,
                right: 5,
                height: 120,
                textAlign: 'center',
                text: (editMode) ? 'No exercises in this routine.\n\nSelect a type below to add an exercise to this routine.' : 'No exercises in this routine.\n\nClick edit above right,\nthen select a type from the bottom\nto add one to this routine.'
            }));
            data.push(tvrNoExercises);
        }
        else {
            tvExercises.touchEnabled = true;
            tvExercises.backgroundColor = 'white';
            tvExercises.separatorColor = '#e1e1e1';
            
            for (var routineItr = 0, routineLen = routine.length; routineItr < routineLen; routineItr++) {
                var currRoutineStep = routine[routineItr];
                if (currRoutineStep != undefined) {
                    var currExercise = laf.data.exerciseRow('SELECT ExerciseID, Name, LogTypeID FROM Exercise WHERE ExerciseID = "' + currRoutineStep.ExerciseID + '"', ['ExerciseID', 'Name', 'LogTypeID']);
                    data.push(newExerciseRow(currRoutineStep, currExercise));
                }
            }
        }
        
        tvExercises.setData(data);
    }
    
    function setEditMode(){
        editMode = true;
        laf.window.fire('workoutRoutineEditChange');
        setRightNav(btnDone);
        tvExercises.editing = tvExercises.moving = true;
        
        if (laf.device.isiPhone()) {
            win.setToolbar([btnAddCardio, flexSpace, btnAddMachine, flexSpace, btnAddWeights, flexSpace, btnAddBodyWeights]);
        }
        
        tfRoutineName.visible = true;
        vwRoutineImg.visible = false;
        lblRoutineName.visible = false;
    }
    
    function setNormalMode(){
        editMode = false;
        laf.window.fire('workoutRoutineEditChange');
        setRightNav(btnEdit);
        tvExercises.editing = tvExercises.moving = false;
        
        if (laf.device.isiPhone()) {
            win.setToolbar(undefined);
        }
        
        tfRoutineName.visible = false;
        vwRoutineImg.visible = true;
        lblRoutineName.visible = true;
        tfRoutineName.blur();
    }
    
    function moveRow(fromIndex, toIndex){
        if (fromIndex != toIndex) {
            var toCopy = routine[fromIndex];
            routine.splice(fromIndex, 1);
            routine.splice(toIndex, 0, toCopy);
            
            var minIndex = (fromIndex < toIndex) ? fromIndex : toIndex;
            var maxIndex = (toIndex > fromIndex) ? toIndex : fromIndex;
            
            for (var moveIndexItr = minIndex; moveIndexItr <= maxIndex; moveIndexItr++) {
                var currRoutineStep = routine[moveIndexItr];
                if (currRoutineStep != undefined) {
                    currRoutineStep.OrderID = moveIndexItr;
                }
            }
            
            //Android doesn't move rows for us automatically
            if (!laf.device.isiPhone()) {
                setExerciseRows();
            }
        }
    }
    
    //=== EVENT =====================================
    btnEdit.addEventListener('click', function(){
        setEditMode();
    });
    
    btnDone.addEventListener('click', function(){
        if (tfRoutineName.value != routineName) {
            tfRoutineName.value = laf.verify.trim(tfRoutineName.value);
            
            if (laf.verify.isEmpty(tfRoutineName)) {
                laf.window.alert('Required', 'Please enter a name for your routine.');
                tfRoutineName.focus();
                return;
            }
            
            if (laf.data.workoutSet('Select RoutineName FROM WorkoutPlan WHERE Inactive = "0" AND lower(RoutineName) = "' + tfRoutineName.value.toLowerCase() + '" AND GUID <> "' + planGUID + '"', ['Name']).length > 0) {
                laf.window.alert('Invalid', 'You already have a routine named \'' + tfRoutineName.value + '\'.');
                tfRoutineName.value = '';
                tfRoutineName.focus();
                return;
            }
            
            laf.data.workoutMakeSync('WorkoutPlan', planGUID, false, ['RoutineName'], [tfRoutineName.value]);
            routineName = tfRoutineName.value;
            lblRoutineName.text = tfRoutineName.value;
        }
        
        //Update Routine
        if (routine != undefined) {
            for (var routineItr = 0, routineLen = routine.length; routineItr < routineLen; routineItr++) {
                var currRoutineStep = routine[routineItr];
                if (currRoutineStep != undefined) {
                    laf.data.workoutMakeSync('WorkoutRoutine', currRoutineStep.GUID, false, ['PlanGUID', 'OrderID', 'ExerciseID', 'Sets', 'SetsMax', 'Reps', 'RepsMax', 'Duration', 'DurationMax', 'Distance', 'DistanceMax'], [planGUID, currRoutineStep.OrderID, currRoutineStep.ExerciseID, currRoutineStep.Sets, currRoutineStep.SetsMax, currRoutineStep.Reps, currRoutineStep.RepsMax, currRoutineStep.Duration, currRoutineStep.DurationMax, currRoutineStep.Distance, currRoutineStep.DistanceMax]);
                }
            }
        }
        
        //Remove Deleted Exercises
        for (var deletedExerciseItr = 0, deletedExerciseLen = deletedExercises.length; deletedExerciseItr < deletedExerciseLen; deletedExerciseItr++) {
            laf.data.workoutMakeSync('WorkoutRoutine', deletedExercises[deletedExerciseItr], true);
        }
        deletedExercises = [];
        
        laf.window.fire('RoutineUpdated');
        setNormalMode();
        if (routine == undefined || routine.length == 0) {
            routine = [];
            setExerciseRows();
        }
    });
    
    btnAddCardio.addEventListener('click', function(e){
        laf.window.create('Routine', '/views/track/workoutRoutineExCardio.js');
        laf.window.open();
    });
    
    btnAddMachine.addEventListener('click', function(e){
        laf.window.create('Routine', '/views/track/workoutRoutineExMachine.js');
        laf.window.open();
    });
    
    btnAddWeights.addEventListener('click', function(e){
        laf.window.create('Routine', '/views/track/workoutRoutineExWeights.js');
        laf.window.open();
    });
    
    btnAddBodyWeights.addEventListener('click', function(e){
        laf.window.create('Routine', '/views/track/workoutRoutineExBody.js');
        laf.window.open();
    });
    
    tvExercises.addEventListener('delete', function(e){
        deletedExercises.push(e.rowData.GUID);
        routine.splice(e.index, 1);
    });
    
    tvExercises.addEventListener('move', function(e){
        moveRow(e.fromIndex, e.index);
    });
    
    tvExercises.addEventListener('click', function(e){
        if (e.source.name == 'Gear') {
            return;
        }
        
        laf.window.create('Routine', '/views/track/workoutRoutineRecord.js', {
            currRoutine: routine,
            currIndex: e.index
        });
        laf.window.open();
    });
    
    laf.window.listen('AddExercise', function(e){
        var data = [];
        
        //Get rid of any add exercise text & rows
        if (routine.length == 0) {
            tvExercises.touchEnabled = true;
            tvExercises.backgroundColor = 'white';
            tvExercises.separatorColor = '#e1e1e1';
            data.push(laf.table.section('Exercises'));
            tvExercises.setData(data);
        }
        
        var currRoutineStep = {
            PlanGUID: planGUID,
            GUID: laf.object.newGUID(),
            ExerciseID: e.exerciseID,
            OrderID: routine.length
        };
        routine.push(currRoutineStep);
        
        var currExercise = laf.data.exerciseRow('SELECT ExerciseID, Name, LogTypeID FROM Exercise WHERE ExerciseID = "' + e.exerciseID + '"', ['ExerciseID', 'Name', 'LogTypeID']);
        tvExercises.appendRow(newExerciseRow(currRoutineStep, currExercise));
        
        laf.window.create('Routine', '/views/track/workoutRoutineExGuidance.js', {
            currRoutineStep: currRoutineStep,
            currExercise: currExercise
        });
        laf.window.open();
    });
    
    laf.window.listen('NewExerciseGuidance', function(e){
        //Update Data Model
        var currRoutineStep;
        for (var routineItr = 0, routineItrLen = routine.length; routineItr < routineItrLen; routineItr++) {
            currRoutineStep = routine[routineItr];
            if (currRoutineStep != undefined && currRoutineStep.GUID == e.GUID) {
                switch (e.LogTypeID) {
                    case 1:
                        currRoutineStep.Sets = e.EntryOne;
                        currRoutineStep.Reps = e.EntryTwo;
                        break;
                    case 2:
                        currRoutineStep.Duration = e.EntryOne;
                        currRoutineStep.Distance = e.EntryTwo;
                        break;
                    case 3:
                        currRoutineStep.Reps = e.EntryOne;
                        break;
                }
                break;
            }
        }
        
        //Update Display
        if (currRoutineStep != undefined) {
            for (var rowItr = 0, rowLen = tvExercises.data[0].rows.length; rowItr < rowLen; rowItr++) {
                if (tvExercises.data[0].rows[rowItr].GUID == e.GUID) {
                    var currExercise = laf.data.exerciseRow('SELECT ExerciseID, Name, LogTypeID FROM Exercise WHERE ExerciseID = "' + currRoutineStep.ExerciseID + '"', ['ExerciseID', 'Name', 'LogTypeID']);
                    tvExercises.updateRow(rowItr, newExerciseRow(currRoutineStep, currExercise), {
                        animationStyle: Ti.UI.iPhone.RowAnimationStyle.FADE
                    });
                    break;
                }
            }
        }
    });
    
    //=== DISPLAY ===================================
    if (editMode) {
        setEditMode();
    }
    else {
        setNormalMode();
    }
    setExerciseRows();
    
    vwMain.add(vwHeader);
    vwMain.add(tvExercises);
})();
