(function(){
    //=== HEADER & DATA =============================
    Ti.include('../../common/winHeader.js');
    
    //=== OBJECTS =============================
    var tfRoutineName;
    
    var tvRoutineName = Ti.UI.createTableView({
        backgroundColor: 'white',
        rowBackgroundColor: 'transparent',
        separatorColor: 'white'
    });
    
    var btnCancel = Ti.UI.createButton({
        title: 'Cancel'
    });
    
    var btnSave = Ti.UI.createButton({
        title: 'Save',
        style: Ti.UI.iPhone.SystemButtonStyle.DONE
    });
    
    //=== FUNCTIONS =============================    
    function setNewRoutineRows(){
        var data = [];
        
        data.push(laf.table.section('New Routine'));
        
        var tvrRoutineName = Ti.UI.createTableViewRow({
            height: 320,
            className: 'workoutRoutineAdd'
        });
        laf.table.ignoreRowSelection(tvrRoutineName);
        
        tvrRoutineName.add(Ti.UI.createView({
            backgroundImage: laf.path.images + 'weightLift.png',
            height: 48,
            width: 48,
            top: 10,
            right: 10
        }));
        
        tvrRoutineName.add(Ti.UI.createLabel({
            color: 'black',
            font: {
                fontSize: 18,
                fontFamily: 'Arial'
            },
            top: 10,
            left: 10,
            right: 68,
            height: 50,
            text: 'What would you like to call your new routine?'
        }));
        
        tfRoutineName = Ti.UI.createTextField({
            color: '#336699',
            height: 40,
            left: 10,
            right: 10,
            top: 85,
            hintText: 'New Routine Name',
            autocorrect: true,
            borderStyle: Ti.UI.INPUT_BORDERSTYLE_ROUNDED,
            keyboardType: Ti.UI.KEYBOARD_DEFAULT,
            autocapitalization: Titanium.UI.TEXT_AUTOCAPITALIZATION_SENTENCES,
            returnKeyType: Ti.UI.RETURNKEY_DONE,
            clearButtonMode: Ti.UI.INPUT_BUTTONMODE_ONFOCUS
        });
        tfRoutineName.addEventListener('return', saveName);
        tvrRoutineName.add(tfRoutineName);
        
        tvrRoutineName.add(Ti.UI.createLabel({
            color: 'gray',
            font: {
                fontSize: 14,
                fontWeight: 'light',
                fontFamily: 'Arial'
            },
            top: 145,
            left: 10,
            right: 10,
            height: 20,
            textAlign: 'center',
            text: 'EXAMPLES: Sunday, Cardio, Muscle Toning'
        }));
        
        data.push(tvrRoutineName);
        
        tvRoutineName.setData(data);
        laf.table.scrollToTop(tvRoutineName, false);
    }
    
    function saveName(){
        tfRoutineName.value = laf.verify.trim(tfRoutineName.value);
        
        if (laf.verify.isEmpty(tfRoutineName)) {
            laf.window.alert('Required', 'Please enter a name for your new routine.');
            tfRoutineName.focus();
            return;
        }
		
        if (laf.data.workoutSet('Select RoutineName FROM WorkoutPlan WHERE Inactive = "0" AND lower(RoutineName) = "' + tfRoutineName.value.toLowerCase() + '"', ['Name']).length > 0) {
            laf.window.alert('Invalid', 'You already have a routine named \'' + tfRoutineName.value + '\'.');
			tfRoutineName.value = '';
            tfRoutineName.focus();
            return;			
		}

        var planGUID = laf.object.newGUID();
        laf.data.workoutMakeSync('WorkoutPlan', planGUID, false, ['RoutineOrderID', 'RoutineName'], [0, laf.verify.trim(tfRoutineName.value)]);
        laf.window.fire('RoutineUpdated');
        
        laf.window.create('Routine', '/views/track/workoutRoutine.js', {
            editMode: true,
			planGUID: planGUID
        });
        laf.window.open();
        
        setTimeout(function(){
            win.close();
        }, 600);
    }
    
    //=== EVENTS =============================	
    btnSave.addEventListener('click', saveName);
    
    btnCancel.addEventListener('click', function(e){
        win.close();
    });
    
    //=== DISPLAY =============================
    setLeftNav(btnCancel);
    setRightNav(btnSave);
    setNewRoutineRows();
    vwMain.add(tvRoutineName);
    
    setTimeout(function(){
        tfRoutineName.focus();
    }, 400);
})();
