//=== HEADER & DATA =============================
Ti.include('../../common/winHeader.js');

var currentValue = laf.data.workoutScalar('SELECT Weight FROM WeightHistory WHERE Inactive = 0 ORDER BY StatsDate DESC LIMIT 1');
if (currentValue != undefined && !laf.verify.isEmpty(currentValue)) {
    var weight = parseFloat(currentValue) / 2.2;
}

//=== OBJECTS ===================================    
var tvRoutineExercise = Ti.UI.createTableView({
    backgroundColor: 'white',
    rowBackgroundColor: 'transparent',
    separatorColor: '#e1e1e1',
    bottom: '45'
});

var vwFooter = Ti.UI.createView({
    bottom: 0,
    height: 45,
    backgroundColor: '#576996'
});

//=== FUNCTIONS =================================
function getCaloriesBurned(weight, metValue){
    return (metValue == undefined || weight == undefined || metValue <= 1 || weight == 0) ? 0 : parseInt(weight * metValue, 10);
}

function newInfoRow(rowType, text, calories, exerciseID){
    var tvrRow = Ti.UI.createTableViewRow({
        rowType: rowType,
        className: 'workoutRoutineExercise',
        index: exerciseID
    });
    
    tvrRow.add(Ti.UI.createLabel({
        color: (laf.device.isiPhone()) ? '#576996' : 'black',
        font: {
            fontSize: 14,
            fontWeight: 'bold',
            fontFamily: 'Arial'
        },
        left: 5,
        top: 5,
        height: 20,
        textAlign: 'left',
        text: text
    }));
    
    tvrRow.add(Ti.UI.createLabel({
        color: '#7F7F7F',
        font: {
            fontSize: 14,
            fontFamily: 'Arial'
        },
        left: 5,
        right: laf.table.leftDataRightMargin,
        top: 25,
        height: 20,
        textAlign: 'left',
        text: (calories != undefined) ? calories + ' Cal/Hr' : ''
    }));
    laf.table.makeRowSelectable(tvrRow);
    
    tvrRow.add(Ti.UI.createButton({
        color: 'black',
        font: {
            fontFamily: 'Arial',
            fontWeight: 'bold'
        },
        right: 5,
        height: 28,
        width: 60,
        title: '+ Add',
        zIndex: 10,
        name: 'add',
        backgroundImage: laf.path.images + 'BUTT_gry_off.png',
        backgroundSelectedImage: laf.path.images + 'BUTT_gry_on.png'
    }));
    
    return tvrRow;
}

function setRoutineRows(sqlQuery, fieldValues, text){
    var data = [];
    data.push(laf.table.section(text));
    
    if (sqlQuery != undefined && sqlQuery != null) {
        var result = laf.data.exerciseSet(sqlQuery, fieldValues);
        if (result != undefined && result.length > 0) {
            for (var resultItr = 0, resultLen = result.length; resultItr < resultLen; resultItr++) {
                data.push(newInfoRow(result[resultItr].Name, result[resultItr].Name, getCaloriesBurned(weight, result[resultItr].MetValue), result[resultItr].ExerciseID));
            }
        }
    }
    tvRoutineExercise.setData(data);
}

function tabChange(tabIndex){
    switch (tabIndex) {
        case 0:
            setRoutineRows('SELECT Name, MetValue, ExerciseID FROM Exercise WHERE ExerciseTypeID = 4 AND Inactive = 0', ['Name', 'MetValue', 'ExerciseID'], 'Select Cardio Machine');            
            break;
        case 1:
            setRoutineRows('SELECT Name, MetValue, ExerciseID FROM Exercise WHERE ExerciseTypeID = 3 AND Inactive = 0', ['Name', 'MetValue', 'ExerciseID'], 'Select Cardio Activities');
            break;
        case 2:
            setRoutineRows('SELECT Name, MetValue, ExerciseID FROM Exercise WHERE ExerciseTypeID = 6 AND Inactive = 0', ['Name', 'MetValue', 'ExerciseID'], 'Select Cardio Classes');
            break;
    }
}

//=== EVENT =====================================
tvRoutineExercise.addEventListener('click', function(e){
    if (e.source.name != null && e.source.name != undefined && e.source.name == 'add') {
        laf.window.fire('AddExercise', {
            exerciseName: e.rowData.rowType,
            exerciseID: e.rowData.index,
            exerciseType: 'cardio'
        });
        
        setTimeout(function(){
            win.close();
        }, 400);
    }
    else {
        if (e.rowData.rowType != undefined) {
            laf.window.create('Routine', '/views/track/workoutRoutineExSetting.js', {
                exerciseName: e.rowData.rowType,
                exerciseID: e.rowData.index
            });
            laf.window.open();
        }
    }
});

laf.window.listen('AddExerciseFromSetting', function(e){
    laf.window.fire('AddExercise', {
        exerciseName: e.exerciseName,
        exerciseID: e.exerciseID
    });
    
    setTimeout(function(){
        win.close();
    }, 1000);
});

//=== DISPLAY ===================================
laf.window.footerTabs(['Machine', 'Activities', 'Classes'], tabChange, 0);

vwMain.add(tvRoutineExercise);
vwMain.add(vwFooter);
