(function(){
    //=== HEADER & DATA =============================
    Ti.include('../../common/winHeader.js');
    
    var currRoutineStep = (winData.currRoutineStep != undefined) ? winData.currRoutineStep : undefined;
    var currExercise = (winData.currExercise != undefined) ? winData.currExercise : undefined;
    
    //=== OBJECTS ===================================
    var tfEntryOne, tfEntryTwo;
    
    var tvExerciseGuidance = Ti.UI.createTableView({
        backgroundColor: 'white',
        rowBackgroundColor: 'transparent',
        separatorColor: 'white'
    });
    
    var btnCancel = Ti.UI.createButton({
        title: 'Cancel'
    });
    
    var btnSave = Ti.UI.createButton({
        title: 'Save',
        style: Ti.UI.iPhone.SystemButtonStyle.DONE
    });
    
    function newTextField(isFinalField){
        var tfEntry = Ti.UI.createTextField({
            color: '#336699',
            height: 40,
            top: 75,
            width: 100,
            autocorrect: true,
            borderStyle: Ti.UI.INPUT_BORDERSTYLE_ROUNDED,
            keyboardType: Ti.UI.KEYBOARD_DEFAULT,
            autocapitalization: Ti.UI.TEXT_AUTOCAPITALIZATION_SENTENCES,
            returnKeyType: (isFinalField) ? Ti.UI.RETURNKEY_DONE : Ti.UI.RETURNKEY_NEXT,
            clearButtonMode: Ti.UI.INPUT_BUTTONMODE_ONFOCUS
        });
        
        if (isFinalField) {
            tfEntry.right = 10;
        }
        else {
            tfEntry.left = 10;
        }
        
        return tfEntry;
    }
    
    //=== FUNCTIONS =============================    
    function setNewRoutineRows(){
        var data = [];
        
        data.push(laf.table.section(currExercise.Name));
        
        var tvrGuidance = Ti.UI.createTableViewRow({
            height: 320,
            className: 'workoutRoutineAdd'
        });
        laf.table.ignoreRowSelection(tvrGuidance);
        
        tvrGuidance.add(Ti.UI.createLabel({
            color: 'black',
            font: {
                fontSize: 18,
                fontFamily: 'Arial'
            },
            top: 10,
            left: 10,
            right: 10,
            height: 50,
            text: 'What is your goal for this exercise?',
            textAlign: 'center'
        }));
        
        tfEntryOne = newTextField(false);
        tfEntryOne.hintText = (currExercise.LogTypeID == 1) ? 'Sets' : (currExercise.LogTypeID == 2) ? 'Minutes' : 'Number of';
        tfEntryOne.value = (currExercise.LogTypeID == 1 && currRoutineStep.Sets != null) ? currRoutineStep.Sets : (currExercise.LogTypeID == 2 && currRoutineStep.Duration != null) ? currRoutineStep.Duration : (currExercise.LogTypeID == 3 && currRoutineStep.Reps != null) ? currRoutineStep.Reps : '';
        
        tvrGuidance.add(tfEntryOne);
        
        if (currExercise.LogTypeID != 3) {
            tfEntryTwo = newTextField(true);
            tfEntryTwo.hintText = (currExercise.LogTypeID == 1) ? 'Reps' : 'Miles';
            tfEntryTwo.value = (currExercise.LogTypeID == 1 && currRoutineStep.Reps != null) ? currRoutineStep.Reps : (currExercise.LogTypeID == 2 && currRoutineStep.Distance != null) ? currRoutineStep.Distance : '';
            tfEntryTwo.addEventListener('return', saveGuidance);
            tvrGuidance.add(tfEntryTwo);
        }
        
        tvrGuidance.add(Ti.UI.createLabel({
            color: 'gray',
            font: {
                fontSize: 18,
                fontWeight: 'light',
                fontFamily: 'Arial'
            },
            top: 75,
            left: 10,
            right: 10,
            height: 40,
            textAlign: 'center',
            text: (currExercise.LogTypeID == 1) ? 'sets of ' : (currExercise.LogTypeID == 2) ? 'OR' : 'Reps'
        }));
        
        data.push(tvrGuidance);
        
        tvExerciseGuidance.setData(data);
        laf.table.scrollToTop(tvExerciseGuidance, false);
    }
    
    function saveGuidance(){
    
        if (currExercise.LogTypeID == 1) {
            if (tfEntryOne.value == undefined || tfEntryOne.value.length == 0) {
                laf.window.alert('Required', 'Please enter a numeric value for the sets');
				tfEntryOne.focus();
				return;
            }
            else {
                if (tfEntryTwo.value == undefined || tfEntryTwo.value.length == 0) {
                    laf.window.alert('Required', 'Please enter a numeric value for the reps');
					tfEntryTwo.focus();
					return;
                }
            }			
        }
        
        laf.window.fire('NewExerciseGuidance', {
            GUID: currRoutineStep.GUID,
            EntryOne: tfEntryOne.value,
            EntryTwo: (currExercise.LogTypeID != 3) ? tfEntryTwo.value : undefined,
            LogTypeID: currExercise.LogTypeID
        });
        
        setTimeout(function(){
            win.close();
        }, 600);
    }
    
    //=== EVENTS =============================	
    btnSave.addEventListener('click', saveGuidance);
    
    btnCancel.addEventListener('click', function(e){
        win.close();
    });
    
    //=== DISPLAY =============================
    setLeftNav(btnCancel);
    setRightNav(btnSave);
    setNewRoutineRows();
    vwMain.add(tvExerciseGuidance);
    
    setTimeout(function(){
        tfEntryOne.focus();
    }, 400);
})();
