//=== HEADER & DATA =============================
Ti.include('../../common/winHeader.js');

var exerName = (winData.exerciseName != undefined) ? winData.exerciseName : undefined;
var exerID = (winData.exerciseID != undefined) ? winData.exerciseID : undefined;
var exerLogTypeID = laf.data.exerciseScalar('SELECT LogTypeID FROM Exercise WHERE ExerciseID = "' + exerID + '" ', ['LogTypeID']);

//=== OBJECTS ===================================    
var tvRoutineExerciseSetting = Ti.UI.createTableView({
    bottom: '45',
    top: '30',
    backgroundColor: 'transparent',
    rowBackgroundColor: 'transparent',
    separatorColor: 'transparent'
});

var vwHeader = Ti.UI.createView({
    top: 0,
    height: 30,
    backgroundColor: '#576996'
});

vwHeader.add(Ti.UI.createLabel({
    color: 'white',
    font: {
        fontSize: 18,
        fontWeight: 'bold'
    },
    left: 10,
    minimumFontSize: 10,
    text: (exerName != undefined) ? exerName : ''
}));

var vwFooter = Ti.UI.createView({
    bottom: 0,
    height: 45,
    backgroundColor: '#576996'
});

var btnAdd = Ti.UI.createButton({
    title: 'Add to routine'
});

//=== FUNCTIONS =================================
function createLabel(text, left, top, color){
    return Ti.UI.createLabel({
        color: color,
        font: {
            fontSize: 14,
            fontFamily: 'Arial'
        },
        top: top,
        left: left,
        width: 75,
        height: 15,
        text: text
    });
}

function getOneRepMax(reps, weight){
    //formula to calculate 1RM: [(reps / 30) + 1] * weight
    return parseInt(((reps / 30) + 1) * weight, 10);
}

function leftValues(containerWidth, numButtons, buttonWidth, buttonSpacer){
    var padding = containerWidth -
    ((numButtons * buttonWidth) + (buttonSpacer * (numButtons - 1)));
    var lefts = [];
    for (var i = 0; i < numButtons; i++) {
        var thisLeft = padding / 2 +
        (buttonWidth * (i)) +
        (buttonSpacer * (i));
        lefts[i] = thisLeft;
    }
    return lefts;
}

function newInfoRow(labelField, valueField, date){
    date = date.toString().substring(0, date.toString().indexOf('T'));
    
    var tvrRows = Ti.UI.createTableViewRow({
        height: 50,
        className: 'workoutRoutineRecordHistory'
    });
    
    var lefts = leftValues(250, labelField.length, 75, 10);
    for (var labelFieldItr = 0, labelFieldLen = labelField.length; labelFieldItr < labelFieldLen; labelFieldItr++) {
        tvrRows.add(createLabel(labelField[labelFieldItr], lefts[labelFieldItr], 5, '#7F7F7F'));
        tvrRows.add(createLabel(valueField[labelFieldItr], lefts[labelFieldItr], 25, 'black'));
    };
    
    tvrRows.add(Ti.UI.createLabel({
        color: '#576996',
        font: {
            fontSize: 14,
            fontFamily: 'Arial'
        },
        right: 5,
        width: 75,
        height: 15,
        text: date.replace(/\//g, '-')
    }));
    
    return tvrRows;
}

function setRows(text){
    var data = [];
    
    if (text != undefined && exerName != undefined) {
        data.push(laf.table.section(text));
        var result;
        
        if (text == 'Instruction') {
            result = laf.data.exerciseScalar('SELECT Instructions FROM Exercise WHERE ExerciseID = "' + exerID + '" AND Inactive = 0', ['Instructions']);
            if (result != undefined && result.length > 0) {
                data.push(laf.table.infoRow(result));
            }
        }
        
        else {
            var labelField = (exerLogTypeID == 1) ? ['Weight:', 'Reps:', '1RM:'] : (exerLogTypeID == 2) ? ['Duration:', 'Distance:', 'Calories:'] : ['Reps'];
            
            result = laf.data.workoutSet('SELECT LogDate, Calories, Distance, Duration, Reps, Weight FROM WorkoutHistory WHERE Inactive = "0" AND ExerciseID = "' + exerID + '" ORDER BY LogDate DESC', ['LogDate', 'Calories', 'Distance', 'Duration', 'Reps', 'Weight']);
            if (result != undefined && result.length > 0) {
                tvRoutineExerciseSetting.separatorColor = '#e1e1e1';
                var valueField = [];
                for (var resultItr = 0, resultLen = result.length; resultItr < resultLen; resultItr++) {
                    switch (exerLogTypeID) {
                        case 1:
                            valueField = [result[resultItr].Weight, result[resultItr].Reps, getOneRepMax(result[resultItr].Reps, result[resultItr].Weight)];
                            break;
                        case 2:
                            valueField = [result[resultItr].Duration, result[resultItr].Distance, result[resultItr].Calories];
                            break;
                        case 3:
                            valueField = [result[resultItr].Reps];
                            break;
                    }
                    
                    data.push(newInfoRow(labelField, valueField, result[resultItr].LogDate));
                }
            }
            else {
                data.push(laf.table.infoRow('No history avaliable for this exercise.'));
            }
        }
    }
    
    tvRoutineExerciseSetting.setData(data);
}

function tabChange(tabIndex){
    switch (tabIndex) {
        case 0:
            setRows('Instruction');
            tvRoutineExerciseSetting.separatorColor = 'transparent';
            break;
        case 1:
            setRows('History');
            break;
    }
}

//=== EVENT =====================================	
btnAdd.addEventListener('click', function(e){
    laf.window.fire('AddExerciseFromSetting', {
        exerciseName: (exerName != undefined) ? exerName : undefined,
        exerciseID: (exerID != undefined) ? exerID : undefined
    });
    
    setTimeout(function(){
        win.close();
    }, 400);
});


//=== DISPLAY ===================================
laf.window.footerTabs(['Instruction', 'History'], tabChange, 0);

vwMain.add(tvRoutineExerciseSetting);
vwMain.add(vwHeader);
vwMain.add(vwFooter);

if (winData.boolAdd != false) {
    setRightNav(btnAdd);
}

