//=== HEADER & DATA =============================
Ti.include('../../common/winHeader.js');

var currentValue = laf.data.workoutScalar('SELECT Weight FROM WeightHistory WHERE Inactive = 0 ORDER BY StatsDate DESC LIMIT 1');
if (currentValue != undefined && !laf.verify.isEmpty(currentValue)) {
    var weight = parseFloat(currentValue) / 2.2;
}

var exerciseType = 'Dumbbell';
var tableIndex;
var blnBodyScreen = false;

//=== OBJECTS ===================================    
var tvRoutineExercise = Ti.UI.createTableView({
    backgroundColor: 'white',
    rowBackgroundColor: 'transparent',
    separatorColor: '#e1e1e1'
});

var vwFooter = Ti.UI.createView({
    bottom: 0,
    height: 45,
    backgroundColor: '#576996',
    visible: false
});

//=== FUNCTIONS =================================	
function getCaloriesBurned(weight, metValue){
    return (metValue == undefined || weight == undefined || metValue <= 1 || weight == 0) ? 0 : parseInt(weight * metValue, 10);
}

function newInfoRow(rowType, text, calories, arrayIndex, blnImage, exerciseID){
    var tvrRow = Ti.UI.createTableViewRow({
        rowType: rowType,
        className: 'workoutRoutineExercise' + blnImage.toString(),
        index: arrayIndex,
        exerciseID: exerciseID
    });
    
    tvrRow.add(Ti.UI.createLabel({
        color: (laf.device.isiPhone()) ? '#576996' : 'black',
        font: {
            fontSize: 14,
            fontWeight: 'bold',
            fontFamily: 'Arial'
        },
        left: (blnImage) ? 40 : 5,
        top: (calories == undefined) ? 15 : 5,
        height: 20,
        textAlign: 'left',
        text: text
    }));
    laf.table.makeRowSelectable(tvrRow);
    
    if (!blnImage) {
        tvrRow.add(Ti.UI.createButton({
            title: '+ Add',
            height: 28,
            width: 60,
            right: 5,
            color: 'black',
            font: {
                fontFamily: 'Arial',
                fontWeight: 'bold'
            },
            zIndex: 10,
            name: 'add',
            backgroundImage: laf.path.images + 'BUTT_gry_off.png',
            backgroundSelectedImage: laf.path.images + 'BUTT_gry_on.png'
        }));
        
        if (calories != undefined && calories != null) {
            tvrRow.add(Ti.UI.createLabel({
                color: (laf.device.isiPhone()) ? '#7F7F7F' : 'gray',
                font: {
                    fontSize: 14,
                    fontFamily: 'Arial'
                },
                top: 25,
                left: 5,
                right: laf.table.leftDataRightMargin,
                height: 20,
                textAlign: 'left',
                text: (calories != undefined) ? calories + ' Cal/Hr' : ''
            }));
        }
    }
    
    if (blnImage) {
        tvrRow.add(Ti.UI.createView({
            backgroundImage: laf.path.images + text.toLowerCase() + '.png',
            left: 5,
            width: 30,
            height: 30
        }));
    }
    
    return tvrRow;
}

function setRoutineRows(sqlQuery, fieldValues, text, blnImage){
    var data = [];
    
    if (blnBodyScreen) {
        tvrHeader = Ti.UI.createTableViewRow({
            height: 40,
            className: 'vwHeader',
            rowType: 'vwHeader'
        });
        
        tvrHeader.add(Ti.UI.createLabel({
            color: 'black',
            font: {
                fontSize: 14,
                fontFamily: 'Arial'
            },
            left: 40,
            right: 5,
            height: 35,
            textAlign: 'left',
            text: 'Select different group'
        }));
        
        tvrHeader.add(Ti.UI.createView({
            backgroundImage: laf.path.images + 'arrowLeftd.png',
            left: 5,
            width: 30,
            height: 30
        }));
        
        data.push(tvrHeader);
    }
    
    if (sqlQuery != undefined && sqlQuery != null) {
        data.push(laf.table.section(text));
        
        var result = laf.data.exerciseSet(sqlQuery, fieldValues);
        if (result != undefined && result.length > 0) {
            for (var resultItr = 0, resultLen = result.length; resultItr < resultLen; resultItr++) {
                data.push(newInfoRow(result[resultItr].Name, result[resultItr].Name, (blnBodyScreen) ? getCaloriesBurned(weight, result[resultItr].MetValue) : undefined, result[resultItr].MuscleGroupID, blnImage, result[resultItr].ExerciseID));
            }
        }
    }
    
    tvRoutineExercise.setData(data);
}

function setBodyPartRows(){
    var result = laf.data.exerciseSet('SELECT MuscleID FROM Muscle WHERE Inactive = 0 AND MuscleGroupID = ' + tableIndex + ' ', ['MuscleID']);
    
    var sqlQuery = 'Select Name, MetValue, ExerciseID from Exercise WHERE (Inactive = 0) AND ( MuscleID = "' + result[0].MuscleID + '" ';
    for (var fieldValueItr = 1, fieldValueLen = result.length; fieldValueItr < fieldValueLen; fieldValueItr++) {
        sqlQuery += ' OR MuscleID = "' + result[fieldValueItr].MuscleID + '" ';
    }
    
    sqlQuery += (exerciseType == 'Dumbbell') ? ') AND ExerciseTypeID = "5"' : (exerciseType == 'Barbell') ? ') AND ExerciseTypeID = "0"' : ') AND ExerciseTypeID = "8"';
    sqlQuery += ' ORDER BY Name';
    
    result = laf.data.exerciseSet(sqlQuery, ['Name', 'MetValue', 'ExerciseID']);
    setRoutineRows(sqlQuery, ['Name', 'MetValue', 'ExerciseID'], 'Select Body Exercise', false);
}

function tabChange(btnBarIndex){
    switch (btnBarIndex) {
        case 0:
            exerciseType = 'Dumbbell';
            if (blnBodyScreen) {
                setBodyPartRows();
            }
            else {
                setRoutineRows('SELECT Name, MuscleGroupID FROM MuscleGroup WHERE Inactive = 0', ['Name', 'MuscleGroupID'], 'Select Body Part', true);
            }
            break;
        case 1:
            exerciseType = 'Barbell';
            if (blnBodyScreen) {
                setBodyPartRows();
            }
            else {
                setRoutineRows('SELECT Name, MuscleGroupID FROM MuscleGroup WHERE Inactive = 0', ['Name', 'MuscleGroupID'], 'Select Body Part', true);
            }
            break;
        case 2:
            exerciseType = 'Smith Machine';
            if (blnBodyScreen) {
                setBodyPartRows();
            }
            else {
                setRoutineRows('SELECT Name, MuscleGroupID FROM MuscleGroup WHERE Inactive = 0', ['Name', 'MuscleGroupID'], 'Select Body Part', true);
            }
            break;
    }
}

//=== EVENT =====================================
tvRoutineExercise.addEventListener('click', function(e){
    if (e.source.name != null && e.source.name != undefined && e.source.name == 'add') {
        laf.window.fire('AddExercise', {
            exerciseName: e.rowData.rowType,
            exerciseID: e.rowData.exerciseID,
            exerciseType: 'weightLift'
        });
        
        setTimeout(function(){
            win.close();
        }, 400);
    }
    else {
        if (blnBodyScreen) {
            if (e.rowData.rowType != undefined) {
                if (e.rowData.rowType == 'vwHeader') {
                    blnBodyScreen = false;
                    setRoutineRows('SELECT Name, MuscleGroupID FROM MuscleGroup WHERE Inactive = 0', ['Name', 'MuscleGroupID'], (exerciseType == 'Machine') ? 'Select Body Part - Fixed machine' : 'Select Body Part - Free Motion', true);
                    
                    vwFooter.visible = false;
                    tvRoutineExercise.bottom = '0';
                }
                else {
                    laf.window.create('Body Exercise', '/views/track/workoutRoutineExSetting.js', {
                        exerciseName: e.rowData.rowType,
                        exerciseID: e.rowData.exerciseID
                    });
                    laf.window.open();
                }
            }
        }
        else {
            if (e.rowData.rowType != undefined && e.rowData.index != undefined) {
                blnBodyScreen = true;
                tableIndex = e.rowData.index;
                setBodyPartRows();
                
                vwFooter.visible = true;
                tvRoutineExercise.bottom = '45';
            }
        }
    }
});

laf.window.listen('AddExerciseFromSetting', function(e){
    laf.window.fire('AddExercise', {
        exerciseName: e.exerciseName,
        exerciseID: e.exerciseID,
        exerciseType: 'weightLift'
    });
    
    setTimeout(function(){
        win.close();
    }, 1000);
});

//=== DISPLAY ===================================
laf.window.footerTabs(['Dumbbell', 'Barbell', 'Smith Machine'], tabChange, 0);
vwMain.add(tvRoutineExercise);
vwMain.add(vwFooter);

setRoutineRows('SELECT Name, MuscleGroupID FROM MuscleGroup WHERE Inactive = 0', ['Name', 'MuscleGroupID'], 'Select an area to focus on', true);
