(function(){
    //=== HEADER & DATA =============================
    Ti.include('../../common/winHeader.js');
    
    var currRoutine = (winData.currRoutine != undefined) ? winData.currRoutine : undefined;
    var currIndex = (winData.currIndex != undefined) ? winData.currIndex : undefined;
    var currExercise = laf.data.exerciseRow('SELECT ExerciseID, Name, LogTypeID FROM Exercise WHERE ExerciseID = "' + currRoutine[currIndex].ExerciseID + '"', ['ExerciseID', 'Name', 'LogTypeID']);
    var history = laf.data.workoutSet('SELECT LogDate, GUID, Calories, Distance, Duration, Reps, Weight FROM WorkoutHistory WHERE Inactive = "0" AND ExerciseID = "' + currExercise.ExerciseID + '" ORDER BY LogDate DESC LIMIT 10', ['LogDate', 'GUID', 'Calories', 'Distance', 'Duration', 'Reps', 'Weight']);
    
    var labelField = [];
    var valueField = [];
    
    var currLogTypeID = currExercise.LogTypeID;
    var tfEntryOne, tfEntryTwo, tfEntryThree;
    var buttonSpace = (Ti.Gesture.orientation != 1) ? 60 : 10;
    
    //=== OBJECTS ===================================     
    var tvRecord = Ti.UI.createTableView({
        backgroundColor: 'white',
        rowBackgroundColor: 'transparent',
        separatorColor: '#e1e1e1',
        top: 48,
        bottom: 30
    });
    
    //arrowLeftD for disable.  arrowLeft for enable
    var buttonObjects = [{
        image: laf.path.images + ((currIndex == 0) ? 'arrowLeftd.png' : 'arrowLeft.png'),
        width: 50
    }, {
        width: 50
    }];
    
    if (currIndex == currRoutine.length - 1) {
        buttonObjects[1].title = 'Done';
    }
    else {
        buttonObjects[1].image = laf.path.images + 'arrowRight.png';
    }
    
    var btnBar = Ti.UI.createButtonBar({
        labels: buttonObjects,
        width: 100,
        backgroundColor: '#336699'
    });
    setRightNav(btnBar);
    
    function createButton(image){
        return Ti.UI.createButton({
            backgroundImage: laf.path.images + image + '.png',
            width: 30,
            height: 25
        });
    }
    
    //Information icon, music icon, title, complete msg
    var vwHeader = Ti.UI.createView({
        top: 0,
        height: 48,
        backgroundColor: '#576996'
    });
    
    var btnInformation = createButton('info');
    btnInformation.left = 5;
    
    var btnMusic = createButton('music');
    btnMusic.right = 5;
    
    var lblTitle = Ti.UI.createLabel({
        color: 'white',
        font: {
            fontSize: 18,
            fontWeight: 'bold',
            fontFamily: 'Arial'
        },
        top: 5,
        height: 20,
        width: 250,
        minimumFontSize: 10,
        textAlign: 'center'
    });
    
    var lblSets = Ti.UI.createLabel({
        color: 'white',
        font: {
            fontSize: 12,
            fontFamily: 'Arial'
        },
        bottom: 5,
        height: 20,
        width: 250,
        minimumFontSize: 10,
        textAlign: 'center'
    });
    
    vwHeader.add(lblTitle);
    vwHeader.add(lblSets);
    vwHeader.add(btnInformation);
    vwHeader.add(btnMusic);
    
    //create check button for information routine row
    var btnCheck = createButton('check');
    btnCheck.right = 5;
    
    //Footer with 60, 120, 180 buttons
    var vwFooter = Ti.UI.createView({
        bottom: 0,
        height: 30,
        backgroundColor: '#576996',
        borderColor: 'black'
    });
    
    var btnSetting = createButton('edit');
    btnSetting.right = 5;
    
    //=== FUNCTIONS =================================
    function changeExercise(direction){
        currIndex = currIndex + direction;
        
        switch (currIndex) {
            case 0: // went from 1 to 0
                buttonObjects[0].image = laf.path.images + 'arrowLeftd.png';
                btnBar.labels = buttonObjects;
                break;
            case 1: // went from 0 to 1
                if (direction == 1) {
                    buttonObjects[0].image = laf.path.images + 'arrowLeft.png';
                    btnBar.labels = buttonObjects;
                }
                break;
            case currRoutine.length - 2: // went back from last item.  ie (from 6 to 5)
                if (direction == -1) {
                    buttonObjects[1].image = laf.path.images + 'arrowRight.png';
                    buttonObjects[1].title = '';
                    btnBar.labels = buttonObjects;
                }
                break;
            case currRoutine.length - 1: // went from second to last item to last time.  ie (from 5 to 6)
                if (direction == 1) {
                    buttonObjects[1].image = '';
                    buttonObjects[1].title = 'Done';
                    btnBar.labels = buttonObjects;
                }
                break;
        }
        
        //reassign variable based on next exercise
        currExercise = laf.data.exerciseRow('SELECT ExerciseID, Name, LogTypeID FROM Exercise WHERE ExerciseID = "' + currRoutine[currIndex].ExerciseID + '"', ['ExerciseID', 'Name', 'LogTypeID']);
        history = laf.data.workoutSet('SELECT LogDate, GUID, Calories, Distance, Duration, Reps, Weight FROM WorkoutHistory WHERE Inactive = "0" AND ExerciseID = "' + currExercise.ExerciseID + '" ORDER BY LogDate DESC LIMIT 10', ['LogDate', 'GUID', 'Calories', 'Distance', 'Duration', 'Reps', 'Weight']);
        
        getExerciseGuidance(currRoutine[currIndex], currLogTypeID);
        setRecordRows();
    }
    
    function createFooter(){
        var tabs = [];
        var tabWidth = (laf.window.percentToPixels(100 / 3)) - 10;
        tabNames = ['60', '120', '180'];
        
        for (var tabItr = 0; tabItr < 3; tabItr++) {
            var currTab = Ti.UI.createLabel({
                color: 'white',
                textAlign: 'center',
                text: tabNames[tabItr],
                left: (tabWidth * tabItr),
                width: tabWidth - 20,
                focusable: true,
                tabIndex: tabItr,
                borderColor: '#000F4B',
                borderWidth: 1
            });
            
            currTab.addEventListener('click', function(e){
                return function(e){
                    if (e.source.text != tabNames[e.source.tabIndex]) {
                        e.source.text = 0;
                        return;
                    }
                    
                    var timer = setInterval(function(){
                        if (e.source.text == 0) {
                            e.source.text = tabNames[e.source.tabIndex];
                            clearInterval(timer);
                        }
                        else {
                            e.source.text = parseInt(e.source.text, 10) - 1;
                        }
                    }, 1000);
                };
            }());
            
            tabs.push(currTab);
            vwFooter.add(currTab);
        }
        
        vwFooter.add(btnSetting);
    }
    
    function createLabel(text, left, top, color){
        return Ti.UI.createLabel({
            color: color,
            font: {
                fontSize: 14,
                fontFamily: 'Arial'
            },
            top: top,
            left: left,
            width: 75,
            height: 15,
            text: text
        });
    }
    
    function createTextField(left){
        var tfEntry = Ti.UI.createTextField({
            bottom: 5,
            left: left,
            width: 60,
            height: 30,
            borderStyle: Titanium.UI.INPUT_BORDERSTYLE_ROUNDED,
            keyboardType: Titanium.UI.KEYBOARD_NUMBERS_PUNCTUATION,
            autocapitalization: Titanium.UI.TEXT_AUTOCAPITALIZATION_NONE,
            returnKeyType: Titanium.UI.RETURNKEY_DONE
        });
        
        tfEntry.addEventListener('focus', function(){
            tvRecord.footerTitle = '\n\n\n';
            tfEntry.value = '';
        });
        
        return tfEntry;
    }
    
    function getExerciseGuidance(currRoutineStep, logTypeID){
        var strDirections = '';
        
        switch (logTypeID + '') {
            case '1': //Sets/Reps
                if (currRoutineStep.Sets != undefined && currRoutineStep.Sets > 0 && currRoutineStep.Reps != undefined && currRoutineStep.Reps > 0) {
                    if (currRoutineStep.SetsMax != undefined && currRoutineStep.SetsMax > 0 && currRoutineStep.SetsMax != currRoutineStep.Sets) {
                        strDirections += currRoutineStep.Sets + '-' + currRoutineStep.SetsMax + ' sets of ';
                    }
                    else {
                        strDirections += currRoutineStep.Sets + ' sets of ';
                    }
                    
                    if (currRoutineStep.RepsMax != undefined && currRoutineStep.RepsMax > 0 && currRoutineStep.RepsMax != currRoutineStep.Reps) {
                        strDirections += currRoutineStep.Reps + '-' + currRoutineStep.RepsMax + ' reps';
                    }
                    else {
                        strDirections += currRoutineStep.Reps + ' reps';
                    }
                }
                break;
            case '2': //Duration
                if (currRoutineStep.Duration != undefined && currRoutineStep.Duration > 0 || currRoutineStep.Distance != undefined && currRoutineStep.Distance > 0) {
                    if (currRoutineStep.DurationMax != undefined && currRoutineStep.DurationMax > 0 && currRoutineStep.DurationMax != currRoutineStep.Duration) {
                        strDirections += currRoutineStep.Duration + '-' + currRoutineStep.DurationMax + ' min';
                        
                        if (currRoutineStep.Distance != undefined && currRoutineStep.Distance > 0) {
                            strDirections += ' or ' + currRoutineStep.Distance + ' Mi ';
                        }
                    }
                    else {
                    
                        if (currRoutineStep.Duration > 0 && currRoutineStep.Distance > 0) {
                            strDirections += currRoutineStep.Duration + ' min or ' + currRoutineStep.Distance + ' Mi';
                        }
                        else {
                            if (currRoutineStep.Duration == undefined || currRoutineStep.Duration == 0) {
                                strDirections += currRoutineStep.Distance + ' Mi';
                            }
                            else {
                                strDirections += currRoutineStep.Duration + ' min';
                            }
                        }
                    }
                }
                break;
            case '3': //Reps
                if (currRoutineStep.Reps != undefined && currRoutineStep.Reps > 0) {
                    if (currRoutineStep.RepsMax != undefined && currRoutineStep.RepsMax > 0 && currRoutineStep.RepsMax != currRoutineStep.Reps) {
                        strDirections += currRoutineStep.Reps + '-' + currRoutineStep.RepsMax + ' reps';
                    }
                    else {
                        strDirections += currRoutineStep.Reps + ' reps';
                    }
                }
                break;
        }
        
        //set the header label values
        lblSets.text = (currIndex + 1) + ' of ' + currRoutine.length;
        if (strDirections != undefined && strDirections != null && strDirections.length > 0) {
            lblSets.text += ' - Complete ' + strDirections;
        }
        
        lblTitle.text = currExercise.Name;
    }
    
    function getOneRepMax(reps, weight){
        //formula to calculate 1RM: [(reps / 30) + 1] * weight
        return parseInt(((reps / 30) + 1) * weight, 10);
    }
    
    function leftValues(containerWidth, numButtons, buttonWidth, buttonSpacer){
        var padding = containerWidth -
        ((numButtons * buttonWidth) + (buttonSpacer * (numButtons - 1)));
        var lefts = [];
        for (var i = 0; i < numButtons; i++) {
            var thisLeft = padding / 2 +
            (buttonWidth * (i)) +
            (buttonSpacer * (i));
            lefts[i] = thisLeft;
        }
        return lefts;
    }
    
    function newInfoRow(valueField, date, GUID){
        date = laf.dateTime.fromString(date);
        date = laf.dateTime.toDateString(date);
        
        var tvrRows = Ti.UI.createTableViewRow({
            height: 50,
            rowType: 'workoutRoutineRecordHistory',
            className: 'workoutRoutineRecordHistory',
            GUID: GUID
        });
        
        var lefts = leftValues(laf.window.percentToPixels(80), labelField.length, 75, buttonSpace);
        for (var labelFieldItr = 0, labelFieldLen = labelField.length; labelFieldItr < labelFieldLen; labelFieldItr++) {
            tvrRows.add(createLabel(labelField[labelFieldItr], lefts[labelFieldItr], 5, '#7F7F7F'));
        };
        
        lefts = leftValues(laf.window.percentToPixels(80), valueField.length, 75, buttonSpace);
        for (var valueFieldItr = 0, valueFieldLen = valueField.length; valueFieldItr < valueFieldLen; valueFieldItr++) {
            tvrRows.add(createLabel(valueField[valueFieldItr], lefts[valueFieldItr], 25, 'black'));
        };
        
        tvrRows.add(Ti.UI.createLabel({
            color: '#576996',
            font: {
                fontSize: 14,
                fontFamily: 'Arial'
            },
            right: 5,
            width: 75,
            height: 15,
            text: date.replace(/\//g, '-')
        }));
        
        return tvrRows;
    }
    
    
    function setRecordRows(){
        labelField = (currLogTypeID == 1) ? ['Weight:', 'Reps:'] : (currLogTypeID == 2) ? ['Duration:', 'Distance:', 'Calories:'] : ['Reps'];
        valueField = [];
        var data = [];
        
        //Design text field, labels and check button
        var tvrRows = Ti.UI.createTableViewRow({
            height: 65,
            rowType: 'workoutRoutineRecord',
            className: 'workoutRoutineRecord'
        });
        laf.table.ignoreRowSelection(tvrRows);
        
        var lefts = leftValues(laf.window.percentToPixels(90), labelField.length, 75, buttonSpace + 10);
        for (var labelFieldItr = 0, labelFieldLen = labelField.length; labelFieldItr < labelFieldLen; labelFieldItr++) {
            tvrRows.add(createLabel(labelField[labelFieldItr], lefts[labelFieldItr], 5, 'black'));
        };
        
        tvrRows.add(tfEntryOne = createTextField(lefts[0]));
        if (currLogTypeID == 1 || currLogTypeID == 2) {
            tvrRows.add(tfEntryTwo = createTextField(lefts[1]));
        }
        if (currLogTypeID == 1) {
            labelField.push('1RM:');
        }
        if (currLogTypeID == 2) {
            tvrRows.add(tfEntryThree = createTextField(lefts[2]));
        }
        
        //add check button.  Declare under object header
        tvrRows.add(btnCheck);
        data.push(tvrRows);
        
        //Design previous 10 entries of exercise
        data.push(laf.table.section('Previous 10 Times'));
        
        if (history != undefined && history != null) {
            for (var historyItr = 0, historyLen = history.length; historyItr < historyLen; historyItr++) {
                switch (currLogTypeID) {
                    case 1:
                        valueField = [history[historyItr].Weight, history[historyItr].Reps, getOneRepMax(history[historyItr].Reps, history[historyItr].Weight)];
                        break;
                    case 2:
                        valueField = [history[historyItr].Duration, history[historyItr].Distance, history[historyItr].Calories];
                        break;
                    case 3:
                        valueField = [history[historyItr].Reps];
                        break;
                }
                
                data.push(newInfoRow(valueField, history[historyItr].LogDate, history[historyItr].GUID));
            }
        }
        
        tvRecord.setData(data);
    }
    
    //=== EVENT =====================================
    btnBar.addEventListener('click', function(e){
        if (e.index == 0) {
            if (currIndex > 0) {
                changeExercise(-1);
            }
        }
        else {
            if (currIndex < currRoutine.length - 1) {
                changeExercise(1);
            }
            else {
                win.close();
            }
        }
    });
    
    btnCheck.addEventListener('click', function(){
        tfEntryOne.value = laf.verify.trim(tfEntryOne.value);
        if (!laf.verify.isEmpty(tfEntryOne.value) && !laf.verify.isNumeric(tfEntryOne.value)) {
            laf.window.alert('Invalid', 'Please enter a numerical value for ' + labelField[0]);
            tfEntryOne.focus();
            return;
        }
        tfEntryOne.blur();
        
        if (currLogTypeID == 1 || currLogTypeID == 2) {
            tfEntryTwo.value = laf.verify.trim(tfEntryTwo.value);
            if (!laf.verify.isEmpty(tfEntryTwo.value) && !laf.verify.isNumeric(tfEntryTwo.value)) {
                laf.window.alert('Invalid', 'Please enter a numerical value for ' + labelField[1]);
                tfEntryTwo.focus();
                return;
            }
            tfEntryTwo.blur();
        }
        
        if (currLogTypeID == 2) {
            tfEntryThree.value = laf.verify.trim(tfEntryThree.value);
            if (!laf.verify.isEmpty(tfEntryThree.value) && !laf.verify.isNumeric(tfEntryThree.value)) {
                laf.window.alert('Invalid', 'Please enter a numerical value for ' + labelField[2]);
                tfEntryThree.focus();
                return;
            }
            tfEntryThree.blur();
        }
        
        var GUID = laf.object.newGUID();
        var date = laf.dateTime.toString(new Date(), 'unspecified');
        var entries = [];
        switch (currLogTypeID) {
            case 1: // weight and reps
                if (laf.verify.isEmpty(tfEntryOne.value) && laf.verify.isEmpty(tfEntryTwo.value)) {
                    return;
                }
                
                laf.data.workoutMakeSync('WorkoutHistory', GUID, false, ['LogDate', 'ExerciseID', 'Weight', 'Reps'], [date, currExercise.ExerciseID, tfEntryOne.value, tfEntryTwo.value]);
                entries = [tfEntryOne.value, tfEntryTwo.value, getOneRepMax(tfEntryTwo.value, tfEntryOne.value)];
                break;
            case 2: // duration, distance and calories
                if (laf.verify.isEmpty(tfEntryOne.value) && laf.verify.isEmpty(tfEntryTwo.value) && laf.verify.isEmpty(tfEntryThree.value)) {
                    return;
                }
                
                laf.data.workoutMakeSync('WorkoutHistory', GUID, false, ['LogDate', 'ExerciseID', 'Duration', 'Distance', 'Calories'], [date, currExercise.ExerciseID, tfEntryOne.value, tfEntryTwo.value, tfEntryThree.value]);
                entries = [tfEntryOne.value, tfEntryTwo.value, tfEntryThree.value];
                break;
            case 3: // reps
                if (laf.verify.isEmpty(tfEntryOne.value)) {
                    return;
                }
                
                laf.data.workoutMakeSync('WorkoutHistory', GUID, false, ['LogDate', 'ExerciseID', 'Reps'], [date, currExercise.ExerciseID, tfEntryOne.value]);
                entries = [tfEntryOne.value];
                break;
        }
        
        if (history.length == 0 || history.length == 1) {
            history.push(newInfoRow(entries, date, GUID));
            tvRecord.appendRow(newInfoRow(entries, date, GUID));
        }
        else {
            history.splice(1, 0, newInfoRow(entries, date, GUID));
            tvRecord.insertRowBefore(1, newInfoRow(entries, date, GUID));
        }
        
        tvRecord.footerTitle = '';
    });
    
    btnInformation.addEventListener('click', function(){
        laf.window.create('Routine', '/views/track/workoutRoutineExSetting.js', {
            exerciseName: currExercise.Name,
            exerciseID: currExercise.ExerciseID,
            boolAdd: false
        });
        laf.window.open();
    });
    
    tvRecord.addEventListener('click', function(e){
    
        if (e.rowData.rowType == 'workoutRoutineRecordHistory') {
            var dlgRecordOptions = Ti.UI.createOptionDialog({
                options: ['Delete', 'Edit', 'Share', 'Cancel'],
                destructive: 0,
                cancel: 3
            });
            
            dlgRecordOptions.addEventListener('click', function(data){
                switch (data.index) {
                    case 0:
                        laf.window.alert('Delete Record', 'Are you sure you want to delete?', ['Delete', 'Cancel'], function(msg){
                            if (msg.index == 0) {
                                laf.data.workoutMakeSync('WorkoutHistory', e.rowData.GUID, true);
                                
                                if (e.index == 0) {
                                    history.splice(0, 1);
                                    tvRecord.deleteRow(0);
                                }
                                else {
                                    history.splice(e.index, 1);
                                    tvRecord.deleteRow(e.index);
                                }
                            }
                        });
                        break;
                    case 1:
                        laf.window.include('workoutRoutineRecordEdit.js');
                        var winToOpen = new edit(currExercise, e.rowData.GUID);
                        break;
                    case 2:
                        
                        break;
                }
            });
            
            dlgRecordOptions.show();
        }
    });
    
    Ti.Gesture.addEventListener('shake', function(e){
        if (currIndex < currRoutine.length - 1) {
            changeExercise(1);
        }
        else {
            win.close();
        }
    });
    
    Ti.Gesture.addEventListener('orientationchange', function(e){
        buttonSpace = (e.orientation != 1) ? 60 : 10;
        setRecordRows();
        
        //remove all labels/button
        for (var x = vwFooter.children.length - 1; x >= 0; x--) {
            vwFooter.remove(vwFooter.children[x]);
        }
        createFooter();
    });
    
    //=== DISPLAY ===================================
    vwMain.add(vwHeader);
    vwMain.add(tvRecord);
    vwMain.add(vwFooter);
    
    getExerciseGuidance(currRoutine[currIndex], currLogTypeID);
    setRecordRows();
    createFooter();
})();
