function edit(currExercise, currGUID){

    //=== HEADER & DATA =============================
    Ti.include('../../common/winHeader.js');
    Ti.include('../../common/utilPicker.js');
    
    // var currExercise = (this.currExercise != undefined) ? this.currExercise : undefined;
    // var currGUID = (this.currGUID != undefined) ? this.currGUID : undefined;
    
    var currLogTypeID = currExercise.LogTypeID;
    var currHistory = laf.data.workoutRow('SELECT LogDate, GUID, Calories, Distance, Duration, Reps, Weight FROM WorkoutHistory WHERE Inactive = "0" AND ExerciseID = "' + currExercise.ExerciseID + '" AND GUID = "' + currGUID + '" ORDER BY LogDate DESC', ['LogDate', 'GUID', 'Calories', 'Distance', 'Duration', 'Reps', 'Weight']);
    
    var defaultDate = laf.dateTime.fromString(currHistory.LogDate);
    defaultDate = laf.dateTime.toDateString(defaultDate);
    defaultDate = new Date(defaultDate);
    
    var tfEntryOne, tfEntryTwo, tfEntryThree;
    var buttonSpace = (Ti.Gesture.orientation != 1) ? 60 : 30;
    
    var labelField = [];
    var valueField = [];
    
    var win = Ti.UI.currentWindow;
    
    //=== OBJECTS ===================================     
    var vwHeader = Ti.UI.createView({
        top: 0,
        height: 48,
        backgroundColor: '#576996'
    });
    
    var lblTitle = Ti.UI.createLabel({
        color: 'white',
        font: {
            fontSize: 18,
            fontWeight: 'bold',
            fontFamily: 'Arial'
        },
        minimumFontSize: 10,
        text: currExercise.Name,
        textAlign: 'center'
    });
    vwHeader.add(lblTitle);
    
    var btnSave = Ti.UI.createButton({
        title: 'Save'
    });
    setRightNav(btnSave);
    
    var pckrDate = Ti.UI.createPicker({
        type: Ti.UI.PICKER_TYPE_DATE,
        height: 200,
        bottom: 0,
        value: defaultDate
    });
    
    //=== FUNCTIONS =================================   
    function createLabel(text, left, top){
        return Ti.UI.createLabel({
            color: 'white',
            font: {
                fontSize: 14,
                fontFamily: 'Arial'
            },
            top: top,
            left: left,
            width: 75,
            height: 15,
            text: text
        });
    }
    
    function createTextField(left, top){
        return Ti.UI.createTextField({
            top: top,
            left: left,
            width: 60,
            height: 30,
            borderStyle: Titanium.UI.INPUT_BORDERSTYLE_ROUNDED,
            keyboardType: Titanium.UI.KEYBOARD_NUMBERS_PUNCTUATION,
            autocapitalization: Titanium.UI.TEXT_AUTOCAPITALIZATION_NONE,
            returnKeyType: Titanium.UI.RETURNKEY_DONE
        });
    }
    
    function leftValues(containerWidth, numButtons, buttonWidth, buttonSpacer){
        var padding = containerWidth -
        ((numButtons * buttonWidth) + (buttonSpacer * (numButtons - 1)));
        var lefts = [];
        for (var i = 0; i < numButtons; i++) {
            var thisLeft = padding / 2 +
            (buttonWidth * (i)) +
            (buttonSpacer * (i));
            lefts[i] = thisLeft;
        }
        return lefts;
    }
    
    function setView(){
        labelField = (currLogTypeID == 1) ? ['Weight:', 'Reps:'] : (currLogTypeID == 2) ? ['Duration:', 'Distance:', 'Calories:'] : ['Reps'];
        var lefts = leftValues(laf.window.percentToPixels(100), labelField.length, 70, buttonSpace);
        
        for (var labelFieldItr = 0, labelFieldLen = labelField.length; labelFieldItr < labelFieldLen; labelFieldItr++) {
            vwMain.add(createLabel(labelField[labelFieldItr], lefts[labelFieldItr], 55));
        }
        
        vwMain.add(tfEntryOne = createTextField(lefts[0], 80));
        if (currLogTypeID == 1 || currLogTypeID == 2) {
            vwMain.add(tfEntryTwo = createTextField(lefts[1], 80));
        }
        if (currLogTypeID == 2) {
            vwMain.add(tfEntryThree = createTextField(lefts[2], 80));
        }
        
        switch (currLogTypeID) {
            case 1:
                tfEntryOne.value = currHistory.Weight;
                tfEntryTwo.value = currHistory.Reps;
                break;
            case 2:
                tfEntryOne.value = currHistory.Duration;
                tfEntryTwo.value = currHistory.Distance;
                tfEntryThree.value = currHistory.Calories;
                break;
            case 3:
                tfEntryOne.value = currHistory.Reps;
                break;
        }
    }
    
    //=== EVENT =====================================
    
    
    //=== DISPLAY ===================================
    win.add(vwHeader);
    win.add(pckrDate);
    win.backgroundColor = 'black';
    win.opacity = 0.85;
    
    setView();
    
};
